#ifndef BASEDIALOG_H_
#define BASEDIALOG_H_

#include "basewindow.h"
/**
	_CAOx[XNX
*/
namespace MIE {

class BaseDialog : public BaseWindow {
protected:
	enum {
		CHILD_MAX_NUM = 8 // qEBhE̍ő吔
	};
	bool isAlive_;
	HWND parent_;
	const HINSTANCE hInst_;
	BaseDialog *child_[CHILD_MAX_NUM]; // q_CAO
	int childNum_;
	int resourceId_;
public:
	/**
		RXgN^
	*/
	BaseDialog()
		: isAlive_(false)
		, parent_(0)
		, hInst_((HINSTANCE)GetModuleHandle(0))
		, childNum_(0)
		, resourceId_(0)
	{
		memset(child_, 0, sizeof(child_));
	}
	/**
		_CAO
		@param parent [in] enh
		@param resourceId [in] \[Xʎq
	*/
	virtual bool create(HWND parent, int resourceId)
	{
		if (isAlive_) return false;

		HWND hWnd;

		hWnd = CreateDialogParam(hInst_
						, MAKEINTRESOURCE(resourceId)
						, parent, (DLGPROC)MIE::BaseWindow::WindowMapProc, (LONG)this);
		if (hWnd == 0) return false;
		BaseWindow::attach(hWnd);
		isAlive_ = true;
		resourceId_ = resourceId;
		return true;
	}

	/**
		q_CAOƂĒǉ
		@param child [in] _CAO
	*/
	bool appendByChild(BaseDialog *child)
	{
		if (childNum_ == CHILD_MAX_NUM) return false;
		child_[childNum_] = child;
		childNum_++;
		return true;
	}
	/*
		Ă邩ۂ
	*/
	inline bool isAlive() const { return isAlive_; }

	/*
		nꂽbZ[Ŵ̂珈
		@param msg [in/out] bZ[W
		@retval true bZ[W
		@retval false ĂȂ
	*/
	inline bool processIfDialogMessage(MSG *msg)
	{
		if (!isAlive_) return false;
		if (IsDialogMessage(hWnd_, msg)) return true;

		for (int i = 0; i < childNum_; i++) {
			if (IsDialogMessage(child_[i]->hWnd_, msg)) {
				return true;
			}
		}
		return false;
	}

	/*
		I
	*/
	void destroy() {
		if (!isAlive_) return;
		isAlive_ = false;
		DestroyWindow(hWnd_);
	}
};

} // end of namespace

#endif // BASEDIALOG_H_
