#ifndef BASEWINDOW_H_
#define BASEWINDOW_H_

#include "windowhandle.h"

/**
	@file basewindow.h
	@brief EBhEx[XNX
	@author $Author: mitsunari $
	@version $Revision: 1.1.1.1 $
	@date $Date: 2005/01/20 01:42:22 $
*/
namespace MIE {

class BaseWindow : public WindowHandle {
protected:

	WNDPROC oldWndProc_; // EBhEvV[WAhX
	bool isDialog_; // _CAOۂ

public:
	/**
		RXgN^
	*/
	BaseWindow()
		: oldWndProc_(0)
		, isDialog_(false)
	{
	}

	/**
		fXgN^
	*/
	~BaseWindow() {}

private:
	static inline const char *getEntry() { return "BaseWindow"; }

public:
	/**
		bZ[WU蕪EBhEvV[W
	*/
	static LRESULT CALLBACK WindowMapProc(
				HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		BaseWindow *base;

		base = (BaseWindow*)GetProp(hWnd, getEntry());

		if (base == 0) { // Ȃ猋ѕts
			if ((msg == WM_CREATE) || (msg == WM_NCCREATE)) {
				base = (BaseWindow*)((LPCREATESTRUCT)lParam)->lpCreateParams;
			} else if (msg == WM_INITDIALOG) {
				base = (BaseWindow*)lParam;
			}
			if (base) base->hWnd_ = hWnd; // WM_CREATEŎg悤ɐݒ肵Ă
		}

		if (base) {
			LRESULT ret = 0;

			ret = base->wndProc(hWnd, msg, wParam, lParam);

			// WM_DESTROY ŃEBhEBaseWindow؂藣
			if (msg == WM_DESTROY) {
				base->detach();
			}
			return ret;
		}
		if (GetWindowLong(hWnd, DWL_DLGPROC)) return FALSE;
		// ftHg̃EBhEvV[WĂ
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}

	/**
		EBhEnhBaseWindowѕt
		@param hWnd [in] EBhEnh
	*/
	bool attach(HWND hWnd)
	{
		if (hWnd == 0) return false;
		hWnd_ = hWnd;

		int idx;
		int currProc = GetWindowLong(hWnd_, DWL_DLGPROC);
		if (currProc) {
			// _CAO
			isDialog_ = true;
			idx = DWL_DLGPROC;
		} else {
			// łȂ΃EBhE
			isDialog_ = false;
			idx = GWL_WNDPROC;
			currProc = GetWindowLong(hWnd_, idx);
			if (currProc == 0) return false;
		}

		// EBhEnhɂ̃CX^Xo^
		SetProp(hWnd_, getEntry(), (HANDLE)this);

		// EBhEvV[Wu
		if (currProc != (int)WindowMapProc) {
			oldWndProc_ = (WNDPROC)SetWindowLong(hWnd_, idx, (LONG)WindowMapProc);
		}
		return true;
	}

	/**
		EBhEnhBaseWindow؂藣
	*/
	bool detach()
	{
		if (hWnd_ == 0) return false;
		// vV[WuĂȂ؂藣
		if (oldWndProc_) {
			int idx = (isDialog_) ? DWL_DLGPROC : GWL_WNDPROC;
			SetWindowLong(hWnd_, idx, (LONG)oldWndProc_);
		}
		// CX^X菜
		RemoveProp(hWnd_, getEntry());
		return true;
	}

	/**
		EBhEL
	*/
	inline void beVisible(bool isEnable = true) const
	{
		ShowWindow(hWnd_, isEnable ? SW_SHOW : SW_HIDE);
	}

	/**
		EBhEL
	*/
	inline bool isVisible() const
	{
		return (IsWindowVisible(hWnd_) != 0);
	}

	/**
		I[o[Ch\ȃEBhEvV[W
	*/
	virtual LRESULT wndProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		// TuNXĂꍇ͌̃EBhEvV[WĂ
		if (oldWndProc_) {
			return CallWindowProc(oldWndProc_, hWnd, msg, wParam, lParam);
		}
		if (isDialog_) return FALSE;
		// łȂꍇ̓ftHg̃EBhEvV[WĂ
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
};

} // end of namespace

#endif // BASEWINDOW_H_
