#ifndef MEMORY_BITMAP_H_
#define MEMORY_BITMAP_H_

/**
	@file memorybitmap.h
	@brief rbg}bvNX
	@author $Author: mitsunari $
	@version $Revision: 1.1.1.1 $
	@date $Date: 2005/01/20 01:42:22 $
*/
namespace MIE {

class MemoryBitmap {
private:
	int leftAdj_; //!< EBhEɑ΂鑊Έʒu
	int topAdj_; //!< EBhEɑ΂鑊Έʒu
	int width_; //!< 
	int height_; //!< c
	int viewWidth_; //!< 鉡
	int viewHeight_; //!< c

	// for draw
	void *addr_;
	HDC vramDC_;
	HBITMAP vramDIB_;
	int left_;
	int top_; // VRAM(left, top)`悷

public:

	/**
		RXgN^
	*/
	MemoryBitmap()
		: width_(0)
		, height_(0)
		, vramDC_(0)
		, vramDIB_(0)
		, left_(0)
		, top_(0)
		, leftAdj_(0)
		, topAdj_(0)
	{
	}

	/**
		fXgN^
	*/
	~MemoryBitmap()
	{
	}
	/**
		rbg}bv(DIB)̍쐬
		@param hWnd [in] EBhEnh
		@param left [in] xW
		@param top [in] yW
		@param width [in] 
		@param height [in] c
		@param bytePerPixel [in] sNZ̑傫
	*/
	bool create(HWND hWnd, int left, int top, int width, int height, int bytePerPixel)
	{
		HDC hdc = GetDC(hWnd);
		vramDC_ = CreateCompatibleDC(hdc);

		BITMAPINFOHEADER DIB;
		memset(&DIB, 0, sizeof(DIB));
		DIB.biSize = sizeof(BITMAPINFOHEADER);
		DIB.biWidth = width;
		DIB.biHeight = -height; // 琔̂ŕ̓}CiX
		DIB.biPlanes = 1;
		DIB.biBitCount = (WORD)(bytePerPixel * 8);
		vramDIB_ = CreateDIBSection(vramDC_, (BITMAPINFO *)&DIB,
									DIB_RGB_COLORS, &addr_, NULL, 0);

		if (vramDIB_ == 0) {
			DeleteDC(vramDC_);
			ReleaseDC(hWnd, hdc);
			vramDC_ = 0;
			addr_ = 0;
			return false;
		}
		width_ = width;
		height_ = height;
		leftAdj_ = left;
		topAdj_ = top;
		viewWidth_ = width;
		viewHeight_ = height;

		SelectObject(vramDC_, vramDIB_);

		// rbg}bṽNA
		PatBlt(vramDC_, 0, 0, width, height, WHITENESS);//BLACKNESS);
		ReleaseDC(hWnd, hdc);
		return true;
	}

	// ANZbT
	/** VRAMAhX擾 */
	inline void *getAddr() const { return addr_; }

	/** ʒu擾 */
	inline int getLeft() const { return left_; }

	/** cʒu擾 */
	inline int getTop() const { return top_; }

	/** 擾 */
	inline int getWidth() const { return width_; }

	/** c擾 */
	inline int getHeight() const { return height_; }

	/**
		鉡ݒ
		@param width [in] 
		@return ݒ̒l
	*/
	inline int setViewWidth(int width)
	{
		if (width < 0) {
			width = 0;
		} else if (width > width_) {
			width = width_;
		}
		viewWidth_ = width;
		return width;
	}
	/**
		cݒ
		@param height [in] c
		@return ݒ̒l
	*/
	inline int setViewHeight(int height)
	{
		if (height < 0) {
			height = 0;
		} else if (height > height_) {
			height = height_;
		}
		viewHeight_ = height;
		return height;
	}
	
	/**
		ʒuݒ
		@param left [in] ʒu
		@param isRelative [in] ΐݒ
		@return ݒ̒l
	*/
	inline int setLeft(int left, bool isRelative = false)
	{
		if (isRelative) {
			left += left_;
		}
		if (left < 0) left = 0;
		if (left + viewWidth_ > width_) left = width_ - viewWidth_;
		left_ = left;
		return left;
	}
	
	/**
		cʒuݒ
		@param top [in] cʒu
		@param isRelative [in] ΐݒ
		@return ݒ̒l
	*/
	inline int setTop(int top, bool isRelative = false)
	{
		if (isRelative) {
			top += top_;
		}
		if (top < 0) top = 0;
		if (top + viewHeight_ > height_) top = height_ - viewHeight_;
		top_ = top;
		return top;
	}

	/**
		rbg}bv̍폜
	*/
	bool destroy()
	{
		if (vramDIB_ == 0) return true;
		addr_ = 0;
		width_ = height_ = 0;
		left_ = top_ = 0;
		DeleteObject(vramDIB_);
		DeleteDC(vramDC_);
		vramDIB_ = 0;
		vramDC_ = 0;
		return true;
	}

	/**
		rbg}bv]
		@param hdc [in] BeginPaint̕Ԃl
	*/
	inline void onPaint(HDC hdc)
	{
		if (vramDC_ == 0) return;
		BitBlt(hdc, // ]
			leftAdj_, topAdj_,
			width_,
			height_,
			vramDC_, // ]
			left_, top_, SRCCOPY);
	}
};

} // end of namespace

#endif /* MEMORY_BITMAP_H_ */
