#ifndef MIE_CONFIGFILE_H_
#define MIE_CONFIGFILE_H_
/*!
	Avp[^̑ޔE
	@version $Revision: 1.11 $
	@date $Date: 2007/06/22 02:18:25 $
*/

#include <string>
#include <map>
#include <fstream>
#include <algorithm>
#include <stdlib.h>

#ifdef _MSC_VER
#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")
#endif

namespace MIE {

/* keyvaluẽyA */
struct KeyTable : private std::map<std::string, std::string> {
public:
	/*!
		keyɑΉvalue擾
		@param keyTbl [in] e[u
		@param key [in] 
		@retval 0 ݂Ȃ
		@retval !0 keyɑΉvalueւ̃|C^
	*/
	const char *getString(const std::string& key) const
	{
		const_iterator itr = find(key);
		return itr != end() ? itr->second.c_str() : 0;
	}

	/*!
		keyɑΉvalue𐔒lƂĎ擾
		@param keyTbl [in] e[u
		@param key [in] 
		@param value [out] keyɑΉ鐔l
		@retval true key݂
		@retval false key݂Ȃ
	*/
	bool getInteger(const std::string& key, int *value) const
	{
		const char *ret = getString(key);
		if (ret) {
			*value = atoi(ret);
			return true;
		} else {
			return false;
		}
	}

	/*!
		keyǉ
		key݂ΒǉȂ
	*/
	bool set(const std::string& key, const std::string& value)
	{
		iterator itr = find(key);
		if (itr == end()) {
			(*this)[key] = value;
			return true;
		} else {
			return false;
		}
	}
};

/*!
	init@CANZXNX
	@note
	RtBOt@CtH[}bg

	[section1]
	key1=value1
	key2=value2

	[section2]
	key3=value3
	...

	擪#̓Rg
	[]̓Gg[\(K݂邱)
	s͖
	=l
	=܂܂Ȃ
	l͉s܂܂Ȃ
	=̑OɃXy[XȂ
	Rgł͂Ȃ=Ȃ΃G[
	ÕZNVΒǉ
	ZNVɓOkey΍ŏɒ`ꂽ̂L
*/
class ConfigFile {
private:
	/* sectionKeyTablẽyA */
	typedef std::map<std::string, KeyTable> SectionTable;

	SectionTable sectionTbl_;
	const KeyTable *get(const std::string& section) const
	{
		SectionTable::const_iterator itr = sectionTbl_.find(section);
		if (itr == sectionTbl_.end()) {
			return 0;
		} else {
			return &(itr->second);
		}
	}
public:
	static inline std::string GetExecPath()
	{
#if defined(_MSC_VER)
		char path[MAX_PATH];
		if (GetModuleFileName(NULL, path, sizeof(path))) {
			if (PathRemoveFileSpec(path)) {
				PathAddBackslash(path);
				return std::string(path);
			}
		}
		return std::string();
#elif defined(__linux__)
		char path[4096];
		int ret = readlink("/proc/self/exe", path, sizeof(path));
		if (ret != -1) {
			std::string chop(path);
			int pos = chop.find_last_of('/');
			if (pos > 0) {
				return chop.substr(0, pos + 1).c_str();	
			}
		}
		return std::string();
#else
	#error "implement GetExecPath"
#endif
	}
	/**
		t@CJ
		@param fileName [in] RtBOt@C
	*/
	bool open(const char *fileName, bool isRelative = true)
	{
		std::string path;
		if (isRelative) {
			path = GetExecPath();
		}
		path += fileName;
		std::ifstream ifs(path.c_str());
		if (!ifs) {
			fprintf(stderr, "can't open %s\n", path.c_str());
			return false;
		}

		std::string buf;
		KeyTable *keyTbl = 0; /* ǉׂe[u */
		while (std::getline(ifs, buf)) {
			int len = buf.size();
	#ifndef WIN32
			/* remove CR(for Linux) */
			if (buf[len - 1] == '\r') {
				buf[len - 1] = '\0';
				len--;
			}
	#endif
			if (buf[0] == '#' || buf[0] == '\0') {
				/* s܂'#'Ŏn܂΃Rg */
				continue;
			}

			/* [section]Ƃ`̕񂾂ZNV̎n܂ */
			if (len > 2 && buf[0] == '[' && buf[len - 1] == ']') {
				/*
					[]ZNVɑ΂keyTblԂ
				*/
				keyTbl = &(sectionTbl_[std::string(&buf[1], len - 2)]);
				continue;
			}
			if (keyTbl == 0) {
				/* ZNVŎn܂ĂȂ΃G[ */
				return false;
			}
			/* key̒T */
			std::string::size_type pos = buf.find_first_of('=');
			if (pos == std::string::npos) {
				/* '='Ȃ΃G[ */
				return false;
			}
			/*
				l̐ݒ
				[0, pos)key
				[pos + 1, len)value
			*/
	//printf(":::key=%s, val=%s\n", std::string(&buf[0], pos).c_str(), std::string(&buf[pos + 1], len - pos - 1).c_str());
			keyTbl->set(std::string(&buf[0], pos), std::string(&buf[pos + 1], len - pos - 1));
		}
		return true;
	}

	/*!
		l擾
		@param value [out] l
		@param section [in] ZNV
		@param key [in] 
	*/
	bool get(std::string& value, const char *section, const char *key) const
	{
		const KeyTable *keyTbl = get(section);
		if (keyTbl) {
			const char *v = keyTbl->getString(key);
			if (v) {
				value = v;
				return true;
			}
		}
		return false;
	}
	/*!
		l擾
		@param section [in] ZNV
		@param key [in] 
		@param value [out] l(valueLenmۂĂ邱)
		@param valueLen [in] ܂ő咷(byte)
	*/
	bool get(const char *section, const char *key, char *value, int valueLen) const
	{
		std::string tmp;
		if (get(tmp, section, key)) {
			if (static_cast<int>(tmp.size()) < valueLen) {
				strcpy(value, tmp.c_str());
				return true;
			}
		}
		return false;
	}
	/*!
		l擾
		@param section [in] ZNV
		@param key [in] 
		@param value [out] l
	*/
	bool get(const char *section, const char *key, int *value) const
	{
		char buf[32];
		if (get(section, key, buf, sizeof(buf))) {
			*value = atoi(buf);
			return true;
		} else {
			return false;
		}
	}
};

} // end of namespace

#endif /* MIE_CONFIGFILE_H_ */
