/*
	ȈՃEBhE̎ for Windows
	@author $Author: mitsunari $
	@version $Revision: 1.1.1.1 $
	@date $Date: 2005/01/20 01:42:22 $
	@note QQQ:I͖wǖ
*/
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <memory.h>
#include <signal.h>
#include <sys/time.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/Xatom.h>

#include "mie_thread.h"
#include "mie_graphic.h"

#ifdef NDEBG
const int debug = 0;
#else
const int debug = 1;
#endif


using namespace MIE;

class CanvasLinux;

/*
	荞݃nhɃ[Uf[^nȂ̂globalɂ
	ȂƂȂ
*/
const void *s_timerData;
CanvasLinux *s_canvas;

inline CanvasLinux* toHandle(void *data)
{
	return reinterpret_cast<CanvasLinux*>(data);
}

#define GET_RGB32(R, G, B) (((R) << 16) | ((G) << 8) | (B))
#define GET_RGB16(R, G, B) (((R) << 11) | ((G) << 5) | (B))

/**
    32bitRGBA16bitRGB(5:6:5)ւ̕ϊ
    @param dest [out] oVRAMAhX
    @param src [in] VRAMAhX
    @param width [in] 
    @param height [in] c
*/
void Convert32bppTo16bpp(unsigned char *dest, const unsigned char *src, int width, int height)
{
    for (int y = 0; y < height; y++) {
        for (int x = 0; x < width; x++) {
            unsigned int R, G, B, col;
            B = src[0];
            G = src[1];
            R = src[2];
            col = GET_RGB16(R >> 3, G >> 2, B >> 3);
            src += 4;
            dest[0] = (unsigned char)col;
            dest[1] = (unsigned char)(col >> 8);
            dest += 2;
        }
    }
}

/**
    16bitRGB(5:6:5)32bitRGBAւ̕ϊ
    @param dest [out] oVRAMAhX
    @param src [in] VRAMAhX
    @param width [in] 
    @param height [in] c
*/
void Convert16bppTo32bpp(unsigned char *dest, const unsigned char *src, int width, int height)
{
    for (int y = 0; y < height; y++) {
        for (int x = 0; x < width; x++) {
            unsigned int R, G, B, col;
            col = src[0] | (src[1] << 8);
            src += 2;
            R = col >> 11;
            G = (col >> 5) & 0x3F;
            B = col & 0x1F;
            dest[0] = (B * 255) / 31;   /* 31255ɑΉ悤 */
            dest[1] = ((G * 255) / 63);
            dest[2] = ((R * 255) / 31);
            dest[3] = 0;
            dest += 4;
        }
    }
}

/**
	ȈՃEBhENX
*/
class CanvasLinux {
private:
	enum {
		bytePerPixel = 4
	};

	// r
	MIE::CriticalSection cs_;

// for common
	int width_;
	int height_;
	bool is16bpp_; /* X16bpp */
	Canvas::EventHandler eventHandler_;
	char *vramAdr_;
	const void *data_; //userData
	bool isCalledDestroy_; /* ICxgĂ΂ꂽ */
// for X
	Display *d_;
	Window w_;
	GC gc_;
	XEvent ev_;
	XGCValues gcVal_;
	bool isTrueColor_;
	XImage *xim_;
    Atom wmDeleteWindow_;

	unsigned int black_;
	unsigned int white_;
	unsigned int rMax_;
	unsigned int gMax_;
	unsigned int bMax_;
	int rOffset_;
	int gOffset_;
	int bOffset_;
	int isLSBfirst_; /* (local->xim[0]->byte_order == LSBFirst)LEBE */

	// for timer
	int intervalMsec_;
	const void* timerData_;
	bool isOnce_;
	struct sigaction oldAction_;
	struct itimerval oldValue_;

public:
	CanvasLinux()
		: width_(0)
		, height_(0)
		, is16bpp_(false)

		, intervalMsec_(0)
		, timerData_(0)
		, isOnce_(false)
	{
	}

	// ʃTCYANZbT
	// @return TCY(sNZl)
	int getVramWidth() const { return width_; }
	int getVramHeight() const { return height_; }
	char* getVramAddress() const { return vramAdr_; }
	/*
		`惂[h̎擾
	*/
	bool is16bpp()
	{
		XImage *xim;
		int bytePerPixel;
		bool ret = false;

		xim = XGetImage(d_, w_, 0, 0, 1, 1, AllPlanes, ZPixmap);
		assert(xim);

		bytePerPixel = xim->bits_per_pixel / 8;
		if (isTrueColor_) {
			if (bytePerPixel == 4 && rOffset_ == 16 && gOffset_ == 8 && bOffset_ == 0) {
				/* 32bit color */
				/* through */
			} else
			if (bytePerPixel == 2 && rOffset_ == 11 && gOffset_ == 5 && bOffset_ == 0) {
				/* 16bit color */
				ret = true;
			}
		}
		XDestroyImage(xim);
		return ret;
	}

	/*
		OSˑȃf[^̊J
	*/
	void localDestroy()
	{
		XFreeGC(d_, gc_);
		XDestroyImage(xim_);
		XDestroyWindow(d_, w_);
		XFlush(d_);
		XCloseDisplay(d_);
		if (is16bpp_) {
			delete[] vramAdr_;
			vramAdr_ = 0;
		}
	}

	/**
		`̈ɑ΂čXVv𑗂
	*/
	int sendFlushMessage()
	{
		if (vramAdr_ == 0) return Canvas::ERR_WINDOW;
		if (is16bpp_) {
			// ʃ[hϊ
			Convert32bppTo16bpp(reinterpret_cast<unsigned char*>(xim_->data), reinterpret_cast<unsigned char*>(vramAdr_), width_, height_);
		}

		XPutImage(d_, w_, gc_, xim_, 0, 0, 0, 0, width_, height_);
		return Canvas::NOERR;
	}

	/**
		EBhE悤ɖ߂𓊂
		@return G[ԍԂ
	*/
	int requestClosure()
	{
		isCalledDestroy_ = true;
		return Canvas::NOERR;
	}

	/*
		WindowvV[Wǂ
		Cxg擾(Cxg܂ŃubN)
	*/
	Canvas::EventType waitEvent(Canvas::EventInfo *event)
	{
	RETRY:
		if (isCalledDestroy_ == 1) {
			isCalledDestroy_ = 0;
			return Canvas::DESTROY;
		}
		XNextEvent(d_, &ev_);
		switch (ev_.type) {
		case ButtonPress:
			event->mx = ev_.xbutton.x;
			event->my = ev_.xbutton.y;
			event->sw = Canvas::Button(ev_.xbutton.button);
			return Canvas::MOUSE_PRESS;
		case ButtonRelease:
			event->mx = ev_.xbutton.x;
			event->my = ev_.xbutton.y;
			event->sw = Canvas::Button(ev_.xbutton.button);
			return Canvas::MOUSE_RELEASE;
		case KeyPress:
			{
				char c;
				KeySym key;
				XLookupString((XKeyEvent *)&ev_, &c, 1, &key, NULL);
				switch (key) {
				case XK_Delete:
					break;
				default:
					event->key = (!IsCursorKey(key) && !IsFunctionKey(key)) ? c : 0;
					break;
				}
				return Canvas::KEY_PRESS;
			}
		case Expose:
			sendFlushMessage();
			break;
		case DestroyNotify:
			if (debug) fprintf(stderr, "Receive DestroyNotify\n");
			isCalledDestroy_ = 1;
			return Canvas::DESTROY;
		case ClientMessage: /* ~{^̃Cxg */
			if (ev_.xclient.data.l[0] == (int)wmDeleteWindow_) {
				isCalledDestroy_ = 1;
				return Canvas::DESTROY;
			}
			break;
		default:
			break;
		}
		goto RETRY;
	}

	/**
		EBhE̐ƃCxgnh̓o^
		@param width [in] EBhẼTCY(悱)
		@param height [in] EBhẼTCY()
		@param title [in] EBhẼ^Cg
		@param eventHandler_ [in] Cxgnh
		@param data [in] [Uf[^(Canvas::OpenWindowŎw肳ꂽf[^)
		@return G[ԍԂ

		@note umode  PXGRF_GetVramAddress Ŏ擾ł鉼zVRAMւ̉摜[h(F)w肷B
		\EChẺ摜[h(F)ł͂Ȃ̂ŒӂB
		eventHandler_ ̓Cxg閈ɌĂ΂R[obN֐

		`Ɋւ鏈́ACxgnh̒ Canvas::CREATE Ƃ
		Canvas::GetGraphicHandle() ɂ擾nhɑ΂čsB
	*/

	int init(int width, int height, const char *title, Canvas::EventHandler eventHandler, const void* data)
	{
		width_ = width;
		height_ = height;
		eventHandler_ = eventHandler;
		data_ = data;

		Visual *vis;
		XVisualInfo vinfo;
		int depth;
		int screen, rootWin;

		d_ = XOpenDisplay(NULL);
		if (d_ == 0) {
			return Canvas::ERR_WINDOW;
		}
		isTrueColor_ = false;

		screen = DefaultScreen(d_);
		rootWin = RootWindow(d_, 0);

		vis = DefaultVisual(d_, screen);
		depth = DefaultDepth(d_, screen);

		/* ܂PseudoColorĎTrueColor */

		if (vis->c_class != TrueColor && XMatchVisualInfo(d_, screen, 8, PseudoColor, &vinfo)) {
			if (debug) fprintf(stderr, "not support 8bit color\n");
			return Canvas::ERR_WINDOW;
		} else if (vis->c_class != PseudoColor) {
			int i;
			if (!XMatchVisualInfo(d_, screen, depth, TrueColor, &vinfo)) {
				fprintf(stderr, "can't find TrueColor for depth %d.\n", depth);
				return Canvas::ERR_WINDOW;
			}
			isTrueColor_ = true;
			rMax_ = vinfo.red_mask;
			for (i = 0; (rMax_ & 1) == 0; i++) rMax_ >>= 1;
			rOffset_ = i;
			rMax_++;

			gMax_ = vinfo.green_mask;
			for (i = 0; (gMax_ & 1) == 0; i++) gMax_ >>= 1;
			gOffset_ = i;
			gMax_++;

			bMax_ = vinfo.blue_mask;
			for (i = 0; (bMax_ & 1) == 0; i++) bMax_ >>= 1;
			bOffset_ = i;
			bMax_++;

			black_ = 0;
			white_ = vinfo.blue_mask | vinfo.red_mask | vinfo.green_mask;
		} else {
			fprintf(stderr, "can'T find TrueColor nor PseudoColor class.\n");
			return Canvas::ERR_WINDOW;
		}

		w_ = XCreateSimpleWindow(d_, rootWin, 0, 0, width, height, 0, 0, 0);

		XStoreName(d_, w_, title);
		gcVal_.line_width = 1;
		gc_ = XCreateGC(d_, w_, GCLineWidth, &gcVal_);

		/* ~{^ŃEChEȂ */
		wmDeleteWindow_ = XInternAtom(d_, "WM_DELETE_WINDOW", False);
		XSetWMProtocols(d_, w_, &wmDeleteWindow_, 1);

		/* event set */
		XSelectInput(d_, w_, ExposureMask | VisibilityChangeMask
					 | ButtonPressMask | ButtonReleaseMask | KeyPressMask);
		//    | PointerMotionMask | Button1MotionMask | OwnerGrabButtonMask for simple event of mouse

		XMapWindow(d_, w_);
		XFlush(d_);

		/* window J܂ő҂ */
		{
			XEvent g_ev;
			do {
				XNextEvent(d_, &g_ev);
			} while (g_ev.type != VisibilityNotify);
		}

		/* clear screen */

		XSetForeground(d_, gc_, black_);
		XSetFunction(d_, gc_, GXcopy);
		XFillRectangle(d_, w_, gc_, 0, 0, width, height);
		XFlush(d_);

		is16bpp_ = is16bpp();
		if (debug) printf("screen mode=%s\n", is16bpp_ ? "16bpp" : "32bpp");

		// XXX: Window ʂ͂ݏoĂƂł (XGetImage => BadMatch)
		xim_ = XGetImage(d_, w_, 0, 0, width, height, AllPlanes, ZPixmap);
		if (xim_ == 0) {
			if (debug) fprintf(stderr, "Cannot create XImage\n");
			return Canvas::ERR_WINDOW;
		}
		isLSBfirst_ = (xim_->byte_order == LSBFirst);

		// ʃ[hɉVRAM
		if (is16bpp_) {
			vramAdr_ = new char [width * height * bytePerPixel];
		} else {
			vramAdr_ = xim_->data;
		}

		eventHandler_(Canvas::CREATE, 0, (void*)data);

		return Canvas::NOERR;
	}

	void callEventDestroy()
	{
		eventHandler_(Canvas::DESTROY, 0, const_cast<void*>(data_));
	}

	int messageLoop()
	{
		Canvas::EventType type;
		Canvas::EventInfo info;

		do {
			type = waitEvent(&info);
		} while ((eventHandler_(type, &info, const_cast<void*>(data_)) == 0) && !(type == Canvas::DESTROY));

		if (debug) fprintf(stderr, "exit message loop\n");

		// DestroyNotify  ClientMessage ŏIꍇ
		if (isCalledDestroy_) {
			isCalledDestroy_ = false;
			callEventDestroy();
		}
// QQQ
//		destroy();
		return Canvas::NOERR;
	}

	static void sigHandler(int)
	{
		CanvasLinux *canvas = s_canvas;
		assert(canvas);
		Canvas::EventInfo info;
		info.timerData = const_cast<void*>(s_timerData);
		canvas->eventHandler_(Canvas::TIMER, &info, const_cast<void*>(canvas->data_));
		if (canvas->isOnce_) {
			canvas->stopTimer();
		}
	}

	/**
		^C}[ݒ肷
		@param intervalMsec [in] 荞݊Ԋu(msec)
		@param timerData [in] ^C}[Cxgɓnf[^
		@param isOnce [in] x
	*/
	int startTimer(int intervalMsec, const void *timerData, bool isOnce)
	{
		intervalMsec_ = intervalMsec;
		timerData_ = timerData;

s_timerData = timerData;
s_canvas = this;

		isOnce_ = isOnce;

		struct sigaction act;
		struct itimerval val;
		memset(&act, 0, sizeof(act));
		act.sa_handler = sigHandler;
		sigaction(SIGALRM, &act, &oldAction_);

		val.it_value.tv_sec = intervalMsec / 1000;
		val.it_value.tv_usec = (intervalMsec % 1000) * 1000;
		val.it_interval.tv_sec = intervalMsec / 1000;
		val.it_interval.tv_usec = (intervalMsec % 1000) * 1000;
		setitimer(ITIMER_REAL, &val, &oldValue_);

		return 0;
	}

	/**
		^C}[~߂
	*/
	int stopTimer()
	{
		struct itimerval value;
		setitimer(ITIMER_REAL, &oldValue_, &value);
		sigaction(SIGALRM, &oldAction_, 0);
		return 0;
	}
};

void* Canvas::create()
{
	return reinterpret_cast<void*>(new CanvasLinux());
}

void Canvas::destroy(void *hdl)
{
	delete reinterpret_cast<CanvasLinux*>(hdl);
}

/**
	EBhE̐ƃCxgnh̓o^
	@param width [in] EBhẺ
	@param height [in] EBhȄc
	@param title [in] EBhẼ^Cg
	@param eventHandler [in] Cxgnh
	@param data [in] [Uf[^(open)
	@return G[ԍԂ

	@note eventHandler ̓Cxg閈ɌĂ΂R[obN֐
*/
int Canvas::open(
	int width,
	int height,
	const char *title,
	EventHandler eventHandler,
	const void* data)
{
	CanvasLinux *canvas = toHandle(hdl_);
	return canvas->init(width, height, title, eventHandler, data);
}

/**
	bZ[W󂯁ACxgnhɓnBJԂB
	eventHandler_ 0ȊO̒lԂ邢͊ȎŃEBhE
	j܂ŃubNB


	ȈF
	Cxgnh Canvas::DESTROY 𓊂A
	hdl ɑΉ\̂JB

	Canvas::RequestClosure Ă΂ƏLIoăubN𔲂B
*/
int Canvas::messageLoop()
{
	CanvasLinux *canvas = toHandle(hdl_);
	return canvas->messageLoop();

}


/**
	EBhE悤ɖ߂𓊂
	@return G[ԍԂ
*/
int Canvas::requestClosure()
{
	CanvasLinux *canvas = toHandle(hdl_);

	canvas->callEventDestroy();
	return NOERR;
}

/**
	`̈ɑ΂čXVv𑗂
*/
int Canvas::sendFlushMessage()
{
	CanvasLinux *canvas = toHandle(hdl_);
	canvas->sendFlushMessage();
	return NOERR;
}

char* Canvas::getVramAddress() const
{
	CanvasLinux *canvas = toHandle(hdl_);
	return canvas->getVramAddress();
}

/**
	^C}[ݒ肷
	@param intervalMsec [in] 荞݊Ԋu(msec)
	@param timerData [in] ^C}[Cxgɓnf[^
	@param isOnce [in] x
*/
int Canvas::startTimer(int intervalMsec, const void *timerData, bool isOnce)
{
	CanvasLinux *canvas = toHandle(hdl_);
	return canvas->startTimer(intervalMsec, timerData, isOnce);
}

/**
	^C}[~߂
*/
int Canvas::stopTimer()
{
	CanvasLinux *canvas = toHandle(hdl_);
	return canvas->stopTimer();
}

/**
	EBhE擾
*/
int Canvas::getVramWidth() const
{
	CanvasLinux *canvas = toHandle(hdl_);
	return canvas->getVramWidth();
}

/**
	EBhEc擾
*/
int Canvas::getVramHeight() const
{
	CanvasLinux *canvas = toHandle(hdl_);
	return canvas->getVramHeight();
}
