/*
	ȈՃEBhE̎ for Windows
	@author $Author: mitsunari $
	@version $Revision: 1.1.1.1 $
	@date $Date: 2005/01/20 01:42:22 $
*/
#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>

#include "mie_thread.h"
#include "mie_graphic.h"

using namespace MIE;

#define CLASS_NAME "mieCanvasClass"

class CanvasWin;

inline CanvasWin* toHandle(void *data)
{
	return reinterpret_cast<CanvasWin*>(data);
}

/**
	ȈՃEBhENX
*/
class CanvasWin {
private:
	enum {
		bytePerPixel = 4
	};

	// r
	CriticalSection cs_;

	HWND hWnd_; // g̃nh
	char *vramAdr_;

	const void* data_; // [Uf[^
	bool isCalledDestroy_; // IĂ΂ꂽ

	int width_;// 
	int height_; // c
	Canvas::EventHandler eventHandler_; // [U`̃vV[W

	// for draw
	HDC vramDC_;
	HBITMAP vramDIB_;

	// for timer
	int intervalMsec_;
	const void* timerData_;
	bool isOnce_;
	int timerId_;
public:
	CanvasWin()
		: hWnd_(0)
		, vramAdr_(0)
		, data_(0)
		, isCalledDestroy_(false)
		, width_(0)
		, height_(0)
		, eventHandler_(0)
		, vramDC_(0)
		, vramDIB_(0)
		, intervalMsec_(0)
		, timerData_(0)
		, isOnce_(false)
		, timerId_(0)
	{
	}

	~CanvasWin()
	{
		destroyVram();
	}

	bool init(int width, int height, const char* title, Canvas::EventHandler eventHandler, const void* data)
	{
		width_ = width;
		height_ = height;
		eventHandler_ = eventHandler;
		data_ = data;

		const HWND parent = HWND_DESKTOP; // e
		WNDCLASSEX wc;

		wc.style = 0;
		wc.lpfnWndProc = CanvasWin::wndProc;
		wc.cbClsExtra = wc.cbWndExtra = 0;
		wc.cbSize = sizeof(WNDCLASSEX);
		wc.hInstance = (HINSTANCE)GetWindowLong(parent, GWL_HINSTANCE);
		wc.hIcon = NULL;
		wc.hIconSm = NULL;
		wc.hCursor = NULL;
		wc.hbrBackground = NULL; // BeginPaint ŏȂ NULL ɂ
		wc.lpszMenuName = NULL;
		wc.lpszClassName = CLASS_NAME;

		DWORD style = WS_VISIBLE | WS_BORDER | WS_SYSMENU | WS_MINIMIZEBOX;
		DWORD exStyle = 0;

		if (RegisterClassEx(&wc)) {
			hWnd_ = CreateWindowEx(exStyle,
					CLASS_NAME, title,
					style,
					CW_USEDEFAULT, CW_USEDEFAULT,
					width, height,
					parent,
					NULL, wc.hInstance, (LPVOID)this);
		}
		return hWnd_ != 0;
	}

	void* createCanvas(int width, int height)
	{
		void* addr;
		HDC hdc = GetDC(hWnd_);
		BITMAPINFOHEADER DIB;

		if (vramDC_) goto ERR_EXIT;

		// rbg}bv(DIB)̍쐬
		vramDC_ = CreateCompatibleDC(hdc);
		memset(&DIB, 0, sizeof(DIB));
		DIB.biSize = sizeof(BITMAPINFOHEADER);
		DIB.biWidth = width;
		DIB.biHeight = - height; // 琔̂ŕ̓}CiX
		DIB.biPlanes = 1;
		DIB.biBitCount = (WORD)(bytePerPixel * 8);
		vramDIB_ = CreateDIBSection(vramDC_, (BITMAPINFO *)&DIB,
										DIB_RGB_COLORS, &addr, NULL, 0);

		if (vramDIB_ == 0) goto ERR_EXIT;
		// rbg}bṽNA
		SelectObject(vramDC_, vramDIB_);
		PatBlt(vramDC_, 0, 0, width, height, BLACKNESS);
		ReleaseDC(hWnd_, hdc);

		return addr;

	ERR_EXIT:
		ReleaseDC(hWnd_, hdc);
		return 0;
	}

	/**
		[U`̃vV[WĂ
	*/
	void callEventHandler(Canvas::EventType type, const Canvas::EventInfo *info)
	{
		int ret = eventHandler_(type, info, const_cast<void*>(data_));
		if (ret != 0) {
			callEventDestroy();
		}
	}
	/**
		Iʒm(x)
		@retval true I
		@retval false łɌĂяoĂ
	*/
	bool callEventDestroy()
	{
		bool called = false;
		cs_.lock();

		if (isCalledDestroy_ == false) {
			isCalledDestroy_ = true;
			callEventHandler(Canvas::DESTROY, 0);
			called = true;
		}
		cs_.unlock();
		PostQuitMessage(0);
		return called;
	}

	/**
		qEBhEpVRAMj󂷂
	*/
	void destroyVram()
	{
		if (vramDC_ == 0) return;

		DeleteObject(vramDIB_);
		DeleteDC(vramDC_);
		vramDIB_ = 0;
		vramDC_ = 0;
	}

	// ĕ`(rect͍XVׂ͈)
	void redraw(HDC dc, const RECT& rect)
	{
		if (vramDC_ == 0) return;
		BitBlt(dc, // ]
				rect.left, rect.top,
				rect.right - rect.left,
				rect.bottom - rect.top,
				vramDC_, // ]
				rect.left,
				rect.top,
				SRCCOPY);
	}

	// ĕ`v
	void sendFlushMessage()
	{
		InvalidateRgn(hWnd_, NULL, FALSE);
	}

	void sendFlushMessage(int left, int top, int width, int height)
	{
		RECT rect = {left, top, width, height};
		InvalidateRect(hWnd_, &rect, FALSE);
	}

	// ʃTCYANZbT
	// @return TCY(sNZl)
	int getVramWidth() const { return width_; }
	int getVramHeight() const { return height_; }
	char *getVramAddress() const { return vramAdr_; }

	// qEBhẼvV[W
	static LRESULT CALLBACK wndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		CanvasWin *canvas;
		Canvas::EventInfo info;

		switch (msg) {
		case WM_CREATE:
			{

				// break 𔲂܂ł canvas->hWnd_ ͕sł
				SetWindowLong(hWnd, GWL_USERDATA, (DWORD)(((CREATESTRUCT*)lParam)->lpCreateParams));

				canvas = CanvasWin::getThis(hWnd);
				canvas->hWnd_ = hWnd; // lĂƏ WM_PAINT ł hWnd_ l͗L
				const int width = canvas->getVramWidth();
				const int height = canvas->getVramHeight();

				// 傫
				RECT WindowRect, ClientRect;
				int deltaWidth, deltaHeight;
				GetWindowRect(hWnd, &WindowRect);
				GetClientRect(hWnd, &ClientRect);
				deltaWidth = width - ClientRect.right;
				deltaHeight = height - ClientRect.bottom;
				MoveWindow(hWnd, WindowRect.left, WindowRect.top,
					width + deltaWidth, height + deltaHeight, TRUE);

				// ʐ
				canvas->vramAdr_ = (char*)canvas->createCanvas(width, height);
				if (canvas->vramAdr_ == 0) {
					PostQuitMessage(0);
					break;
				}

				ShowWindow(hWnd, SW_SHOW);
				UpdateWindow(hWnd);
			}
			break;

		case WM_PAINT:
			{
				canvas = CanvasWin::getThis(hWnd);
				PAINTSTRUCT ps;
				HDC dc = BeginPaint(hWnd, &ps);
				if (dc == NULL) break;
				canvas->redraw(dc, ps.rcPaint);
				EndPaint(hWnd, &ps);
			}
			break;

		// }EX
		case WM_LBUTTONDOWN:
		case WM_MBUTTONDOWN:
		case WM_RBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_MBUTTONUP:
		case WM_RBUTTONUP:
 			{
				canvas = CanvasWin::getThis(hWnd);

				Canvas::EventType type = Canvas::MOUSE_PRESS;
				switch (msg) {
				case WM_LBUTTONUP:
					type = Canvas::MOUSE_RELEASE;
					/* through */
				case WM_LBUTTONDOWN:
					info.sw = Canvas::MOUSE_LEFT;
					break;

				case WM_MBUTTONUP:
					type = Canvas::MOUSE_RELEASE;
					/* through */
				case WM_MBUTTONDOWN:
					info.sw = Canvas::MOUSE_MIDDLE;
					break;

				case WM_RBUTTONUP:
					type = Canvas::MOUSE_RELEASE;
					/* through */
				case WM_RBUTTONDOWN:
					info.sw = Canvas::MOUSE_RIGHT;
					break;
				}
				info.mx = LOWORD(lParam);
				info.my = HIWORD(lParam);
				canvas->callEventHandler(type, &info);
			}
			break;

		// L[{[h
		case WM_CHAR:
			info.key = wParam;
			canvas = CanvasWin::getThis(hWnd);
			canvas->callEventHandler(Canvas::KEY_PRESS, &info);
			break;

		case WM_DESTROY:
			canvas = CanvasWin::getThis(hWnd);
			canvas->callEventDestroy();
			break;
		case WM_TIMER:
			canvas = CanvasWin::getThis(hWnd);
			info.timerData = const_cast<void*>(canvas->timerData_);
			canvas->callEventHandler(Canvas::TIMER, &info);
			if (canvas->isOnce_) {
				canvas->stopTimer();
			}
			break;
		default:
			return DefWindowProc(hWnd, msg, wParam, lParam);
		}
		return 0;
	}

	/**
		^C}[ݒ肷
		@param intervalMsec [in] 荞݊Ԋu(msec)
		@param timerData [in] ^C}[Cxgɓnf[^
		@param isOnce [in] x
	*/
	int startTimer(int intervalMsec, const void *timerData, bool isOnce)
	{
		intervalMsec_ = intervalMsec;
		timerData_ = timerData;
		isOnce_ = isOnce;
		timerId_ = SetTimer(hWnd_, (UINT)timerData, intervalMsec, NULL);
		return 0;
	}

	/**
		^C}[~߂
	*/
	int stopTimer()
	{
		if (timerId_) {
			KillTimer(hWnd_, timerId_);
			timerId_ = 0;
		}
		return 0;
	}

private:
	// qEBhẼnhqEBhENXւ̃|C^擾
	static CanvasWin *getThis(HWND hWnd)
	{
		return (CanvasWin *)GetWindowLong(hWnd, GWL_USERDATA);
	}
};

void* Canvas::create()
{
	return reinterpret_cast<void*>(new CanvasWin());
}

void Canvas::destroy(void *hdl)
{
	delete reinterpret_cast<CanvasWin*>(hdl);
}

/**
	EBhE̐ƃCxgnh̓o^
	@param width [in] EBhẺ
	@param height [in] EBhȄc
	@param title [in] EBhẼ^Cg
	@param eventHandler [in] Cxgnh
	@param data [in] [Uf[^(open)
	@return G[ԍԂ

	@note eventHandler ̓Cxg閈ɌĂ΂R[obN֐
*/
int Canvas::open(
	int width,
	int height,
	const char *title,
	EventHandler eventHandler,
	const void* data)
{
	CanvasWin *canvas = toHandle(hdl_);
	return canvas->init(width, height, title, eventHandler, data);
}

/**
	bZ[W󂯂ăCxgnhɓn
	JԂ
	eventHandler0ȊO̒lԂ邢͊ȎŃEBhE
	j܂ŃubN

	ȈF
	CxgnhDESTROY𓊂

	requestClosureĂ΂ƏLIoăubN𔲂
*/
int Canvas::messageLoop()
{
	CanvasWin *canvas = toHandle(hdl_);

	// ŌĂ΂Ȃƃnh̐ĂȂ
	canvas->callEventHandler(CREATE, NULL);

	MSG message;
	while (GetMessage(&message, NULL, 0, 0)) {
		TranslateMessage(&message);
		DispatchMessage(&message);
	}
	canvas->callEventDestroy();
	return NOERR;
}

/**
	EBhE悤ɖ߂𓊂
	@return G[ԍԂ
*/
int Canvas::requestClosure()
{
	CanvasWin *canvas = toHandle(hdl_);

	canvas->callEventDestroy();
	return NOERR;
}

/**
	`̈ɑ΂čXVv𑗂
*/
int Canvas::sendFlushMessage()
{
	CanvasWin *canvas = toHandle(hdl_);
	canvas->sendFlushMessage();
	return NOERR;
}

char* Canvas::getVramAddress() const
{
	CanvasWin *canvas = toHandle(hdl_);
	return canvas->getVramAddress();
}

/**
	^C}[ݒ肷
	@param intervalMsec [in] 荞݊Ԋu(msec)
	@param timerData [in] ^C}[Cxgɓnf[^
	@param isOnce [in] x
*/
int Canvas::startTimer(int intervalMsec, const void *timerData, bool isOnce)
{
	CanvasWin *canvas = toHandle(hdl_);
	return canvas->startTimer(intervalMsec, timerData, isOnce);
}

/**
	^C}[~߂
*/
int Canvas::stopTimer()
{
	CanvasWin *canvas = toHandle(hdl_);
	return canvas->stopTimer();
}

/**
	EBhE擾
*/
int Canvas::getVramWidth() const
{
	CanvasWin *canvas = toHandle(hdl_);
	return canvas->getVramWidth();
}

/**
	EBhEc擾
*/
int Canvas::getVramHeight() const
{
	CanvasWin *canvas = toHandle(hdl_);
	return canvas->getVramHeight();
}
