#include "mie_socket.h"
#include <vector>
/*!
	@file mie_socket.cpp
	@brief \Pbg̊ȈՃNX
	@author $Author: shigeo $
	@version $Revision: 1.42 $
	@date $Date: 2007/08/25 10:05:30 $
*/

static bool s_isInit = false;

#ifdef _WIN32

//#define MIE_USE_PCAP
#ifdef MIE_USE_PCAP
	#pragma message("*** winpcap is necessary ***")
#endif

#include <iphlpapi.h>

#pragma comment(lib, "ws2_32.lib")
#pragma comment(lib, "iphlpapi.lib")
#pragma warning(disable : 4996) /* sscanf */

#ifdef MIE_USE_PCAP
	#include "pcap.h"
	extern "C" {
	#include <remote-ext.h> // for pcap-open()
	}
	#pragma comment(lib, "wpcap.lib")
#endif

bool MIE::Socket::initSystem()
{
	if (s_isInit) return true;

	WSADATA data;

	if (WSAStartup(MAKEWORD(2, 2), &data)) {
		return false;
	}

	s_isInit = true;
	return true;
}

bool MIE::Socket::termSystem()
{
	if (!s_isInit) return false;
	WSACleanup();
	s_isInit = false;
	return true;
}

/** MACAhX擾 */
bool MIE::IpAddress::getMacAddress(MacAddress& macAddress) const
{
	ULONG mac[2];
	unsigned char macAddr[6];
	ULONG len = 6;
	if (SendARP(address_.s_addr, 0, mac, &len) == 0) {
		const unsigned char *p = reinterpret_cast<const unsigned char*>(mac);
		for (int i = 0; i < 6; i++) {
			macAddr[i] = p[i];
		}
		macAddress.set(macAddr);
		return true;
	} else {
		/*
			staticɂȂ̂arpR}hŖ擾
		*/
		bool isOK = false;
		FILE *fp;
		char cmd[64];
		sprintf(cmd, "arp -a %s", toString());
		fp = _popen(cmd, "r");
		if (fp) {
			char buf[1024];
			/* skip 3 lines */
			for (int i = 0; i < 3; i++) {
				fgets(buf, sizeof(buf), fp);
			}
			fgets(buf, sizeof(buf), fp);
			char ip[32];
			unsigned int t[6];
			int n;
			n = sscanf(buf, "%s %02X-%02X-%02X-%02X-%02X-%2X", ip, &t[0],  &t[1],  &t[2],  &t[3],  &t[4],  &t[5]);
			if (n == 7 && strcmp(ip, toString()) == 0) {
				for (int i = 0; i < 6; i++) {
					macAddr[i] = static_cast<unsigned char>(t[i]);
				}
				macAddress.set(macAddr);
				isOK = true;
			}
			_pclose(fp);
		}
		return isOK;
	}
}

#ifdef MIE_USE_PCAP
bool MIE::Socket::getNetworkInterfaces(MIE::NetworkInterfaces& ifs)
{
	ULONG size = 0;
	int ret;

	ifs.clear();

	/* obt@TCY */
	ret = GetAdaptersInfo(0, &size);
	if (ret == ERROR_NO_DATA) {
		return true;
	}
	if (ret != ERROR_BUFFER_OVERFLOW) {
		return false;
	}

	/* mۂď擾 */
	std::vector<char> buf(size);
	IP_ADAPTER_INFO *info = reinterpret_cast<IP_ADAPTER_INFO*>(&buf[0]);
	memset(info, 0, size);
	ret = GetAdaptersInfo(info, &size);
	if (ret) {
		return false;
	}

	/* l̐ݒ */
	do {
		MIE::NetworkInterface curr;
		curr.index_ = info->Index;
		if (strlen(info->AdapterName) > sizeof(curr.name_)) {
			return false;
		}
		strcpy(curr.name_, info->AdapterName);
		if (strlen(info->Description) > sizeof(curr.description_)) {
			return false;
		}
		strcpy(curr.description_, info->Description);
		curr.macAddress_.set(info->Address);
		curr.ipAddress_.set(info->IpAddressList.IpAddress.String);
		curr.gwIpAddress_.set(info->GatewayList.IpAddress.String);
		ifs.push_back(curr);
		info = info->Next;
	} while (info);
	return true;
}

#endif /* MIE_USE_PCAP */

#else ///////////////////////////////////////////////////////////////

#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#ifdef MIE_USE_RAW_SOCKET
#include <netinet/if_ether.h>
#include <netpacket/packet.h>
#endif
#ifdef MIE_USE_PCAP
#include <pcap.h>
#endif

bool MIE::Socket::initSystem()
{
	if (s_isInit) return true;

	s_isInit = true;
	return true;
}

bool MIE::Socket::termSystem()
{
	if (!s_isInit) return false;

	s_isInit = false;
	return true;
}

#ifdef MIE_USE_RAW_SOCKET
bool MIE::Socket::getNetworkInterfaces(MIE::NetworkInterfaces& ifs)
{
	FILE *fp;
	int fd;
	char buf[256];
	bool isOK = false;
#ifdef MIE_USE_GPCAP
	{
		pcap_if_t *all = 0;
		if (pcap_findalldevs(&all, buf) < 0) {
			fprintf(stderr, "can't open gigapcap\n");
			return false;
		}
		for (const pcap_if_t *d = all; d != 0; d = d->next) {
			if (strncmp(d->name, "ra:", 3) == 0) {
				MIE::NetworkInterface cur;
				strncpy(cur.name_, d->name, sizeof(cur.name_));
				cur.name_[sizeof(cur.name_) - 1] = '\0';
				strncpy(cur.description_, d->description, sizeof(cur.description_));
				cur.description_[sizeof(cur.description_) - 1] = '\0';
				ifs.push_back(cur);
//				printf("name=%s, disp=%s\n", d->name, d->description);
			}
		}
	}
#endif

	fp = fopen("/proc/net/dev", "r");
	if (fp == 0) {
		return false;
	}
	fd = ::socket(AF_INET, SOCK_DGRAM, 0);
	if (fd < 0) {
		goto ERR_EXIT;
	}
	/* skip 2 lines */
	for (int i = 0; i < 2; i++) {
		fgets(buf, sizeof(buf), fp);
	}
	while (fgets(buf, sizeof(buf), fp)) {
		MIE::NetworkInterface cur;
		struct ifreq ifr;
		/* get network interface name */
		const char *top = buf;
		while (*top == ' ') top++;
		const char *end = strchr(buf, ':');
		if (end == 0) {
			goto ERR_EXIT;
		}
		int len = end - top;
		memcpy(cur.name_, top, len);
		cur.name_[len] = '\0';
		if (strcmp(cur.name_, "lo") == 0) {
			/* ignore loopback device */
			continue;
		}
		memset(&ifr, 0, sizeof(ifr));
		/* get MAC address */
		strcpy(ifr.ifr_name, cur.name_);
		if (ioctl(fd, SIOCGIFHWADDR, &ifr) < 0) {
			continue;
		}
		cur.macAddress_.set(reinterpret_cast<unsigned char*>(ifr.ifr_hwaddr.sa_data));
		/* get ip address */
		if (ioctl(fd, SIOCGIFADDR, &ifr) < 0) {
			continue;
		}
		cur.ipAddress_.set(reinterpret_cast<struct sockaddr_in*>(&ifr.ifr_addr)->sin_addr);
#ifndef NDEBUG
		/* get gw address */
		fprintf(stderr, "not support to get gw address\n");
#endif
		/* get interface number */
		if (ioctl(fd, SIOCGIFINDEX, &ifr) < 0) {
			continue;
		}
		cur.index_ = ifr.ifr_ifindex;
		ifs.push_back(cur);
	}
	isOK = true;
ERR_EXIT:
	fclose(fp);
	::close(fd);
	return isOK;
}
#endif

/** MACAhX擾 */
bool MIE::IpAddress::getMacAddress(MacAddress& macAddress) const
{
#if 1
	FILE *fp;
	char buf[256];
	bool isOK = false;
	fp = fopen("/proc/net/arp", "r");
	if (fp == 0) {
		return false;
	}
	fgets(buf, sizeof(buf), fp); /* skip top line */
	while (fgets(buf, sizeof(buf), fp)) {
		char IPaddress[32], HWtype[32], Flag[32], HWaddress[32];
		int n;
		n = sscanf(buf, "%s %s %s %s", IPaddress, HWtype, Flag, HWaddress);
		if (n == 4 && strcmp(toString(), IPaddress) == 0) {
			unsigned char mac[6];
			char *endp;
			for (int i = 0; i < 6; i++) {
				mac[i] = strtol(&HWaddress[i * 3], &endp, 16);
			}
			macAddress.set(mac);
			isOK = true;
			break;
		}
	}
	fclose(fp);
	return isOK;
#else
	/* Why doesnot this code run well? */
	struct arpreq arp;
	struct sockaddr_in *adr = reinterpret_cast<struct sockaddr_in*>(&arp.arp_pa);
	memset(&arp, 0, sizeof(arp));
	int fd;
	fd = socket(AF_INET, SOCK_DGRAM, 0);
	if (fd < 0) return false;

	adr->sin_family = AF_INET;
	adr->sin_addr = address_;
	int ret;
	ret = ioctl(fd, SIOCGARP, &arp);
	close(fd);
	if (ret) {
		return false;
	}
	macAddress.set(reinterpret_cast<unsigned char*>(&arp.arp_ha.sa_data[0]));
	return true;
#endif
}

#if defined(MIE_USE_RAW_SOCKET) && !defined(MIE_USE_PCAP)
int MIE::Socket::readAsRaw(char *buf, int bufSize)
{
	return ::read(sd_, buf, bufSize);
}

int MIE::Socket::writeAsRaw(const char *buf, int bufSize)
{
	return ::write(sd_, buf, bufSize);
}

bool MIE::Socket::openAsRaw(const MIE::NetworkInterface& netIF, int timeoutMsec)
{
	sd_ = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL));
	if (sd_ < 0) {
		return false;
	}
	/* bind */
	{
		struct sockaddr_ll sock;
		memset(&sock, 0, sizeof(sock));
		sock.sll_family = AF_PACKET;
		sock.sll_protocol = htons(ETH_P_ALL);
		sock.sll_ifindex = netIF.getIndex();
		bind(sd_, (struct sockaddr*)&sock, sizeof(sock));
	}
	/* abandon old data */
#if 0 /* comment out to avoid to infinite loop */
	{
		size_t size;
		do {
			char buf[2048];
			fd_set fds;
			struct timeval t;
			FD_ZERO(&fds);
			FD_SET(sd_, &fds);
			size = select(FD_SETSIZE, &fds, 0, 0, &t);
			if (size > sizeof(buf)) {
				size = sizeof(buf);
			}
			if (size > 0) {
				recv(sd_, buf, size, 0);
			}
		} while (size > 0);
	}
#endif
	/* set promiscous mode */
	{
		struct ifreq ifreq;
		int ret;
		memset(&ifreq, 0, sizeof(ifreq));
		strncpy(ifreq.ifr_name, netIF.getName(), IFNAMSIZ);
		ret = ioctl(sd_, SIOCGIFFLAGS, &ifreq);
		if (ret < 0) {
			return false;
		}
		ifreq.ifr_ifru.ifru_flags |= IFF_PROMISC;
		ret = ioctl(sd_, SIOCSIFFLAGS, &ifreq);
		if (ret < 0) {
			return false;
		}
	}
	if (timeoutMsec > 0) {
		setReceiveTimeout(timeoutMsec);
	}
	return true;
}

bool MIE::Socket::closeAsRaw()
{
	/* same as ordinary socket */
	if (sd_ < 0) return true;
	S_CLOSE(sd_);
	sd_ = -1;
	return true;
}
#endif /* MIE_USE_RAW_SOCKET and !MIE_USE_PCAP */

#endif /* !_WIN32 */

/// use pcap(winpcap)
#ifdef MIE_USE_PCAP
bool MIE::Socket::openAsRaw(const MIE::NetworkInterface& netIF, int timeoutMsec)
{
	if (*netIF.getName() == '\0') {
		return false;
	}
	char err[PCAP_ERRBUF_SIZE];

#ifdef _WIN32
	char name[PCAP_BUF_SIZE];
	/*
		QQQ:pcap_openŊJfoCX͂̕ǉKv
	*/
	_snprintf(name, sizeof(name), "\\DEVICE\\NPF_%s", netIF.getName());
#else
	const char *name = netIF.getName();
#endif

	pcap_t *fp;
	const int snaplen = 1514;
#ifdef _WIN32
	/*
		simple repeater test
		timeout : 100 :  277
		           50 :  577
				   20 :  965
		           10 : 1660
				    5 : 1557
					        Kbytes/sec
	*/
	fp = pcap_open(name, snaplen,
				PCAP_OPENFLAG_PROMISCUOUS, timeoutMsec,
				NULL /* remote authentication */, err);
#else
	fp = pcap_open_live(name, snaplen, 1, timeoutMsec, err);
#endif

	if (fp) {
		rawFp_ = reinterpret_cast<void*>(fp);
		isRaw_ = true;
		return true;
	} else {
		return false;
	}
}

int MIE::Socket::readAsRaw(char *buf, int bufSize)
{
	struct pcap_pkthdr *header;
	const u_char *pkt_data;
	pcap_t *fp = reinterpret_cast<pcap_t*>(rawFp_);

	int ret;
	ret = pcap_next_ex(fp, &header, &pkt_data);
	if (ret > 0) {
		int readSize = header->caplen;

		/* xɓǂ߂Ȃꍇ̓obt@̊Ǘʓ|Ȃ̂ŃG[ɂ */
		if (readSize > bufSize) {
			DPRINTF(("can't read in readAsRaw(%d)\n", readSize));
			return ERR;
		}
		/* QQQ:̃Rs[Ȃ */
		memcpy(buf, pkt_data, readSize);
		return readSize;
	}
	if (ret < 0) {
		DPRINTF(("readAsRaw error=%d\n", ret));
		return ERR; /* error */
	}
	return TIMEOUT;
}

#ifdef _WIN32
int MIE::Socket::writeAsRaw(const char *buf, int bufSize)
{
	pcap_t *fp = reinterpret_cast<pcap_t*>(rawFp_);
	if (pcap_sendpacket(fp, const_cast<u_char*>(reinterpret_cast<const u_char*>(buf)), bufSize)) {
		DPRINTF(("writeAsRaw error=%s\n", pcap_geterr(fp)));
		return -1;
	}
	return bufSize;
	/* Ȃ錾constĂȂ? */
//	return pcap_sendpacket(fp, reinterpret_cast<const u_char*>(buf), bufSize);
}
#else
int MIE::Socket::writeAsRaw(const char *, int)
{
	fprintf(stderr, "not supported in linux\n");
	return -1;
}
#endif

bool MIE::Socket::closeAsRaw()
{
	pcap_t *fp = reinterpret_cast<pcap_t*>(rawFp_);
	if (fp == 0) return false;
	pcap_close(fp);
	rawFp_ = 0;
	return true;
}

bool MIE::Socket::setFilter(const char *rule)
{
	pcap_t *fp = reinterpret_cast<pcap_t*>(rawFp_);
	struct bpf_program fcode;
	const unsigned int netmask = 0xffffff; // * supporse to be in a C class network */

	if (pcap_compile(fp, &fcode, const_cast<char*>(rule), 1, netmask) < 0) {
		return false;
	}
	if (pcap_setfilter(fp, &fcode) < 0) {
		return false;
	}
	return true;
}

int MIE::Socket::getDropNum() const
{
	pcap_t *fp = reinterpret_cast<pcap_t*>(rawFp_);
	struct pcap_stat stat;
	if (pcap_stats(fp, &stat) < 0) {
//		fprintf(stderr, "\npcap_stats: %s\n", pcap_geterr(fp));
		return -1;
	}
	return stat.ps_drop;
}
#endif

