#ifndef SCROLLBAR_TMPL_H_
#define SCROLLBAR_TMPL_H_

/**
	@file scrollbar_tmpl.h
	@brief XN[o[ev[gNX
	@author $Author: mitsunari $
	@version $Revision: 1.1.1.1 $
	@date $Date: 2005/01/20 01:42:22 $
	@note class T ͎̃\bhĂ邱
	setTop(int top, bool isRelative); // c̈ړ(isRelative^̂Ƃ͑ΕύX)
	setLeft(int left, bool isRelative); // ̈ړ(isRelative^̂Ƃ͑ΕύX)
	setViewWidth(int width); // 鉡
	setViewHeight(int height); // c
	getWidth(); // zIȉ
	getHeight(); // zIȏc

*/
namespace MIE {

template<class T>
class ScrollBar {
private:
	T *x_;
	HWND hWnd_;
	enum {
		SCROLL_PIXEL = 10, // XN[̈ړP(pixel)
		SCROLL_PAGE = 40, // XN[{bNX̑傫(K)
		SCROLL_END = 2000, // \傫Ȓl
		VERTICAL = SB_VERT,
		HORIZONTAL = SB_HORZ,
		XXX
	};
	int clientWidth_; // NCAg̉
	int clientHeight_; // NCAg̏c

	/**
		XN[̈ʒu擾
	*/
	inline int getPosition(int mode)
	{
		SCROLLINFO info;
		info.cbSize = sizeof(SCROLLINFO);
		info.fMask = SIF_TRACKPOS;
		GetScrollInfo(hWnd_, mode, &info);
		return info.nTrackPos;
	}
	/**
		XN[ʒuݒ
	*/
	inline void setPosition(int pos, int mode)
	{
		SCROLLINFO info;
		info.cbSize = sizeof(SCROLLINFO);
		info.fMask = SIF_POS | SIF_PAGE;
		info.nPos = pos;
		info.nPage = SCROLL_PAGE;
		SetScrollInfo(hWnd_, mode, &info, TRUE);
	}
public:
	/**
		RXgN^
	*/
	ScrollBar()
		: x_(0)
		, hWnd_(0)
	{
	}

	/**
		֘AÂ
		@param hWnd [in] EBhE
		@param x [in] XN[o[ɑΉē삷NX
	*/
	inline bool attach(HWND hWnd, T *x)
	{
		x_ = x;
		hWnd_ = hWnd;
		return true;
	}

	/**
		eEBhEɍ킹ăTCY
	*/
	inline int onSize(HWND hWnd, WPARAM, LPARAM lParam)
	{
		if (x_ == 0) return 1;
		SCROLLINFO info;
		info.cbSize = sizeof(SCROLLINFO);
		info.fMask = SIF_POS | SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
		info.nPos = 0;
		info.nMin = 0;
		info.nPage = SCROLL_PAGE;

		clientWidth_ = LOWORD(lParam);
		clientHeight_ = HIWORD(lParam);
		clientWidth_ = x_->setViewWidth(clientWidth_);
		clientHeight_ = x_->setViewHeight(clientHeight_);

		int oldTop = getPosition(VERTICAL);
		int oldLeft = getPosition(HORIZONTAL);

		// ݒ
		info.nMax = x_->getWidth() - clientWidth_ + SCROLL_PAGE - 1; // XN[{bNX̕߂
		SetScrollInfo(hWnd, SB_HORZ, &info, FALSE);

		// cݒ
		info.nMax = x_->getHeight() - clientHeight_ + SCROLL_PAGE - 1;
		SetScrollInfo(hWnd, SB_VERT, &info, FALSE);

		const bool isRelative = false;
		setPosition(x_->setTop(oldTop, isRelative), VERTICAL);
		setPosition(x_->setLeft(oldLeft, isRelative), HORIZONTAL);
		return 0;
	}

	/**
		cXN[
	*/
	inline int onVscroll(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		bool isRelative = true;
		int top = 0;
		
		switch (LOWORD(wParam)) {
		case SB_LINEUP:
			top--;
			break;

		case SB_LINEDOWN:
			top++;
			break;

		case SB_PAGEUP:
			top -= SCROLL_PIXEL;
			break;

		case SB_PAGEDOWN:
			top += SCROLL_PIXEL;
			break;

		case SB_THUMBTRACK:
		case SB_THUMBPOSITION:
			top = HIWORD(wParam);
			isRelative = false;
			break;

		case SB_TOP:
			top = 0;
			isRelative = false;
			break;

		case SB_BOTTOM:
			top = SCROLL_END;
			isRelative = false;
			break;
		}
		// ړ
		int newTop = x_->setTop(top, isRelative);

		setPosition(newTop, VERTICAL);
		return 0;
	}

	/**
		XN[
	*/
	inline int onHscroll(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		bool isRelative = true;
		int left = 0;

		switch (LOWORD(wParam)) {
		case SB_LINELEFT:
			left--;
			break;

		case SB_LINERIGHT:
			left++;
			break;

		case SB_PAGELEFT:
			left -= SCROLL_PIXEL;
			break;

		case SB_PAGERIGHT:
			left += SCROLL_PIXEL;
			break;

		case SB_THUMBTRACK:
		case SB_THUMBPOSITION:
			left = HIWORD(wParam);
			isRelative = false;
			break;

		case SB_TOP:
			left = 0;
			isRelative = false;
			break;

		case SB_BOTTOM:
			left = SCROLL_END;
			isRelative = false;
			break;
		}
		// ړ
		int newLeft = x_->setLeft(left, isRelative);

		setPosition(newLeft, HORIZONTAL);
		return 0;
	}
};

} // end of namespace

#endif /* SCROLLBAR_TMPL_H_ */
