
#include "mie_graphic.h"

#define TITLE "JPEGMVXe"

enum {
	WIDTH = 720,
	HEIGHT = 480
};

using namespace MIE;

extern "C" int eventHandler(Canvas::EventType type, const Canvas::EventInfo *info, void *data)
{
	static char *vram;
	static Canvas *canvas;

	switch (type) {
	case Canvas::CREATE:
		canvas = reinterpret_cast<Canvas*>(data);
		vram = canvas->getVramAddress();
		break;

	case Canvas::MOUSE_PRESS:
		{
			int x = info->mx;
			int y = info->my;
			((int*)vram)[(x + y * WIDTH)] = 0xFF00FF00;
			canvas->sendFlushMessage();
		}
		break;

	default:
		break;
	}
	return 0;
}

int main()
{
	Canvas canvas;
	canvas.open(WIDTH, HEIGHT, TITLE, eventHandler, (void*)&canvas);
	canvas.messageLoop();
	return 0;
}
