/*
	mutexeXg
	^CAEgłĂ邩
	time
	+0   main lock
	+1   sub1 lock(with 2sec)
	+2   sub2 lock
	+4   sub1 retire
	+5   main unlock
			sub2lockł邩mFD
*/
#include "../mie_thread.h"
#include <stdio.h>

class ThreadTest : public MIE::ThreadBase {
	enum State {
		SLEEP, //!< ҋ@
		ACTIVE, //!< t@CXV
		DEAD //!< Xbh
	} state_;

	MIE::Mutex& mutex_;
	int num_;
public:
	ThreadTest(MIE::Mutex& mutex, int num)
		: mutex_(mutex)
		, num_(num)
	{
	}

	// XbhJnGg|Cg
	void threadEntry()
	{
		if (num_ == 1) {
			puts("sub1 start");
			puts("sub1 sleep 1sec");
			sleepMsec(1000);
			puts("sub1 try lock(2sec)");
			if (mutex_.lockTimeout(2000)) {
				/* not here */
				puts("sub1 lock succeeded");
			} else {
				puts("sub1 lock failed");
			}
		} else {
			puts("sub2 start");
			puts("sub2 sleep 2sec");
			sleepMsec(2000);
			puts("sub2 try lock");
			mutex_.lock();
			puts("sub2 lock succeeeded");
		}
	}

	/**
		Xbh̒~
	*/
	void stopThread()
	{
		state_ = DEAD;
	}
};


int main()
{
	MIE::Mutex mutex;
	ThreadTest sub1(mutex, 1);
	ThreadTest sub2(mutex, 2);
	sub1.beginThread();
	sub2.beginThread();

	puts("start main");
	puts("main lock");
	puts("main try lock");
	mutex.lock();
	puts("main lock succeeded");
	puts("main wait 5sec");
	MIE::ThreadBase::sleepMsec(5000);
	puts("main unlock");
	mutex.unlock();
	puts("main wait 5sec");
	MIE::ThreadBase::sleepMsec(5000);
	puts("main wait join");
	sub1.joinThread();
	sub2.joinThread();
	return 0;
}
