#ifndef WINDOWHANDLE_H_
#define WINDOWHANDLE_H_

/**
	@file windowhandle.h
	@brief EBhEnhNXт̃}NEev[g
	@author $Author: shigeo $
	@version $Revision: 1.3 $
	@date $Date: 2007/08/25 10:05:30 $
*/
#include <windows.h>
#include <shlobj.h>
#include <commdlg.h>
#include <cstdio>
#include <cstdarg>
#include <strstream> // QQQ: remove this file

#if _MSC_VER > 1200
	#pragma warning(push)
	#pragma warning(disable : 4996) /* sscanf */
#endif

namespace MIE {

/** z̑傫擾 */
#define NUM_OF_ARRAY(x) (sizeof(x)/sizeof(x[0]))

/** lNXɕϊ */
template<int n>
struct int2type { enum { VALUE = n }; };

/**
	bZ[W{bNX\
	@pamra hWnd [in] EBhEnh
	@param title [in] ^Cg
	@param type [in] {^^Cv
	@param format [in] 
*/
static int messageBox(HWND hWnd, const char *title, UINT type, const char *format, ...)
{
	char buf[1024];
	va_list vaList;

	va_start(vaList, format);
	_vsnprintf(buf, sizeof(buf), format, vaList);
	return MessageBox(hWnd, buf, title, type);
}

/** tH_wp */
static inline int CALLBACK callbackForSelectFolder(HWND hWnd, UINT msg, LPARAM lParam, LPARAM lpData)
{
    if (msg == BFFM_INITIALIZED) {
        SendMessage(hWnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData);
    }
	return 0;
}
/*
	tH_I(p)
	@pamra hWnd [in] EBhEnh
	@param title [in] _CAO^Cg
	@param dir [out] ۑfBNg(MAX_PATHȏ゠邱)
	@param initDir [in] fBNg
*/
static inline bool selectFolder(HWND hWnd, const char *title, char *dir, const char *initDir = 0)
{
	BROWSEINFO brows;
	LPITEMIDLIST item;

	memset(&brows, 0, sizeof(BROWSEINFO));
	brows.hwndOwner = hWnd;
	brows.pidlRoot = NULL;
	brows.pszDisplayName = NULL;
	brows.lpszTitle = title;
	brows.ulFlags = BIF_RETURNONLYFSDIRS;
	brows.lpfn = initDir ? callbackForSelectFolder : NULL;
	brows.lParam = reinterpret_cast<long>(initDir);
	brows.iImage = 0;

	item = SHBrowseForFolder(&brows);
	if (item == NULL) {
		/* LZꂽ */
		return false;
	} else {
		/* PIDLpXɕϊ */
		SHGetPathFromIDList(item, dir);

		/* VF(SHBrowseForFolder)mۂ */
		CoTaskMemFree(item);
		return true;
	}
}

/**
	t@CZN^o
	@param hWnd [in] EBhEnh
	@param fname [out] Iꂽt@C
	@param fnameMaxSize [in] őt@C
	@param suffix [in] gq
	@param isReadOnly [in] ǂݍݐpƂĊJ(default)
*/
static inline bool selectFile(
	HWND hWnd,
	char *fname,
	int fnameMaxSize,
	const char *suffix, bool isReadOnly = true)
{
	using namespace std;
	OPENFILENAME ofn;

	memset(&ofn, 0, sizeof(ofn));
	memset(fname, 0, fnameMaxSize);

	ofn.lStructSize  = sizeof(OPENFILENAME);
	ofn.hInstance	= NULL;
	ofn.hwndOwner	= hWnd;

	char cbuf[128];
	strstream filter(cbuf, sizeof(cbuf), ios::out);

	filter << suffix << "t@C" << ends << suffix << ends
		<< "ׂẴt@C" << ends << "*.*" << ends << ends;
	ofn.lpstrFilter = cbuf;
	ofn.lpstrFile = fname;
	ofn.nMaxFile  = fnameMaxSize;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_EXPLORER;
	if (isReadOnly) {
		ofn.Flags |= OFN_FILEMUSTEXIST | OFN_READONLY;
	} else {
		ofn.Flags |= OFN_OVERWRITEPROMPT;
	}
	ofn.lpstrDefExt = suffix;
	if (isReadOnly) {
		char title[64];
		sprintf(title, "%st@CJ", suffix);
		ofn.lpstrTitle = title;
	} else {
		ofn.lpstrTitle = "t@C֕ۑ";
	}

	int success;
	if (isReadOnly) {
		success = GetOpenFileName(&ofn);
	} else {
		success = GetSaveFileName(&ofn);
	}
	if (success) {
		return true;
	} else {
		return false;
	}
}

/**
	HWND̔bpNX
*/
class WindowHandle {
protected:
	HWND hWnd_;

public:
	/**
		RXgN^
	*/
	WindowHandle()
		: hWnd_(0)
	{
	}

	/**
		nhݒ肷
	*/
	inline void setHandle(HWND hWnd) { hWnd_ = hWnd; }

	/**
		nh𓾂
		@note ȂhWnd_publicɂĂ悢悤ȋC
	*/
	inline HWND getHandle() const { return hWnd_; }

	/**
		EBhELɂ
	*/
	inline void enable(bool isEnable = true) const
	{
		EnableWindow(hWnd_, isEnable);
	}
	/**
		EBhELۂ
	*/
	inline bool isEnable() const
	{
		return IsWindowEnabled(hWnd_) != 0;
	}

	/**
		tHgݒ肷
		@note id [in] tHgI
		@note \[X[N
		id == -1 : Ȃ
		id == 0  : DEFAULT_GUI_FONT
		id > 1   : `(dl)
	*/
	inline void setFont(int id = -1) const
	{
		if (id == -1) return;
		HFONT hFont;
		if (id == 0) {
			hFont = reinterpret_cast<HFONT>(GetStockObject(DEFAULT_GUI_FONT));
		} else {
			hFont = CreateFont(12, 0, 0, 0, 0, 0, 0, 0,
					SHIFTJIS_CHARSET, 0, 0, 0, FIXED_PITCH, "lr SVbN");
		}
		SendMessage(hWnd_, WM_SETFONT, (WPARAM)hFont, TRUE);
	}

	/**
		EBhȆ傫ύX
		@param width [in] 
		@param height [in] c
		@param isRepaint [in] ĕ`悷邩ۂ
	*/
	inline void resize(int width, int height, bool isRepaint = true) const
	{
		RECT rect;
		GetWindowRect(hWnd_, &rect);
		MoveWindow(hWnd_, rect.left, rect.top, width, height, isRepaint);
	}

	/**
		NCAg̈̑傫ύX
		@param width [in] 
		@param height [in] c
		@param isRepaint [in] ĕ`悷邩ۂ
	*/
	inline void resizeClient(int width, int height, bool isRepaint = true) const
	{
		RECT rect, client;
		GetWindowRect(hWnd_, &rect);
		GetClientRect(hWnd_, &client);
		MoveWindow(hWnd_, rect.left, rect.top,
			rect.right - rect.left + width - client.right,
			rect.bottom - rect.top + height - client.bottom, isRepaint);

	}
	/**
		EBhȆ傫𑊑ΓIɕύX
		@param width [in] ̑
		@param height [in] c̑
		@param isRepaint [in] ĕ`悷邩ۂ
	*/
	inline void resizeRelative(int width, int height, bool isRepaint = true) const
	{
		RECT rect;
		GetWindowRect(hWnd_, &rect);
		width += rect.right - rect.left;
		height += rect.bottom - rect.top;
		MoveWindow(hWnd_, rect.left, rect.top, width, height, isRepaint);
	}

	/**
		EBhEړ
		@param left [in] ̐Έʒu
		@param top [in] c̐Έʒu
		@param isRepaint [in] ĕ`悷邩ۂ
	*/
	inline void move(int left, int top, bool isRepaint = true) const
	{
		RECT rect;
		GetWindowRect(hWnd_, &rect);
		MoveWindow(hWnd_, left, top, rect.right - rect.right, rect.bottom - rect.top, isRepaint);
	}

	/**
		EBhẺ̃TCY擾
	*/
	inline int getWidth() const
	{
		RECT rect;
		if (GetClientRect(hWnd_, &rect)) {
			return rect.right;
		} else {
			return 0;
		}
	}

	/**
		EBhȄc̃TCY擾
	*/
	inline int getHeight() const
	{
		RECT rect;
		if (GetClientRect(hWnd_, &rect)) {
			return rect.bottom;
		} else {
			return 0;
		}
	}

	/**
		EBhȆ傫擾
	*/
	inline void getSize(int *width, int *height) const
	{
		RECT rect;
		if (GetClientRect(hWnd_, &rect)) {
			*width = rect.right;
			*height = rect.bottom;
		} else {
			*width = 0;
			*height = 0;
		}
	}

	/**
		EBhËʒu擾
	*/
	inline void getPosition(int *left, int *top) const
	{
		RECT rect;
		if (GetWindowRect(hWnd_, &rect)) {
			*left = rect.left;
			*top = rect.top;
		} else {
			*left = 0;
			*top = 0;
		}
	}

	/**
		eLXgύX
	*/
	inline void setText(const char *text) const
	{
		SetWindowText(hWnd_, text);
	}

	/**
		eLXg擾
	*/
	inline void getText(char *text, int textSize) const
	{
		GetWindowText(hWnd_, text, textSize);
	}

	/**
		leLXgƂđ
	*/
	inline void setTextAsInteger(int x) const
	{
		char buf[32];
		sprintf(buf, "%d", x);
		setText(buf);
	}
	/**
		eLXg10i̐lƂĎ擾
		@note G[̂Ƃ0Ԃ̂0Ƃ̋ʂ͂łȂ
	*/
	inline int getTextAsInteger() const
	{
		char buf[32];
		getText(buf, sizeof(buf));
		return atoi(buf);
	}

	/**
		tbV
	*/
	inline void flush() const
	{
		InvalidateRgn(hWnd_, NULL, FALSE);
	}

	/**
		tbV
	*/
	inline void flush(const RECT* rect)
	{
		InvalidateRect(hWnd_, rect, FALSE);
	}

	/**
		EBhEX^C擾
	*/
	inline UINT getStyle() const
	{
		return GetWindowLong(hWnd_, GWL_STYLE);
	}
	/**
		EBhEX^Cݒ
	*/
	inline void setStyle(UINT style)
	{
		SetWindowLong(hWnd_, GWL_STYLE, style);
	}

	/**
		bZ[W{bNX
		@param title [in] ^Cg
		@param type [in] {^^Cv
		@param format [in] 
	*/
	inline int messageBox(const char *title, UINT type, const char *format, ...) const
	{
		char buf[1024];
		va_list vaList;

		va_start(vaList, format);
		_vsnprintf(buf, sizeof(buf), format, vaList);
		return MessageBox(hWnd_, buf, title, type);
	}
	/*
		tH_I(p)
		@param title [in] _CAO^Cg
		@param dir [out] ۑfBNg(MAX_PATHȏ゠邱)
		@param initDir [in] fBNg
	*/
	inline bool selectFolder(const char *title, char *dir, const char *initDir = 0)
	{
		return MIE::selectFolder(hWnd_, title, dir, initDir);
	}

	/**
		t@CZN^o
		@param fname [out] Iꂽt@C
		@param fnameMaxSize [in] őt@C
		@param suffix [in] gq
		@param isReadOnly [in] ǂݍݐpƂĊJ(default)
	*/
	inline bool selectFile(
		char *fname,
		int fnameMaxSize,
		const char *suffix, bool isReadOnly = true)
	{
		return MIE::selectFile(hWnd_, fname, fnameMaxSize, suffix, isReadOnly);
	}

};

} // end of namespace

#if _MSC_VER > 1200
	#pragma warning(pop)
#endif

#endif /* WINDOWHANDLE_H_ */
