#ifndef BUTTON_CTL_H_
#define BUTTON_CTL_H_
/*!
	@file button_ctl.h
	@brief {^Rg[
	@author $Author: shigeo $
	@version $Revision: 1.3 $
	@date $Date: 2006/05/19 01:54:49 $
*/

#include "windowhandle.h"

namespace MIE {

class ButtonCtl : public WindowHandle {
	int id_;
	void (*handler_)(int state, void *arg);
	void *arg_;
public:
	enum State {
		CHECKED = BST_CHECKED, //!< `FbN
		UNCHECKED = BST_UNCHECKED, //!< `FbN
		GRAY = BST_INDETERMINATE, //!< I𕉉
		UNKNOWN = -1
	};
	/*!
		RXgN^
	*/
	ButtonCtl()
		: id_(0)
	{
	}

	int onCommand(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		if (LOWORD(wParam) == id_) {
			if (HIWORD(wParam) == BN_CLICKED) {
				int state;
//				state = SendMessage(hWnd_, BM_GETCHECK, 0, 0);
				state = getState();
				if (handler_) handler_(state, arg_);
				return TRUE;
			}
		}
		return FALSE;
	}
	/*!
		{^Rg[
		@param parent [in] enh
		@param id [in] {^ʎq
		@param state [in] Ƀ`FbNĂ邩ۂ
		@param handler [in] ύXƂɌĂ΂nh(stateɃ{^̏Ԃ)
		@param arg [in] nhɓn郆[U`|C^
	*/
	bool create(HWND parent, int id, State state,
		void (*handler)(int state, void *arg) = 0,
		void *arg = 0)
	{
		// EBhEnh擾
		hWnd_ = GetDlgItem(parent, id);
		if (hWnd_ == 0) return false;
		handler_ = handler;
		arg_ = arg;
		id_ = id;

		change(state);
		return true;
	}

	/*!
		{^̏Ԑݒ
	*/
	inline void change(State state)
	{
		if (hWnd_) SendMessage(hWnd_, BM_SETCHECK, state, 0);
	}
	/*!
		{^̏Ԏ擾
	*/
	inline State getState() const
	{
		if (hWnd_) {
			return static_cast<State>(SendMessage(hWnd_, BM_GETCHECK, 0, 0));
		}
		return UNKNOWN;
	}
};

} // end of namespace

#endif /* BUTTON_CTL_H_ */
