/*!
	time.cgi
	IvV
		ݎ̏\
	"YYYYMMDDHHMMSS"
		̎̏\(͕s)
	"publickey"
		J\
*/
#include <stdio.h>
#include <string.h>
#include "mie_timecapsule.h"

#define USE_PRIVATE_FILE /* 閧t@Cǂݍ */
#ifdef USE_PRIVATE_FILE

#include <string>
#include <fstream>
#include <sstream>
#define PRIVATE_KEY_FILE "timecapsule.prv" /* 閧t@C */

#else

static const char *seed = "231470950298345644921027510273641027363502734151";

#endif

enum {
	debug = 0
};

struct Html {
	bool isJSONP_;
	Html(bool isJSONP)
		:isJSONP_(isJSONP)
	{
		printf("Content-type: ");
		if (isJSONP) {
			printf("application/x-javascript; charset=utf-8\r\n\r\n");
		} else {
			printf("text/html\r\n\r\n");
			printf("<html><head><title>time capsule</title></head><body>");
		}
	}
	~Html()
	{
		if (!isJSONP_) printf("</body></html>\r\n");
	}
};

int main(int argc, char *argv[])
{
	argc--, argv++;
	const char *cmd = argc > 0 ? *argv : 0;

	MIE_TC::init();
	MIE_TC::PrivateKey privateKey;
	MIE_TC::PublicKey publicKey;

	bool isJSONP = false;
	if (cmd && cmd[0] == 'P') {
		cmd++;
		if (cmd[0] == '\\') cmd++;
		if (cmd[0] == '&') cmd++;
		isJSONP = true;
	}
	Html html(isJSONP);
#ifdef USE_PRIVATE_FILE
	std::string buf;
	{
		std::ifstream ifs(PRIVATE_KEY_FILE);
		if (!ifs) {
			fprintf(stderr, "can't open %s\n", PRIVATE_KEY_FILE);
			return 1;
		}
		std::getline(ifs, buf);
	}
	const char *seed = buf.c_str();
#endif
	if (!privateKey.init(seed, &publicKey)) {
		if (debug) puts("fail:privateKey.init()");
		return 1;
	}

	if (cmd && strcmp(cmd, "publickey") == 0) {
		const char *key = publicKey.get();
		if (key) {
			printf("%s", key);
			return 0;
		} else {
			printf("fail:can't get public key");
			return 1;
		}
	}

	MIE_TC::TimeInfo timeInfo;

	bool isNow = true;
	if (cmd && memcmp(cmd, "now", 3) != 0) {
		MIE_TC::TimeInfo now;
		now.setNow();
		const int marginSec = 30; /* Ȃ疢ł(ȂƎ̒ʓ|) */
		/* sȕ񂩖̎ȂG[ */
		if (timeInfo.set(cmd) && !timeInfo.isNewerThan(now, marginSec)) {
			isNow = false;
		}
	}
	if (isNow) {
		timeInfo.setNow();
	}

	MIE_TC::SignedTimeInfo signedTimeInfo;
	if (privateKey.sign(&signedTimeInfo, timeInfo, publicKey, MIE_TC::PrivateKey::DontVerifyTime)) {
		if (isJSONP) {
			const std::string callback = "handler";
			std::istringstream is(signedTimeInfo.get());
			std::string time, Em;
			is >> time >> Em;
			printf("%s([", callback.c_str());
			printf("{\"time\":\"%s\"},{\"Em\":\"%s\"}", time.c_str() + 5, Em.c_str() + 3);
			printf("])");
		} else {
			printf("%s", signedTimeInfo.get());
		}
	}
	return 0;
}

