#ifndef CLOCKSTRING_H_
#define CLOCKSTRING_H_
/*!
	v
*/
#include "windowhandle.h"
#include <ctime>
#include <assert.h>

#if defined(_MSC_VER) && (_MSC_VER > 1200)
	#pragma warning(push)
	#pragma warning(disable:4996)
#endif

class ClockString : public MIE::WindowHandle {
private:
	HFONT font_;
public:
	ClockString()
		: font_(0)
	{
	}

	void updateTime()
	{
		char msg[32];
		time_t currTime;
		struct tm *today;
		time(&currTime);
		today = localtime(&currTime);
		strftime(msg, sizeof(msg), "%Y/%m/%d %H:%M:%S", today);
		setText(msg);
	}

	void resize(int width, int height)
	{
		const int clockLen = 10; /* ̒ */
		RECT rect;
		GetWindowRect(hWnd_, &rect);
		MoveWindow(hWnd_, 0, 0, width, height, TRUE);
		if (font_) {
			DeleteObject(font_);
			font_ = 0;
		}

		int fontWidth = width / clockLen;
		if (fontWidth < 12) fontWidth = 12; /* ŏl */
		font_ = CreateFont(fontWidth, 0, 0, 0, 0, 0, 0, 0,
//					SHIFTJIS_CHARSET, 0, 0, 0, FIXED_PITCH, "lr SVbN");
					SHIFTJIS_CHARSET, 0, 0, 0, FIXED_PITCH, "HGnpp߯ߑ");
		SendMessage(hWnd_, WM_SETFONT, (WPARAM)font_, TRUE);
		updateTime();
	}
};

#if defined(_MSC_VER) && (_MSC_VER > 1200)
	#pragma warning(pop)
#endif

#endif /* CLOCKSTRING_H_ */
