#ifndef TS_DECODER_H_
#define TS_DECODER_H_

/*!
	^CJvZÍfR[_

	@author $Author: shigeo $
	@version $Revision: 1.19 $
	@date $Date: 2007/08/30 02:09:07 $
*/

#include <stdio.h>
#include <string.h>
#include "mie_timecapsule.h"
#include "ts_protocol.h"
#include "cipher_rijndael.h"
#include "ts_common.h"
#include <fstream>
#include <ios>
#include <string>

namespace MIE_TC {

class TSdecoder {
private:
	void usage()
	{
		fprintf(stderr, "-f input-file [-a address]\n");
	}

public:
	/*!
		擾
		@param timeInfo [out] 
		@param inName [in] t@C
	*/
	static bool getTimeInfo(TimeInfo& timeInfo, const std::string& inName)
	{
		std::ifstream ifs(inName.c_str(), std::ios::binary);
		if (!ifs) {
			if (debug) fprintf(stderr, "can't open [%s]\n", inName.c_str());
			return false;
		}
		/* ÍꂽZbV擾 */
		std::string header;
		std::getline(ifs, header, '\0');
		if (!ifs) {
			if (debug) fprintf(stderr, "bad format\n");
			return false;
		}
		EncodedSessionKey encodedSessionKey(header.c_str());

		fprintf(stderr, "encodedSessionKey:\n%s\n", encodedSessionKey.get());

		// 擾
		return timeInfo.set(encodedSessionKey.get());
	}
	/*!
		fR[h{
		@param inName [in] t@C
		@param address [in] T[õAhX
		@param publicKey [in] J(؎Kv svȂ0)
		@param outName [in] o̓t@C
	*/
	static int decodeContents(const char *inName, const char *address, const PublicKey *publicKey, const char *outName = 0)
	{
		std::ifstream ifs(inName, std::ios::binary);
		if (!ifs) {
			fprintf(stderr, "can't open [%s]\n", inName);
			return 1;
		}

		/* t@C */
		std::string outNameBuf;
		if (outName == 0) {
			outNameBuf = inName;
			outNameBuf += ".dec";
			outName = outNameBuf.c_str();
		}
		std::ofstream ofs(outName, std::ios::binary);
		if (!ofs) {
			fprintf(stderr, "can't open [%s]\n", outName);
			return 1;
		}

		bool isOK;
		isOK = DecodeCore(ifs, ofs, address, publicKey);
		fprintf(stderr, "decoding : %s\n", isOK ? "done" : "fail");
		return isOK ? 0 : 1;
	}

	/* Av{ */
	int run(int argc, char *argv[])
	{
		const char *inName = 0;
		const char *address = 0;
		bool doVerify = false;

		while (argc > 0) {
			if (argc > 1 && strcmp(*argv, "-f") == 0) {
				argc--, argv++;
				inName = *argv;
			} else
			if (argc > 1 && strcmp(*argv, "-a") == 0) {
				argc--, argv++;
				address = *argv;
			} else
			if (strcmp(*argv, "-v") == 0) {
				doVerify = true;
			} else
			{
				usage();
				return 1;
			}
			argc--, argv++;
		}
		if (address == 0) {
			address = TIME_SERVER_ADDRESS;
		}
		if (inName == 0) {
			usage();
			return 1;
		}
		if (doVerify) {
			PublicKey publicKey;
			if (!publicKey.load(PUBLIC_KEY_FILE)) {
				fprintf(stderr, "can't load `%s`\n", PUBLIC_KEY_FILE);
				return 1;
			}
			return decodeContents(inName, address, &publicKey);
		} else {
			return decodeContents(inName, address, 0);
		}
	}
};

} // end of namespace

#endif /* TS_DECODER_H_ */
