#ifndef TS_ENCODER_H_
#define TS_ENCODER_H_
/*!
	^CJvZÍGR[_

	@author $Author: shigeo $
	@version $Revision: 1.12 $
	@date $Date: 2007/08/28 09:43:21 $
*/

#include <stdio.h>
#include <string.h>
#include "mie_timecapsule.h"
#include "ts_protocol.h"
#include "cipher_rijndael.h"
#include "ts_common.h"
#include <string>
#include <fstream>

namespace MIE_TC {

class TSencoder {
private:
	void usage()
	{
		printf("-init server-address\n");
		printf("-f input-file -t decode-time[YYYYMMDDHHMMSS] -s seed\n");
	}

public:
	/*!
		GR[_{
		@param publicKey [in] J
		@param inName [in] t@C
		@param decTime [in] 
		@param seed [in] ÍɎg̎
	*/
	int encodeFile(const PublicKey& publicKey, const char *inName, const char *decTime, const char *seed) const
	{
		std::string outName(inName);
		outName += "." TC_SUF;

		std::ifstream in(inName, std::ios::binary);
		std::ofstream out(outName.c_str(), std::ios::binary);
		if (!in) {
			printf("can't open [%s]\n", inName);
			return 1;
		}
		if (!out) {
			printf("can't open [%s]\n", outName.c_str());
			return 1;
		}

		if (EncodeCore(publicKey, decTime, in, out, seed)) {
			fprintf(stderr, "encoding is compelte\n");
			return 0;
		} else {
			fprintf(stderr, "encoding is error\n");
			return 1;
		}
	}

	/* Av{ */
	int run(int argc, char *argv[])
	{
		/* J擾 */
		if (argc > 1 && strcmp(*argv, "-init") == 0) {
			const char *cgiPath = (argc > 2) ? argv[2] : 0;
			if (Protocol::GetPublicKeyFileByHTTP(PUBLIC_KEY_FILE, argv[1], cgiPath)) {
				fprintf(stderr, "save publicKey\n");
				return 0;
			} else {
				fprintf(stderr, "can't save publicKey\n");
				return 1;
			}
		}
		const char *time = 0;
		const char *inName = 0;
		const char *seed = 0;

		while (argc > 0) {
			if (argc > 1 && strcmp(*argv, "-f") == 0) {
				argc--, argv++;
				inName = *argv;
			} else
			if (argc > 1 && strcmp(*argv, "-t") == 0) {
				argc--, argv++;
				time = *argv;
			} else
			if (argc > 1 && strcmp(*argv, "-s") == 0) {
				argc--, argv++;
				seed = *argv;
			} else
			{
				usage();
				return 1;
			}
			argc--, argv++;
		}
		if (time == 0 || inName == 0 || seed == 0) {
			usage();
			return 1;
		}

		PublicKey publicKey;

		if (!publicKey.load(PUBLIC_KEY_FILE)) {
			printf("can't load `%s`\n", PUBLIC_KEY_FILE);
			return 1;
		}
		return encodeFile(publicKey, inName, time, seed);
	}
};

} // end of namespace

#endif /* TS_ENCODER_H_ */
