#ifndef LISTVIEW_CTL_H_
#define LISTVIEW_CTL_H_

#pragma warning(disable : 4786)
#include <map>
#include <string>
/*!
	@file listview_dlg.h
	@brief Xgr[_CAONX
	@author $Author: shigeo $
	@version $Revision: 1.4 $
	@date $Date: 2006/05/19 15:37:50 $
*/
namespace MIE {

class ListViewCtl : public WindowHandle {
private:
	int id_;
	int columnNum_;
	int listNo_;
	void update()
	{
		UpdateWindow(hWnd_);
	}
public:
	/*!
		RXgN^
	*/
	ListViewCtl()
		: columnNum_(0)
		, listNo_(0)
	{
	}

	/*!
		fXgN^
	*/
	~ListViewCtl()
	{
	}
	/*!
		Rǉ
		@param column [in] R̕
		@param width [in] 
	*/
	bool addColumn(const char *str, int width)
	{
		LV_COLUMN column;

		column.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		column.fmt = LVCFMT_LEFT;
		column.cx = width;
		column.pszText = const_cast<char*>(str);
		column.iSubItem = columnNum_;
		int ret;
		ret = ListView_InsertColumn(hWnd_, columnNum_, &column);
		if (ret < 0) {
			puts("ERRRO");
		}
		columnNum_++;

//		SendMessage(hWnd_, WM_SIZE, 0, 0);
		return true;
	}
	/*!
		ږԍ擾
		@param itemName [in] ږ
		@retval 0ȏ ږԍ
		@retval -1 ݂Ȃ
	*/
	inline int getItemKeyIdx(const std::string& itemName)
	{
		LVFINDINFO info;
		info.flags = LVFI_STRING;
		info.psz = itemName.c_str();
		return ListView_FindItem(hWnd_, -1/*beginning*/, &info);
	}
	/*!
		ڂ̕ύX
		@param itemKeyIdx [in] ږԍ
		@param itemNo [in] Ԗڂ
		@param value [in] 
	*/
	void change(int itemKeyIdx, int itemNo, const char *value)
	{
		LV_ITEM item;

		item.mask = LVIF_TEXT;
		item.pszText = const_cast<char*>(value);
		item.iItem = itemKeyIdx;
		item.iSubItem = itemNo;
		ListView_SetItem(hWnd_, &item);
		update();
	}

	/*!
		ڂ̒ǉ
		@param itemName [in] ږ(Xgɖꍇ͒ǉ, łȂꍇ͊̒lԂ)
		@retval Ή郊Xg̔ԍ
	*/
	int add(const std::string& itemName)
	{
		int listNo = getItemKeyIdx(itemName);
		if (listNo < 0) {
			/* łȂꍇ͍Ōɒǉ */
			listNo = listNo_++;

			LV_ITEM item;
			item.mask = LVIF_TEXT;
			item.iSubItem = 0;
			item.pszText = const_cast<char *>(itemName.c_str());
			item.iItem = listNo;
			listNo = ListView_InsertItem(hWnd_, &item);
			update();
		}
		return listNo;
	}

	/*!
		ڂ̍폜
	*/
	int del(int itemKeyIdx)
	{
		ListView_DeleteItem(hWnd_, itemKeyIdx);
		listNo_--;
		update();
		return 0;
	}
	/*!
		{^Rg[
		@param parent [in] enh
		@param id [in] {^ʎq
	*/
	bool create(HWND parent, int id)
	{
		// EBhEnh擾
		hWnd_ = GetDlgItem(parent, id);
		if (hWnd_ == 0) return false;
		id_ = id;
		return true;
	}
};

} // end of namespace

#endif // LISTVIEW_CTL_H_
