#ifndef TS_SERVER_H_
#define TS_SERVER_H_
/*!
	JƎɏS

	@author $Author: shigeo $
	@version $Revision: 1.15 $
	@date $Date: 2007/08/25 12:58:30 $
*/

#include <stdio.h>
#include <string.h>
#include "mie_timecapsule.h"
#include "ts_protocol.h"

namespace MIE_TC {

class TSserver {
	enum {
		debug = 1
	};
private:
	PrivateKey privateKey_;
	PublicKey publicKey_;

	void usage()
	{
		printf("-init random-seed-string\n");
	}

	/*!
		NCAg̗v҂
	*/
	int waitForRequest()
	{
		MIE::Socket socket;
		bool isOK;
		int ret = 0;

		isOK = socket.openAsServer(Protocol::PORT);
		if (!isOK) {
			if (debug) fprintf(stderr, "fail:socket.open()\n");
			return 1;
		}

		for (;;) {
			// NCAg̐ڑv҂
			isOK = socket.accept();
			if (!isOK) {
				if (debug) fprintf(stderr, "fail:socket.acccept()\n");
				ret = 1;
				break;
			}
			if (debug) fprintf(stderr, "socket accept\n");
			for (;;) {
				using namespace Protocol;
				char buf[2048];
				int readSize;
				readSize = socket.read(buf, sizeof(buf) - 1);
				if (readSize == 0) continue;
				if (readSize < 0) {
					if (debug) fprintf(stderr, "socket close\n");
					socket.close();
					break;
				}
				buf[readSize] = '\0';
				if (debug) printf("[S] readSize=%d(%s)\n", readSize, buf);

				TimeInfo timeInfo;
				RequestMode mode;
				mode = GetRequestMode(&timeInfo, buf);
				switch (mode) {
				case RequestError:
				default:
					break;
				case RequestPublicKey:
					if (debug) fprintf(stderr, "request publicKey\n");
					/* Jv󂯂烁bZ[WԂ */
					{
						const char *key = publicKey_.get();
						if (key) {
							SendMessageByHTTP(socket, key);
						}
					}
					break;
				case RequestSignedTimeInfo:
					if (debug) fprintf(stderr, "request signedTimeInfo\n");
					/* v󂯂珐Ԃ */
					SignedTimeInfo signedTimeInfo;
					privateKey_.sign(&signedTimeInfo, timeInfo, publicKey_);
					SendMessageByHTTP(socket, signedTimeInfo.get());
					break;
				}
				socket.close();
			}
		} // for (;;)

		return ret;
	}
public:
	// Av{
	int run(int argc, char *argv[])
	{
		const char *seed = 0;

		if (argc > 1 && strcmp(*argv, "-init") == 0) {
			seed = argv[1];
		} else {
			usage();
			return 1;
		}

		/* J */
		if (!privateKey_.init(seed, &publicKey_)) {
			if (debug) fprintf(stderr, "fail:privateKey.init()\n");
			return 1;
		}

		/* NCAg̗v҂ */
		return waitForRequest();
	}
};

} // end of namespace

#endif /* TS_SERVER_H_ */
