/*!
	^CJvZÍNCAgc[
*/
#define STRICT
#define _WIN32_WINNT 0x0500
#define WIN32_LEAN_AND_MEAN

//#define MIE_WIN_CHECK_MEMORY_LEAK

#if !defined(_MSC_VER) || !defined(_DEBUG)
	#undef MIE_WIN_CHECK_MEMORY_LEAK
#endif

#ifdef MIE_WIN_CHECK_MEMORY_LEAK
	#define _CRTDBG_MAP_ALLOC   // for malloc_malloc_dbg̒u
	#define MIE_MEM_Init() _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF)
#else
	#define MIE_MEM_Init()
#endif

#include <winsock2.h>
#include <windows.h>
#include "mie_socket.h"
#include <crtdbg.h>
#include "basedialog.h"
#include <shellapi.h>
#include "editbox_ctl.h"
#include "button_ctl.h"
#include "listview_ctl.h"
#include "tclient_resource.h"

#include "about_dlg.h"

#include "mie_timecapsule.h"
#include "mie_thread.h"
#include "win_configfile.h"
#include "ts_protocol.h"
#include "ts_encoder.h"
#include "ts_decoder.h"
#include "cipher_rijndael.h"
#include "ts_common.h"
#include "clockstring.h"
#include "ts_util.h"
#include <vector>
#include <string>
#include <map>

#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "user32.lib")
#pragma comment(lib, "comdlg32.lib")
#pragma comment(lib, "shell32.lib")

#define ON_COMMAND(x) if (x.onCommand(hWnd, wParam, lParam)) return TRUE;

#define INI_FILE "ts_tool.ini"
#define SECTION "tclient"
#define KEY_ADDRESS "address"
#define KEY_CGI_PATH "cgi-path"
#define KEY_VERIFY "verify"
#define KEY_VIEW "view"

#define TRAY_ID 1
#define WM_MYTRAY (WM_USER + 10)
#define TIME_CAPSULE_MUTEX "time capsule mutex-29384752347"

static bool isEncodedFileName(const char *name)
{
	const char *p = strstr(name, "." TC_SUF);
	return p && p[strlen("." TC_SUF)] == '\0';
}

/*
	[r
*/
class OnceEnter {
private:
	bool& flag_;
public:
	OnceEnter(bool& flag)
		: flag_(flag)
	{
		flag_ = true;
	}
	~OnceEnter()
	{
		flag_ = false;
	}
};

class Seed {
private:
	enum {
		LEN = 64
	};
	char buf_[LEN + 1]; /* NULI[܂ */
	int pos_;
	void updateByte()
	{
		LARGE_INTEGER t;
		QueryPerformanceCounter(&t);
		srand((int)(t.QuadPart % 65537) + rand());
		buf_[pos_] = ((buf_[pos_] + rand()) % 10) + '0';
		pos_++;
		if (pos_ >= LEN) pos_ = 0;
	}
public:
	Seed()
		: pos_(0)
	{
		memset(buf_, 0, sizeof(buf_));
		for (int i = 0; i < LEN; i++) {
			updateByte();
		}
	}
	void update()
	{
		for (int i = 0; i < (buf_[pos_] - '0') + 13; i++) {
			updateByte();
		}
	}
	const char *get() const { return buf_; }
};

class DecodeFileListView;

class ListViewCtlWithDrop : public MIE::BaseWindow {
private:
	DecodeFileListView *decodedFileListView_;
	LRESULT wndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
public:
	void set(DecodeFileListView *decodedFileListView, MIE::ListViewCtl *viewList);
};

class DecodeFileListView {
private:
	MIE::WindowHandle parent_;
	MIE::ListViewCtl viewList_;
	ListViewCtlWithDrop drop_;
	MIE::ButtonCtl doView_;
	MIE::ButtonCtl doVerify_;
	typedef std::multimap<MIE_TC::TimeInfo, std::string> DecodeFileList;
	DecodeFileList fileList_;
	bool underProcessing_;
	MIE::WinConfigFile* config_;
	MIE_TC::PublicKey *publicKey_;
	int adjH_;

	void dump() const
	{
		puts("---");
		for (DecodeFileList::const_iterator itr = fileList_.begin(); itr != fileList_.end(); ++itr) {
			printf("%s, %s\n", itr->first.get(), itr->second.c_str());
		}
	}
public:
	DecodeFileListView()
		: underProcessing_(false)
		, config_(0)
		, publicKey_(0)
	{
	}
	~DecodeFileListView()
	{
		config_->set(SECTION, KEY_VIEW, doView_.getState() == MIE::ButtonCtl::CHECKED ? "on" : "off");
		config_->set(SECTION, KEY_VERIFY, doVerify_.getState() == MIE::ButtonCtl::CHECKED ? "on" : "off");
	}

	enum {
		DEC_TIME_NO = 1
	};
	void init(HWND hWnd, MIE::WinConfigFile* config, MIE_TC::PublicKey *publicKey)
	{
		config_ = config;
		publicKey_ = publicKey;
		{
			char buf[16];
			bool isChecked;
			isChecked = config_->get(SECTION, KEY_VIEW, buf, sizeof(buf)) && strcmp(buf, "on") == 0;
			doView_.create(hWnd, IDC_DOVIEW, isChecked ? MIE::ButtonCtl::CHECKED : MIE::ButtonCtl::UNCHECKED);
			isChecked = config_->get(SECTION, KEY_VERIFY, buf, sizeof(buf)) && strcmp(buf, "on") == 0;
			doVerify_.create(hWnd, IDC_VERIFY, isChecked ? MIE::ButtonCtl::CHECKED : MIE::ButtonCtl::UNCHECKED);
		}
		viewList_.create(hWnd, IDC_MESSAGE_LIST);

		static const char list[][16] = { "t@C", "" };
		static const int listWidth[] = { 400, 230 };
		for (int i = 0; i < NUM_OF_ARRAY(list); i++) {
			viewList_.addColumn(list[i], listWidth[i]);
		}
		parent_.setHandle(hWnd);
		RECT rect;
		GetWindowRect(viewList_.getHandle(), &rect);
		adjH_ = rect.top;
		GetWindowRect(hWnd, &rect);
		adjH_ -= rect.top + 30; /* 30͓K */

		/* hbO&hbvΉ */
		drop_.set(this, &viewList_);
	}

	void onSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		int width = LOWORD(lParam);
		int height = HIWORD(lParam);

		height -= adjH_;
		MoveWindow(viewList_.getHandle(), 0, adjH_, width, height, TRUE);
	}

	void addFile(const char *selectedFile = 0)
	{
		if (underProcessing_) return;
		OnceEnter once(underProcessing_);

		using namespace MIE_TC;
		std::string file;
		if (selectedFile) {
			file = selectedFile;
		} else {
			char fileBuf[MAX_PATH];
			if (!MIE::selectFile(NULL, fileBuf, sizeof(fileBuf), "*." TC_SUF)) return;
			file = fileBuf;
		}
		TimeInfo timeInfo;
		if (!TSdecoder::getTimeInfo(timeInfo, &file[0])) {
			MIE::messageBox(NULL, "G[", MB_OK | MB_ICONWARNING, "s"TC_SUF"t@Cł");
			return;
		}
		int n;
		char dspTime[32];
		FormatTime(dspTime, timeInfo);

		if (viewList_.getItemKeyIdx(file) >= 0) {
			/* ɑ݂ */
			return;
		}
		n = viewList_.add(file);
		viewList_.change(n, DEC_TIME_NO, dspTime);
		fileList_.insert(DecodeFileList::value_type(timeInfo, file));
//		dump();
	}

	void queryDecode(const char *address)
	{
		if (underProcessing_) return;
		OnceEnter once(underProcessing_);

		using namespace MIE_TC;
		TimeInfo nowTime;
		nowTime.setNow();

		DecodeFileList::iterator itr = fileList_.begin();
		while (itr != fileList_.end()) {
			const TimeInfo& currTime = itr->first;
			const int waitSec = -1;
			/*
				̏uԂɎɂĂv̂ꂩƂȂƂ̂ňb҂
			*/
			if (currTime.isNewerThan(nowTime, waitSec)) {
				return;
			}
			const std::string& inName = itr->second;
			std::string outName = inName.substr(0, inName.size() - 4); /* 4 = ".tce" */

			bool doVerify = doVerify_.getState() == MIE::ButtonCtl::CHECKED;
			if (doVerify) {
				std::ifstream ifs(outName.c_str());
				if (ifs) {
					int ret = parent_.messageBox("㏑mF", MB_YESNO, "%s݂܂D㏑Ă悢ł", outName.c_str());
					if (ret != IDYES) goto REMOVE_ITEM;
				}
			}
			if (TSdecoder::decodeContents(inName.c_str(), address, publicKey_, outName.c_str())) {
				parent_.messageBox("G[", MB_OK, "%s̕Ɏs܂", outName.c_str());
				goto REMOVE_ITEM;
			}
			if (doView_.getState() == MIE::ButtonCtl::CHECKED) {
				ShellExecute(NULL, NULL, outName.c_str(), NULL, NULL, SW_SHOWNORMAL);
			} else {
				parent_.messageBox("I", MB_OK, "%s𕜍܂", outName.c_str());
			}
		REMOVE_ITEM:
			int n = viewList_.getItemKeyIdx(inName.c_str());
			viewList_.del(n);
			fileList_.erase(itr++);
//			dump();
		}
	}
};

LRESULT ListViewCtlWithDrop::wndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	/* ňȂ܂ */
	if (oldWndProc_) {
		if (msg == WM_DROPFILES) {
			char name[MAX_PATH];
			HDROP hDrop = (HDROP)wParam;
			int num = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, sizeof(name));
			for (int i = 0; i < num; i++) {
				DragQueryFile(hDrop, i, name, sizeof(name));
				if (isEncodedFileName(name)) {
					decodedFileListView_->addFile(name);
				}
			}
			DragFinish(hDrop);
			return TRUE;
		}
		return CallWindowProc(oldWndProc_, hWnd, msg, wParam, lParam);
	}
	if (isDialog_) return FALSE;
	// łȂꍇ̓ftHg̃EBhEvV[WĂ
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

void ListViewCtlWithDrop::set(DecodeFileListView *decodedFileListView, MIE::ListViewCtl *viewList)
{
	decodedFileListView_ = decodedFileListView;
	attach(viewList->getHandle());
}

class ServerAddress : public MIE::EditBoxCtl {
private:
	std::string address_;

	static void handler(int state, void *arg)
	{
		ServerAddress *p = reinterpret_cast<ServerAddress*>(arg);
		p->address_ = reinterpret_cast<char*>(state);
	}
public:
	ServerAddress()
	{
	}
	bool create(HWND parent, int id)
	{
		return EditBoxCtl::create(parent, id, TIME_SERVER_ADDRESS, handler, reinterpret_cast<void*>(this));
	}
	const char *get() const { return address_.c_str(); }
	void set(const char *address)
	{
		address_ = address;
		setText(address_.c_str());
	}
};

class DialogMain : /*public MIE::ThreadBase,*/ public MIE::BaseDialog {
public:
	DialogMain(int argc, char *argv[])
		: argc_(argc)
		, argv_(argv)
	{
	}
private:
	AboutDlg aboutDlg_;
	ClockString clock_;
	DecodeFileListView fileListView_;
	/* Íp */
	MIE::EditBoxCtl fileName_;
	MIE::WindowHandle dayStr_;
	MIE::WindowHandle timeStr_;
	MIE_TC::TSencoder encoder_;
	MIE_TC::PublicKey publicKey_;
	char file_[MAX_PATH];

	ServerAddress serverAddress_;
	MIE::WinConfigFile config_;
	char cgiPath_[128];
	Seed seed_;
	HICON smallIcon_;
	HMENU trayMenu_;
	NOTIFYICONDATA notifyIcon_;

	int argc_;
	char **argv_;

	/*
		WM_INITDIALOGnh
		
	*/
	void onInitDialog(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		{
			char buf[MAX_PATH];
			::GetModuleFileName(NULL, buf, sizeof(buf));
			::PathRemoveFileSpec(buf);
			::PathAddBackslash(buf);
			std::string pubName(buf);
			pubName += PUBLIC_KEY_FILE;

			std::ifstream ifs(pubName.c_str(), std::ios::binary);
			bool isOK = false;
			if (ifs) {
				std::string line;
				std::getline(ifs, line, '\0');
				isOK = publicKey_.set(line.c_str());
			}
			if (!isOK) {
				messageBox("ERROR", MB_OK | MB_ICONWARNING, "J%sJ܂DI܂", pubName.c_str());
			}
		}

		config_.create(INI_FILE);
		char address[256];
		if (!config_.get(SECTION, KEY_ADDRESS, address, sizeof(address)) || *address == 0) {
			strcpy(address, TIME_SERVER_ADDRESS);
		}
		if (!config_.get(SECTION, KEY_CGI_PATH, cgiPath_, sizeof(cgiPath_)) || *cgiPath_ == 0) {
			strcpy(cgiPath_, CGI_PATH);
		}

		// 

		aboutDlg_.create(hWnd, IDD_ABOUT_DLG);
		// ICON̕ύX
		{
			HICON icon;
			icon = LoadIcon(hInst_, MAKEINTRESOURCE(IDI_CLOCK));
			::SendMessage(hWnd_, WM_SETICON, ICON_BIG, (LPARAM)icon);
			smallIcon_ = LoadIcon(hInst_, MAKEINTRESOURCE(IDI_CLOCK_S));
			::SendMessage(hWnd_, WM_SETICON, ICON_SMALL, (LPARAM)smallIcon_);
		}

		/* Íp */

		fileName_.create(hWnd, IDC_FILE_ORG_NAME, "");
		dayStr_.setHandle(GetDlgItem(hWnd, IDC_DAY));
		timeStr_.setHandle(GetDlgItem(hWnd, IDC_TIME));

		/* p */

		clock_.setHandle(GetDlgItem(hWnd, IDC_TIMER));
		serverAddress_.create(hWnd, IDC_SERVER_ADDRESS);
		serverAddress_.set(address);
		fileListView_.init(hWnd, &config_, &publicKey_);

		/* gCp */
		{
			HMENU menu;
			menu = LoadMenu(hInst_, MAKEINTRESOURCE(IDR_MENU_TRAY));
			trayMenu_ = GetSubMenu(menu, 0);

			notifyIcon_.cbSize = sizeof(NOTIFYICONDATA);
			notifyIcon_.uID = TRAY_ID;
			notifyIcon_.hWnd = hWnd;
			notifyIcon_.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
			notifyIcon_.hIcon = smallIcon_;
			notifyIcon_.uCallbackMessage = WM_MYTRAY;
			strcpy(notifyIcon_.szTip, "^CJvZÍ");
		}

		/* `FbN */
		{
			int argc = argc_;
			char **argv = argv_;
			argc--, argv++;
			while (argc > 0) {
				const char *name = *argv;
				if (isEncodedFileName(name)) {
					fileListView_.addFile(name);
				} else {
					fileName_.setText(name);
				}
				argc--, argv++;
			}
		}

		/* 傫 */
		RECT rect;
		GetClientRect(hWnd, &rect);
		onSize(hWnd, SIZE_RESTORED, rect.right | (rect.bottom << 16));
		beVisible();

		/* 荞݃nh */
		SetTimer(hWnd, IDC_TIMER, 300 /* msec */, NULL);
	}

	/*
		Ípt@CZN^
	*/
	void setFileName()
	{
		if (selectFile(file_, sizeof(file_), "*.*")) {
			fileName_.setText(file_);
		}
	}
	/*
		̐`
		dayStr  = "2005/05/14"
		timeStr = "17:45:23"
	*/
	void formatTime(char *decTime, const char *dayStr, const char *timeStr)
	{
		int year, month, day;
		int hour, minute, second;
		sscanf(dayStr, "%d/%d/%d", &year, &month, &day);
		sscanf(timeStr, "%d:%d:%d", &hour, &minute, &second);
		sprintf(decTime, "%4d%02d%02d%02d%02d%02d", year, month, day, hour, minute, second);
	}
	/*
		Í
	*/
	void doEncode()
	{
		char fileName[MAX_PATH];
		fileName_.getText(fileName, sizeof(fileName));
		if (*fileName == '\0') {
			messageBox("G[", MB_OK | MB_ICONWARNING, "t@Cw肵Ă");
			return;
		}
		char decTime[32];
		{
			char dayStr[32], timeStr[32];
			dayStr_.getText(dayStr, sizeof(dayStr));
			timeStr_.getText(timeStr, sizeof(timeStr));
			formatTime(decTime, dayStr, timeStr);
		}
		if (encoder_.encodeFile(publicKey_, fileName, decTime, seed_.get()) == 0) {
			messageBox("I", MB_OK, "%s." TC_SUF "쐬܂", fileName);
		} else {
			messageBox("G[", MB_OK | MB_ICONWARNING, "ÍɎs܂");
		}
	}

	/*
		WM_TIMERnh
	*/
	void onTimer(HWND, WPARAM , LPARAM)
	{
		seed_.update();
		clock_.updateTime();
		fileListView_.queryDecode(serverAddress_.get());
	}

	/*
		WM_SIZEnh
	*/
	void onSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		fileListView_.onSize(hWnd, wParam, lParam);
	}

	/*
		gCj[
	*/
	void onRButtonUpOnTray(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		POINT pt;
		GetCursorPos(&pt);
		/*
			ACRc
			http://support.microsoft.com/default.aspx?scid=http://support.microsoft.com:80/support/kb/articles/Q135/7/88.asp&NoWebContent=1
		*/
		SetForegroundWindow(hWnd);
		TrackPopupMenu(trayMenu_, TPM_BOTTOMALIGN | TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);
		PostMessage(hWnd, WM_NULL, 0, 0);
	}
	/*!
		EBhEvV[W
	*/
	LRESULT wndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		switch (msg) {
		case WM_INITDIALOG:
			onInitDialog(hWnd, wParam, lParam);
			return TRUE;

		case WM_TIMER:
			onTimer(hWnd, wParam, lParam);
			return TRUE;

		case WM_SIZE:
			onSize(hWnd, wParam, lParam);
			return TRUE;

		case WM_CLOSE:
			config_.set(SECTION, KEY_ADDRESS, serverAddress_.get());
			PostQuitMessage(0);
			return TRUE;

		case WM_MYTRAY:
			switch (lParam) {
			case WM_RBUTTONUP:
				onRButtonUpOnTray(hWnd, wParam, lParam);
				return TRUE;
			}
			break;

		case WM_SYSCOMMAND:
			if (wParam == SC_MINIMIZE) {
				goto ENTER_TRAY;
			}
			break;

		case WM_COMMAND:
			// Rg[𑝂₵Ƃ͂ɒǉ邱
			ON_COMMAND(serverAddress_);

			switch (LOWORD(wParam)) {
			case IDC_OPEN_ORG_FILE:
				setFileName();
				return TRUE;

			case IDC_ENCODE:
				doEncode();
				return TRUE;

			case IDC_ABOUT_DLG:
				aboutDlg_.beVisible();
				return TRUE;

			case IDC_ADD_DEC_FILE:
				fileListView_.addFile();
				return TRUE;

			case IDCANCEL:
			case ID_EXIT:
				Shell_NotifyIcon(NIM_DELETE, &notifyIcon_);
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				return TRUE;

ENTER_TRAY:
			case ID_TRAY:
				Shell_NotifyIcon(NIM_ADD, &notifyIcon_);
				ShowWindow(hWnd, SW_HIDE);
				return TRUE;

			case ID_SHOW:
				Shell_NotifyIcon(NIM_DELETE, &notifyIcon_);
				ShowWindow(hWnd, SW_SHOW);
				return TRUE;

			default:
				break;
			}
			break;

		default:
			break;
		}
		return FALSE;
	}
};

class TSboardApp {
public:
	TSboardApp()
	{
		InitCommonControls();
	}

	void run(int argc, char *argv[])
	{
		DialogMain dlgMain(argc, argv);
		dlgMain.create(NULL, IDD_BOARD);

		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0) > 0) {
			if (!dlgMain.processIfDialogMessage(&msg)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
};

int appmain(int argc, char *argv[])
{
	MIE_MEM_Init();
	MIE_TC::init();

	HANDLE uniqHdl = CreateMutex(NULL, TRUE, TIME_CAPSULE_MUTEX);
	if (uniqHdl == NULL || GetLastError() == ERROR_ALREADY_EXISTS) {
		MessageBox(NULL, "ɋNĂ܂", "ERROR", MB_OK | MB_ICONWARNING);
		return 1;
	}

	TSboardApp app;
	app.run(argc, argv);

	ReleaseMutex(uniqHdl);
	return 0;
}

#if 0// consolet
int main(int argc, char *argv[])
{
	return appmain(argc, argv);
}
#else
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	return appmain(__argc, __argv);
}
#endif
