#ifndef WIN_CONFIGFILE_H_
#define WIN_CONFIGFILE_H_
/*!
	Avp[^̑ޔENX
	@author $Author: shigeo $
	@version $Revision: 1.5 $
	@date $Date: 2007/08/25 13:09:10 $
*/
#include <windows.h>
#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")
#if _MSC_VER > 1200
	#pragma warning(push)
	#pragma warning(disable : 4996) /* sscanf */
#endif

namespace MIE {


class WinConfigFile {
private:
	char fileName_[1024];
public:
	WinConfigFile()
	{
		*fileName_ = '\0';
	}

	~WinConfigFile()
	{
		flush();
	}
	/*!
		t@C
		@param fileName [in] init@C
	*/
	bool create(const char *fileName)
	{
		/* init@C͎sW[ƓpXɒu */
		if (!::GetModuleFileName(NULL, fileName_, sizeof(fileName_) - strlen(fileName) - 2)) {
			return false;
		}
		if (!::PathRemoveFileSpec(fileName_)) {
			return false;
		}
		::PathAddBackslash(fileName_);
		strcat(fileName_, fileName);
		return flush();
	}
	/*!
		t@C폜
		@note not implement
	*/
	bool remove()
	{
		return false;
	}
	/*!
		lݒ肷
		@param section [in] ZNV
		@param key [in] 
		@param value [in] l
	*/
	bool set(const char *section, const char *key, const char *value)
	{
		if (*fileName_ == 0) return false;
		return WritePrivateProfileString(section, key, value, fileName_) != 0;
	}
	/*!
		l擾
		@param section [in] ZNV
		@param key [in] 
		@param value [out] l(valueLenmۂĂ邱)
		@param valueLen [in] ܂ő咷(byte)
	*/
	bool get(const char *section, const char *key, char *value, int valueLen) const
	{
		if (*fileName_ == 0) return false;
		return GetPrivateProfileString(section, key, "", value, valueLen, fileName_) > 0;
	}
	/*!
		lݒ肷
		@param section [in] ZNV
		@param key [in] 
		@param value [in] l
	*/
	bool set(const char *section, const char *key, int value)
	{
		char buf[32];
		sprintf(buf, "%d", value);
		return set(section, key, buf);
	}
	/*!
		l擾
		@param section [in] ZNV
		@param key [in] 
		@param value [out] l
	*/
	bool get(const char *section, const char *key, int *value) const
	{
		char buf[32];
		if (get(section, key, buf, sizeof(buf))) {
			*value = atoi(buf);
			return true;
		} else {
			return false;
		}
	}
	/*!
		t@Cւ̔fm
	*/
	bool flush()
	{
		if (*fileName_ == 0) return false;
		return WritePrivateProfileString(0, 0, 0, fileName_) != 0;
	}
};

} // end of namespace

#if _MSC_VER > 1200
	#pragma warning(pop)
#endif

#endif /* WIN_CONFIGFILE_H_ */
