#ifndef MTT_ALIGNED_NEW_H_
#define MTT_ALIGNED_NEW_H_
/*!
	@brief JX^}CYꂽnew
	@file $RCSfile: aligned_new.h,v $
	@version $Revision: 1.7 $
	@date $Date: 2007/08/28 06:51:38 $
*/

#include <new>
#include <cstdlib>

/*
	alignment ꂽ|C^Ԃ
*/

const int MEMORY_ALIGN_SIZE = 16; // 16byte Eɂ낦
const size_t FREQUENCY_ALLOCATE_SIZE = 160; // mۂTCY̑傫ȉ͍̎ɏ

extern "C" void* FAS_alloc();
extern "C" void  FAS_free(void*);
extern "C" void *alignedMalloc(size_t size) throw();

inline void *alignedMallocFast(size_t size) throw()
{
	void* result;
	if (size <= FREQUENCY_ALLOCATE_SIZE) {
		result =  FAS_alloc();
	} else {
		result = alignedMalloc(size);
	}
	return result;
}

inline void alignedFreeFast(void *ptr)
{
	if (ptr) {
		if (*(reinterpret_cast<void**>(ptr) - 1) != NULL) {
			std::free(*(reinterpret_cast<void**>(ptr) - 1));
		}
		else {
			FAS_free(ptr);
		}
	}
}

template <class T>
inline T* new_t(int size)
{
	return (T*)alignedMallocFast(sizeof(T) * size);
//	return (T*)_aligned_malloc(sizeof(T) * size, 16);
}

inline void delete_t(void *ptr)
{
	alignedFreeFast(ptr);
//	_aligned_free(ptr);
}

#endif /* MTT_ALIGNED_NEW_H_ */
