#ifndef MTT_BIT_REP_H_
#define MTT_BIT_REP_H_

#include "field_base.h"
#include "field_fq.h"
#include "field_fm.h"

namespace MTT {

// ==========================================================================
/*!
	@brief MttBits: F_q  F_m  bit \
	@file $RCSfile: bit_rep.h,v $
	@version $Revision: 1.7 $
	@date $Date: 2007/08/30 02:09:07 $
	@note {I bit ZoΗǂ
*/

class MttBits : public MttBitsBase {
// public member functions
public:
	// window operation constant
	enum {
		op_double = 0,
		op_add,
		op_sub
	};
	
	// ctors
	MttBits(MttFp const& fp) : p_value_(sf_init_object_p(fp.getValue())), bit_(""), naf_("") {}
	MttBits(MttFm const& fm) : p_value_(sf_init_object_m(fm.getValue())), bit_(""), naf_("") {}
	
	// dtors
	~MttBits() { sf_delete(p_value_); }
	
	// accessors
	void const* getValue() const { return p_value_; }
	char const* toStr() const { return sf_get_str(p_value_); }
	
	// operators
	MttBits& operator=(MttBits const& bits) {
		if(&bits != this) {
			sf_delete(p_value_);
			p_value_ = sf_copy(bits.p_value_);
		}
		return *this;
	}
	
	// operations
	void setBit(int digit, bool bit) { sf_set_bit(p_value_, digit, bit); }
	bool isBitOn(int digit) const { return sf_bit(p_value_, digit); }
	int numBits() const { return sf_num_bits(p_value_); }

	// window operations
	void init_window_naf_5bit() const { init_window_naf(); mode_ = mode_naf_5bit; }
	void init_window_naf_5bit_7half() const { init_window_naf(); mode_ = mode_naf_5bit_7half; }
	bool next_op(int& op, int& num) const;
	
// the member
protected:
	enum{
	  mode_5bit = 0,
	  mode_naf_5bit,
	  mode_naf_5bit_7half
	};
	void* p_value_;
	mutable int mode_;
	mutable std::string bit_, naf_;
	mutable std::string::reverse_iterator it_naf_5bit_;
	void init_window_naf() const;

// class initializer
public:
};

} // end of namespace

#endif

