#ifndef MIE_BITS_BASE_H_
#define MIE_BITS_BASE_H_

namespace MTT {

class MttBitsBase {
public:
	static void setup();
protected:
	
	// for ctor/dtor
	static void* sf_init_object_p(void const*);
	static void* sf_init_object_m(void const*);
	static inline void* sf_copy(const void* obj)
	{
		uint32 const* p_ua = reinterpret_cast<uint32 const*>(obj);
		uint32 *p = new_t<uint32>(16);
		ua_copy(p_ua, p, 16);
		return p;
	}
	static inline void sf_delete(void* obj)
	{
		uint32 * p_ua = reinterpret_cast<uint32 *>(obj);
		delete_t(p_ua);
	}
	
	// for access
	static inline char const* sf_get_str(void const*)
	{
		return "[ua library has no string output]";
	}

	// for operation
	static inline void sf_set_bit(void* obj, int digit , bool bit)
	{
		uint32 * p_ua = reinterpret_cast<uint32 *>(obj);
		ua_set_bit(p_ua, digit, bit, 16);
	}
	static inline bool sf_bit(const void* obj, int digit)
	{
		uint32 const* p_ua = reinterpret_cast<uint32 const*>(obj);
		return ua_get_bit(p_ua, digit, 16);
	}

	/* IuWFNg bit ߂ */
	static inline int sf_num_bits(const void* obj)
	{
		uint32 const* p_ua = reinterpret_cast<uint32 const*>(obj);
		return ua_get_bitlength(p_ua, 16);
	}
private:
	static inline void ua_set_bit(uint32* p, int digit, bool bit, int len)
	{
		assert(digit < len*32);
		uint32 mask = (uint32)1<<(digit%32);
		if (bit ) {
			p[digit/32] |= mask;
		} else {
			p[digit/32] &= (~mask);
		}
	}
	/* IuWFNg bit ̓ǂ݂Ƃ */
	static inline bool ua_get_bit(uint32 const* p, int digit, int len)
	{
		assert(digit < len*32);
		uint32 bit = uint32(1) << (digit & 31);
		return (p[digit/32] & bit) == bit;
	}
};

} // end of namespace

#endif /* MIE_BITS_BASE_H_ */
