#ifndef CPU_STATE_H_
#define CPU_STATE_H_
/*!
	@brief CPU ̏Ԃ擾NX
	@file $RCSfile: cpu_state.h,v $
	@version $Revision: 1.5 $
	@date $Date: 2007/08/30 02:09:07 $
*/

#include <string>

namespace MTT {
class Ccpu {
private:
	enum {
		tFPU = 1<<0,
		tMMX = 1<<1,
		t3DN = 1<<2,
		tSSE = 1<<3,
		tCMOV = 1<<4,
		tE3DN = 1<<5,
		tEMMX = 1<<6,
		tSSE2 = 1<<7,
		tCLFLUSH = 1<<18,

		tMULTI = 1<<12,

		tINTEL = 1<<8,
		tAMD = 1<<9,
		tCYRIX = 1<<10,
		tIDT = 1<<11,
		tUNKNOWN = 1<<15,

		tFAMILY4 = 1<<20,
		tFAMILY5 = 1<<21,
		tFAMILY6 = 1<<22,
		tFAMILY7 = 1<<23,

		tPPC = 1<<0,
		tALTIVEC = 1<<3,

		tARM = 1<<0,
		tMIPS = 1<<0
	};
	int unit;
	int haveUNIT(void) const;

public:
	Ccpu();
	bool hasFPU(void) const { return (unit & tFPU) != 0; }
	bool hasMMX(void) const { return (unit & tMMX) != 0; }
	bool has3DN(void) const { return (unit & t3DN) != 0; }
	bool hasSSE(void) const { return (unit & tSSE) != 0; }
	bool hasCMOV(void) const { return (unit & tCMOV) != 0; }
	bool hasE3DN(void) const { return (unit & tE3DN) != 0; }
	bool hasEMMX(void) const { return (unit & tEMMX) != 0; }
	bool hasSSE2(void) const { return (unit & tSSE2) != 0; }
	bool hasCLFLUSH(void) const { return (unit & tCLFLUSH) != 0; }

	bool isINTEL(void) const { return (unit & tINTEL) != 0; }
	bool isAMD(void) const { return (unit & tAMD) != 0; }
	bool isCYRIX(void) const { return (unit & tCYRIX) != 0; }
	bool isIDT(void) const { return (unit & tIDT) != 0; }
	bool isUNKNOWN(void) const { return (unit & tUNKNOWN) != 0; }

	int family(void) const { return unit & tFAMILY4 ? 4   // 486 vendor maybe isn't correct
									: unit & tFAMILY5 ? 5 // 586 (P5, P5-MMX, K6, K6-2, K6-III)
									: unit & tFAMILY6 ? 6 // 686 above P-Pro, P-II, P-III, Athlon
									: unit & tFAMILY7 ? 7 // Pentium 4 or over
									: -1; }
	bool isPPC(void) const { return (unit & tPPC) != 0; }
	bool hasALTIVEC(void) const { return (unit & tALTIVEC) != 0; }

	// ԕ\
	const std::string toString() const;
};

} // end of namespace

#endif // CPU_STASTE_H_
