#ifndef MTT_FIELD_FM_H_
#define MTT_FIELD_FM_H_

#include "field_base.h"

namespace MTT {

// ==========================================================================
/*!
	@brief MttFm: L F_m (m = (p+1)/6:f, p: 512bitf)̉ZNX
	@file $RCSfile: field_fm.h,v $
	@version $Revision: 1.8 $
	@date $Date: 2007/08/30 02:09:07 $
*/
// Z +=, -=, *=, inverse(), clear(), normalize() T|[g
// normalize() Ȃ normalize() Ă邱Ƃۏ؂ȂB
// ܂̂Ƃ is_zero() ͐ʂԂƂ͌ȂB
// ctor̓iVAFmA{^T|[g
// FmA{^T|[g
//

class MttFm : public MttFmBase {
// public member functions
public:
	// ctors
	MttFm(MttFm const& fm) : p_value_(sf_copy(fm.p_value_)) {}
	explicit MttFm(char const* i_str) : p_value_(sf_init_str(i_str)) {}
	explicit MttFm(int x = 0) : p_value_(sf_init_value(x)) {}
	
	// dtor
	~MttFm() { sf_delete(p_value_); }
	
	// accessors
	void const* getValue() const { return p_value_; }
	char const* toStr() const { return sf_get_str(p_value_); }
	void show() const { sf_show(p_value_); }
	
	// operators
	MttFm& operator=(MttFm const& fm) {
		if(&fm != this) {
			sf_delete(p_value_);
			p_value_ = sf_copy(fm.p_value_);
		}
		return *this;
	}
	MttFm& operator=(char const* i_str) {
		sf_delete(p_value_);
		p_value_ = sf_init_str(i_str);
		return *this;
	}
	MttFm& operator=(int x) {
		sf_delete(p_value_);
		p_value_ = sf_init_value(x);
		return *this;
	}
	MttFm& operator+=(MttFm const& fm) {
		sf_add(p_value_, fm.p_value_, p_value_);
		return *this;
	}
	MttFm& operator-=(MttFm const& fm) {
		sf_sub(p_value_, fm.p_value_, p_value_);
		return *this;
	}
	MttFm& operator*=(MttFm const& fm) {
		sf_mul(p_value_, fm.p_value_, p_value_);
		return *this;
	}
	
	// operations
	void inverse() { sf_inverse(p_value_); }
	void normalize() { sf_normalize(p_value_); }
	void clear() { sf_clear(p_value_); }
	void changeSign() { sf_change_sign(p_value_); }
	bool isZero() const { return sf_is_zero(p_value_); }

// the member
protected:
	void* p_value_;

// class initializer
public:
};

} // end of namespace

#endif

