#include "common.h"
#include "implementation.h"
#include "field_base.h"
#include "cpu_state.h"
#include <cmath>

#define ONLY_SSE2

using namespace MTT;

static Ccpu cpu;

// 񐳋KԂ̒
#define MI_SIZE 20
// KԂ̒
#define MI_MOD_SIZE 16

static uint32 mi_p[MI_SIZE], mi_1[MI_SIZE], mi_2[MI_SIZE];

inline void mi_mod(uint32* mi)
{
	//512bitȏ̕ꊇ
	if ((mi[19] | mi[18] | mi[17] | mi[16]) != 0) {
		// X * 2^512 + = X * (2^384 -2^160 +2^128 +2^64 +1) +
		uint32 add[16];
		uint32 tmp[15];

		ua_clear(add+8, 4);
		ua_clear(tmp+4, 11);

		//(+2^384 +2^128   +1)	 (+2^64 -2^160)
		add[15] = add[7] = add[3] = tmp[3] = mi[19];
		add[14] = add[6] = add[2] = tmp[2] = mi[18];
		add[13] = add[5] = add[1] = tmp[1] = mi[17];
		add[12] = add[4] = add[0] = tmp[0] = mi[16];

		//clear
		mi[19] = mi[18] = mi[17] = mi[16] = 0;

		if (ua_add(mi, add, mi, 16) ) mi[16] = 1; //(+2^384 +2^128 +1)
		ua_add(mi+2, tmp, mi+2, 17-2); //(+2^64)
		ua_sub(mi+5, tmp, mi+5, 17-5); //(-2^160)
	}

	//512bitȉ(Jオ512bit1̏ꍇ͂肦)̕
	//if (mi >= mod) then mi -= mod
	if (ua_cmp(mi, mi_p, MI_MOD_SIZE+1) >=0) ua_sub(mi, mi_p, mi, MI_MOD_SIZE+1);
}

// @note ̊֐̕ԂĺAimp_delete() ŉB

static void* imp_init_value_mi_fp(int v)
{
	uint32 *mi = new_t<uint32>(MI_SIZE);
	ua_init_from_int_mod(v, mi_p, MI_SIZE, mi, MI_SIZE);
	return mi;
}

/*
	񒷂uint32[]̔z񒷂߂
 */

static inline int str_length_to_uint32_length(int str_length)
{
	return (int)(str_length * std::log(10.0)/std::log(2.0) / 32.0) + 1; /* 32bitił̌ */
}

/*
	10imodulo32bitiɕϊ.
	input  : str (10i)
	         mod (modulo, 0łǂ)
	         mod_len (mod̔z, mod=0̏ꍇ0ɂ)
	         ua_len  (ua̔z)
	output : ua (little endian  num[0] ŉ, z񒷂mod_lenȏmۂĂ)
	return : ϊ̕(32bit P)
	         -1 (G[)
*/

int MTT::ua_init_from_str_mod(char const* str, uint32 const* mod, unsigned int mod_len, uint32* ua, unsigned int ua_len)
{
	assert(str != 0 && ua != 0);

	unsigned int i, str_len, tmp_len, out_len;
	uint32 *tmp;

	int result = -1;

	/* 񒷂Ɣz񒷂`FbN */
	str_len = strlen(str);
	if (str_len == 0) return -1;
	if (mod_len > ua_len) return -1;

	tmp_len = str_length_to_uint32_length(str_len);
	if (tmp_len < mod_len) tmp_len = mod_len;

	/* ->l ϊp̈ꎞz쐬 */
	tmp = new_t<uint32>(tmp_len+1); /* ua_mul_s ̌p+1 */
	ua_clear(tmp, tmp_len+1);

	/* 10iƂĕϊ݂ */
	{
		uint32 *stmp = new_t<uint32>(tmp_len);
		ua_clear(stmp, tmp_len);
		/* ʌ珇ɓǂݍ */
		for (i = 0; i < str_len; i++) {
			/*  */
			if (i == 0 && str[0] == '+') continue;
			if (i == 0 && str[0] == '-') continue; /* ̏͂܂ */
			/* l */
			sint32 digit;
			digit = str[i] - '0';
			if (digit < 0 || digit > 9) break;
			ua_mul_s(tmp, 10, tmp, tmp_len);  /* tmp  10{ */
			stmp[0] = (uint32)digit;		  /* digit  tmp ɉ */
			ua_add(tmp, stmp, tmp, tmp_len);
		}
		if (i == str_len) result = 1;
		delete_t(stmp);
	}

	/* sȌ` */
	if (result < 0) {
		delete_t(tmp);
		return result;
	}

	/* mod */
	if (mod != 0) {
		/* mod̃Rs[(ua_div̔zv邽) */
		uint32 *tmod = new_t<uint32>(tmp_len);
		ua_copy(mod, tmod, mod_len);
		if (tmp_len > mod_len) ua_clear(tmod+mod_len, tmp_len-mod_len);
		ua_div(tmp, tmod, tmod, tmp, tmp_len);
		delete_t(tmod);
	}

	/* ̏f[^Rs[ */
	if (str[0] == '-') {
		if (mod == 0) {
			result = -1;
		} else {
			ua_sub(mod, tmp, ua, mod_len);
			if (ua_len > mod_len) ua_clear(ua+mod_len, ua_len-mod_len);
		}
	} else {
		if (mod == 0) {
			if (tmp_len < ua_len) {
				ua_copy(tmp, ua, tmp_len);
				ua_clear(ua+tmp_len, ua_len-tmp_len);
			} else {
				ua_copy(tmp, ua, ua_len);
			}
		} else {
			ua_copy(tmp, ua, mod_len);
		}
	}

	/* ȉňꉞmF */

	/* {̌T */
	out_len = ua_get_length(tmp, tmp_len);
	/* 0Ȃ1Ƃ */
	if (out_len == 0) out_len = 1;
	result = out_len;

	/* KvȔz񒷂Z */
	if (out_len > ua_len) result = -1;

	delete_t(tmp);
	return result;
}

static void* imp_init_str_mi_fp(char const* str)
{
	uint32 *mi = new_t<uint32>(MI_SIZE);
	ua_init_from_str_mod(str, mi_p, MI_SIZE, mi, MI_SIZE);
	return mi;
}

/*
	0ȏ10i32bitiɕϊ.
	input  : str (10i)
	         ua_len (ua̔z)
	output : ua (little endian  num[0] ŉ, z񒷂ua_get_ua_length_from_str(str)ȏmۂĂ)
	return : ϊ̕(32bit P)
	         -1 (G[)
 */

int MTT::ua_init_from_str(char const* str, uint32* ua, unsigned int ua_len)
{
	return ua_init_from_str_mod(str, 0, 0, ua, ua_len);
}
/*
	(dat & 0xFFFFFFFF) 32bitiɕϊ. 0x80000000 ͕s
	signɕԂAuaɂ͔fȂ
	input  : dat (int)
	         ua_len  (ua̔z)
	output : ua (little endian  num[0] ŉ)
	         sign (Ԃ -1:, 0:, 1:)
	return : 0ȏ ()
	         -1 (G[)
*/

int MTT::ua_init_from_int(int dat, uint32* ua, unsigned int ua_len, int* sign)
{
	assert(ua != 0 && sign != 0);

	ua_clear(ua, ua_len);
	if (dat > 0) {
		*sign = 1;
		ua[0] = dat;
	} else
	if (dat < 0) {
		*sign = -1;
		ua[0] = -dat;
	} else
	{
		*sign = ua[0] = 0;
	}
	return 1;
}

/*
	(dat & 0xFFFFFFFF)  32bit tƂĈ.@0x80000000 ͕s
	input  : dat (int)
			 mod (modulo)
			 mod_len (mod̔z)
			 ua_len  (ua̔z)
	output : ua (little endian  num[0] ŉ, z񒷂mod_lenȏmۂĂ)
	return : 0ȏ ()
			 -1 (G[)
*/

int MTT::ua_init_from_int_mod(int dat, uint32 const* mod, unsigned int mod_len, uint32* ua, unsigned int ua_len)
{
	assert(mod != 0 && ua != 0);
	assert(ua_len >= mod_len);

	// 
	bool minus = (dat < 0);

	// ꎞz쐬
#ifdef USE_ALLOCA
	uint32 *tmp = (uint32*)ALLOCA(ua_len * sizeof(uint32));
	uint32 *tmod = (uint32*)ALLOCA(ua_len * sizeof(uint32));
#else
	uint32 *tmp = new_t<uint32>(ua_len);
	uint32 *tmod = new_t<uint32>(ua_len);
#endif

	// lݒ
	ua_clear(tmp, ua_len);
	tmp[0] = abs(dat);

	// mod̃Rs[(ua_div̔zv邽)
	ua_copy(mod, tmod, mod_len);
	if (ua_len > mod_len) ua_clear(tmod+mod_len, ua_len-mod_len);

	ua_div(tmp, tmod, tmp, tmod, ua_len);
	ua_copy(tmod, ua, ua_len);

	// ̔f
	if (minus) {
		ua_sub(mod, ua, ua, mod_len);
	}

#ifndef USE_ALLOCA
	delete_t(tmp);
	delete_t(tmod);
#endif
	return 1;
}

/*
	uint32[]𕶎ɕϊۂɕKvƂȂz񒷂Ԃ
	ۂɕKvȒⒷlԂꍇ
 */

static int ua_get_str_length_from_ua_length(unsigned int ua_len)
{
	return (int)(ua_len * 32.0 * log(2.0) / log(10.0)) + 1;
}

/*
	Ȃ32biti10iɕϊ.
	input  : ua (little endian  num[0] ŉ)
			 ua_len  (ua  32bit Pʂł̒)
			 str_len (str ̔z)
	output : str (10i, '\0'I[)
	return : ϊ̕, '\0'
			 -1 (G[)
 */

int MTT::ua_convert_to_str(uint32 const* ua, unsigned int ua_len, char* str, unsigned int str_len)
{
	assert(ua != 0 && str != 0 && str > 0);

	unsigned int i, dest_len, out_len;
	uint32 *tmp, *stmp;
	char *dest;

	if (str_len < 2) {
		str[0] = '\0';
		return -1;
	}

	if (ua_len <= 0) {
		str[0] = '0';
		str[1] = '\0';
		return 1;
	}

	dest_len = ua_get_str_length_from_ua_length(ua_len);

	tmp  = new_t<uint32>(ua_len);
	stmp = new_t<uint32>(ua_len);
	dest = new_t<char>(dest_len + 1);
	ua_copy(ua, tmp, ua_len);
	ua_clear(stmp, ua_len);
	memset(dest, 0, dest_len + 1);

	out_len = 0;
	do {
		stmp[0] = 10;
		/* in: tmp / (stmp=10), out: tmp * 10 + stmp */
		ua_div(tmp, stmp, tmp, stmp, ua_len);
		dest[out_len] = (char)('0' + stmp[0]);
		out_len++;
		assert (out_len <= dest_len);
	} while (!ua_is_zero(tmp, ua_len));

	delete_t(tmp);
	delete_t(stmp);

	/* '\0'ŏI[邾̒Kv */
	if (str_len <= out_len) {
		delete_t(dest);
		str[0] = '\0';
		return -1;
	}

	/* ㉺ւ */
	for (i = 0; i < out_len; i++) {
		str[i] = dest[out_len - 1 - i];
	}
	str[out_len] = '\0';

	delete_t(dest);
	return out_len;
}


// IuWFNg̕

static const char* imp_get_str_mi_fp(void const* obj)
{
	uint32 const* p_mi = reinterpret_cast<uint32 const*>(obj);
	uint32 tmp[MI_SIZE];
	ua_copy(p_mi, tmp, MI_SIZE);
	static char string_buf[MI_SIZE*10];
	
	mi_mod(tmp);
	ua_convert_to_str(tmp, MI_MOD_SIZE, string_buf, sizeof(string_buf));
	return string_buf;
}

// imp̃ZbgAbv

void MTT::MttBitsBase::setup()
{
	// mi 萔
	ua_set_uint(uint32(1), mi_1, MI_SIZE);
	ua_set_uint(uint32(2), mi_2, MI_SIZE);

	// p
	ua_init_from_str(TEXT_PARAM_P, mi_p, MI_SIZE);
}

// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// 璷64bit(32bitd)Œ蒷modt{ r64modint

// 璷Ɣz񒷂2{ɂȂ鎖ɒ
// 񐳋KԂ̒ = KԂ̒
// zŏʂ͉Z񐔂ێKtO
#define R64_SIZE 16 // implementation4a.nas Ƃ̐
#define R64_EXTSIZE (R64_SIZE+1)

// ---------------------------------------------------------------------
// p ̎̂Ȃ

uint64 *MttFpBase::r64_p;
static uint32 ua_4m_1[MI_MOD_SIZE], ua_pp1d4[MI_MOD_SIZE];
static uint64 *r64_0;

// ---------------------------------------------------------------------
// ֐؂ւ

extern "C" {
void r64_asm_init(uint64 const* r64_p_);
void r64_add_SSE2(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);
void r64_sub_SSE2(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);
void r64_change_sign_SSE2(uint64* r64);
uint64 r64_r64normalize_x86(uint64* r64);
uint64 r64_r64normalize_SSE2(uint64* r64);
void r64_semimod_SSE2(uint64* r64);
void r64_mul_simple_SSE2(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst, int len);
void r64_square_simple_SSE2_len8(uint64 const* p_src, uint64* p_dst, int dummy);
void r64_mul_karatsuba_SSE2(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);
void r64_square_karatsuba_SSE2(uint64 const* p_src, uint64* p_dst);
void r64_long_mod_SSE2(uint64* p_dst);
void r64_mul_SSE2(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);
}


static void r64_mod(uint64* r64);

#ifdef ONLY_SSE2
	#define r64_add r64_add_SSE2
	#define r64_sub r64_sub_SSE2
	#define r64_change_sign r64_change_sign_SSE2
	#define r64_r64normalize r64_r64normalize_SSE2
	#define r64_semimod r64_semimod_SSE2
	#define r64_mul_simple r64_mul_simple_SSE2
	#define r64_square_simple r64_square_simple_SSE2_len8
	#define r64_mul_karatsuba r64_mul_karatsuba_SSE2
	#define r64_square_karatsuba r64_square_karatsuba_SSE2
	#define r64_long_mod r64_long_mod_SSE2
	#define r64_mul r64_mul_SSE2
#else
static void r64_add(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);
static void r64_sub(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);
static void r64_change_sign(uint64* r64);
static uint64 r64_r64normalize(uint64* r64);
static void r64_semimod(uint64* r64);
static void r64_mul_simple(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst, int len);
static void r64_square_simple(uint64 const* p_src, uint64* p_dst, int len);
static void r64_mul_karatsuba(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);
static void r64_square_karatsuba(uint64 const* p_src, uint64* p_dst);
static void r64_long_mod(uint64* p_dst);
static void r64_mul(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst);

inline sint64 SAR64(sint64 x, uint32 s) { return x>>s; }
#ifdef __GNUC__
	/* GCC̈ꕔ̃o[Wlong long^萔̍ŌLLKvƂ */
	#define CUINT64(x)  ((uint64)x ## LL)
#else
	#define CUINT64(x)  ((uint64)x)
#endif

// ---------------------------------------------------------------------
// Z

// C: 310clk on P4
static void r64_add(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst)
{
	for(int i=0; i<R64_SIZE; i++) p_dst[i] = p_src1[i] + p_src2[i];

	p_dst[R64_SIZE] = p_src1[R64_SIZE] + p_src2[R64_SIZE] + 1;
	if (p_dst[R64_SIZE] >= (CUINT64(1)<<30) -1) {
		r64_semimod(p_dst);
	}
}

// ---------------------------------------------------------------------
// Z

// C: 310clk on P4
static void r64_sub(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst)
{
	for(int i=0; i<R64_SIZE; i++) p_dst[i] = p_src1[i] - p_src2[i];

	p_dst[R64_SIZE] = p_src1[R64_SIZE] + p_src2[R64_SIZE] + 1;
	if (p_dst[R64_SIZE] >= (CUINT64(1)<<30) -1) {
		r64_semimod(p_dst);
	}
}

// ---------------------------------------------------------------------
// ]

static void r64_change_sign(uint64* r64)
{
	r64_sub(r64_0, r64, r64);
}

// ---------------------------------------------------------------------
// 璷K

// 璷Jグď璷{𐳋K
// ŏʂ̏璷Ԓlɂ
// C: 350clk => 316clk
// x86: 266clk
static uint64 r64_r64normalize(uint64* r64)
{
	uint64 tmp = 0;
	for(int i=0; i<R64_SIZE; i++) {
		tmp += r64[i];
		r64[i] = tmp & 0xffffffff;
		tmp = SAR64(tmp, 32);
	}
	return tmp;
}

// ---------------------------------------------------------------------
// {K(ȗŁFSɐKȂFZ̃I[o[t[h~p)

// 璷K512bitȏ̐̕܏
static void r64_semimod(uint64* r64)
{
	uint64 tmp = r64_r64normalize(r64);

	// tmp * 2^512 + = tmp * (2^384 -2^160 +2^128 +2^64 +1) +
	r64[12] += tmp;
	r64[ 5] -= tmp;
	r64[ 4] += tmp;
	r64[ 2] += tmp;
	r64[ 0] += tmp;
	r64[R64_SIZE] = 1;
}

// ---------------------------------------------------------------------
// Z

// C: 3100clk
// 760clk@SSE2 \...
static void r64_mul_simple(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst, int len)
{
	// p_dst  len*2 ̒Ap_src?Ƃ̏d͕s
	// MZZ
	uint64 carry = 0;
	int i;
	for(i=0; i<len; i++) {
		uint64 mul = p_src1[i] * p_src2[0];
		p_dst[i] = (mul & 0xffffffff) + carry;
		carry = mul>>32;
	}
	p_dst[i] = carry;
	for(int j=1; j<len; j++) {
		carry = 0;
		for(i=0; i<len; i++) {
			uint64 mul = p_src1[i] * p_src2[j];
			p_dst[i+j] += (mul & 0xffffffff) + carry;
			carry = mul>>32;
		}
		p_dst[i+j] = carry;
	}
}

// ---------------------------------------------------------------------
// 2

static void r64_square_simple(uint64 const* p_src, uint64* p_dst, int len)
{
	// p_dst  len*2 ̒Ap_srcƂ̏d͕s
	// MZZ
	uint64 src = p_src[0];
	uint64 carry = src * src;
	p_dst[0] = (carry & 0xffffffff);
	carry >>= 32;
	int i;
	for(i=1; i<len; i++) {
		uint64 mul = p_src[i] * src;
		uint64 tmp = (mul & 0xffffffff);
		p_dst[i] = tmp + tmp + carry;
		carry = mul>>32;
		carry += carry;
	}
	p_dst[i] = carry;
	for(int j=1; j<len; j++) {
		src = p_src[j];
		carry = src * src;
		p_dst[j*2] += (carry & 0xffffffff);
		carry >>= 32;
		for(i=j+1; i<len; i++) {
			uint64 mul = p_src[i] * src;
			uint64 tmp = (mul & 0xffffffff);
			p_dst[i+j] += tmp + tmp + carry;
			carry = mul>>32;
			carry += carry;
		}
		p_dst[i+j] = carry;
	}
}

// ---------------------------------------------------------------------
// Z(Karatsubagp)

static void r64_mul_karatsuba(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst)
{
	// p_dst[32], p_src?[16]̒Ap_dst  p_src?Ƃ̏d͕s

	// Karatsuba
	// a*b = H*N^2 + M*N + L
	// where H = a_h*b_h, L = a_l*b_l, M = H+L-(a_h-a_l)*(b_h-b_l), N=2^256.
	uint64 *M = new_t<uint64>(16);

	uint64 mask_a, mask_b;
	// p_dst[23..16] = abs(a_h-a_l)
	{
	uint64 carry = 0;
	for(int i=0; i<8; i++) {
		carry += p_src1[i+8] - p_src1[i];
		p_dst[i+16] = carry & 0xffffffff;
		carry = SAR64(carry, 32);
	}
	mask_a = carry = (carry>>32) & 0xffffffff; // if (src1 - src2) < 0 then mask(31..0) = All_1
	carry &= 1;
	for(int i=0; i<8; i++) {
		carry += (p_dst[i+16] ^ mask_a);
		p_dst[i+16] = carry & 0xffffffff;
		carry >>= 32;
	}
	}
	// p_dst[7..0] = abs(b_h-b_l)
	{
	uint64 carry = 0;
	for(int i=0; i<8; i++) {
		carry += p_src2[i+8] - p_src2[i];
		p_dst[i] = carry & 0xffffffff;
		carry = SAR64(carry, 32);
	}
	mask_b = carry = (carry>>32) & 0xffffffff; // if (src1 - src2) < 0 then mask(31..0) = All_1
	carry &= 1;
	for(int i=0; i<8; i++) {
		carry += (p_dst[i] ^ mask_b);
		p_dst[i] = carry & 0xffffffff;
		carry >>= 32;
	}
	}

	r64_mul_simple(p_dst+16, p_dst, M, 8); // abs(a_h-a_l)*abs(b_h-b_l)
	r64_mul_simple(p_src1+8, p_src2+8, p_dst+16, 8); // a_h*b_h
	r64_mul_simple(p_src1  , p_src2  , p_dst   , 8); // a_l*b_l

	// M = H+L-(a_h-a_l)*(b_h-b_l)
	{
	uint64 mask = mask_a ^ mask_b; mask |= ((uint64)mask<<32);
	for(int i=0; i<16; i++) M[i] = p_dst[i+16] + p_dst[i] - (M[i] & (~mask)) + (M[i] & mask);
	}

	for(int i=0; i<16; i++) p_dst[i+8] += M[i];

	delete_t(M);
}

// ---------------------------------------------------------------------
// 2(Karatsubagp)

static void r64_square_karatsuba(uint64 const* p_src, uint64* p_dst)
{
	// p_dst[32], p_src[16]̒Ap_dst  p_srcƂ̏d͕s

	// Karatsuba
	// a*a = H*N^2 + M*N + L
	// where H = a_h^2, L = a_l^2, M = H+L-(a_h-a_l)^2, N=2^256.
	uint64 *M = new_t<uint64>(16);

	uint64 mask;
	// p_dst[7..0] = abs(a_h-a_l)
	{
	uint64 carry = 0;
	for(int i=0; i<8; i++) {
		carry += p_src[i+8] - p_src[i];
		p_dst[i] = carry & 0xffffffff;
		carry = SAR64(carry, 32);
	}
	mask = carry = (carry>>32) & 0xffffffff; // if (src1 - src2) < 0 then mask(31..0) = All_1
	carry &= 1;
	for(int i=0; i<8; i++) {
		carry += (p_dst[i] ^ mask);
		p_dst[i] = carry & 0xffffffff;
		carry >>= 32;
	}
	}

	r64_square_simple(p_dst, M, 8); // abs(a_h-a_l)^2
	r64_square_simple(p_src+8, p_dst+16, 8); // a_h^2
	r64_square_simple(p_src  , p_dst   , 8); // a_l^2

	// M = H+L-(a_h-a_l)^2
	for(int i=0; i<16; i++) M[i] = p_dst[i+16] + p_dst[i] - M[i];

	for(int i=0; i<16; i++) p_dst[i+8] += M[i];

	delete_t(M);
}

// ---------------------------------------------------------------------
// Zʂ̏k

static void r64_long_mod(uint64* p_dst)
{
	// p_dst[R64_SIZE*2]  p_dst[R64_SIZE] ɏk

	// tmp * 2^512 + = tmp * (2^384 -2^160 +2^128 +2^64 +1) +
	// 4=128bit*4=512bitŎ
	for(int j=16; j>0; j-=4) {
		for(int i=0; i<j; i++) {
			uint64 t = p_dst[16+i];
			p_dst[16+i] = 0;
			p_dst[12+i] += t;
			p_dst[ 5+i] -= t;
			p_dst[ 4+i] += t;
			p_dst[ 2+i] += t;
			p_dst[ 0+i] += t;
		}
	}
	{
		// 512bitȏ̏璷
		uint64 t = SAR64(p_dst[15], 32);
		p_dst[15] &= 0xffffffff;
		p_dst[12] += t;
		p_dst[ 5] -= t;
		p_dst[ 4] += t;
		p_dst[ 2] += t;
		p_dst[ 0] += t;
	}

	// 񗘗p mod() or semimod() 
	p_dst[R64_SIZE] = CUINT64(1)<<30;
}

// ---------------------------------------------------------------------
// Z(ꑽ{Ԃ̏ŹA2揈Ăяo)

static void r64_mul(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst)
{
	// ͂mod && r64normalizeĂ邱
	// 32*32bit=64bitA32bit*2ɕď璷\64bitŉZ
	uint64 *tmp = new_t<uint64>(R64_SIZE*2);

#if 0
	// PȕSIMDɂ͌Ă邩
	// SSE2_SIMDKaratsubaSISDKaratsuba̍Ɠ炢
	r64_mul_simple(p_src1, p_src2, tmp, R64_SIZE);
#else
	// FPUł
	//  Karatsubag & œKg

	if (p_src1 == p_src2) {
#if 1
		r64_square_karatsuba(p_src1, tmp);
#else
		r64_square_simple(p_src1, tmp, R64_SIZE);
#endif
	} else {
#if 1
		r64_mul_karatsuba(p_src1, p_src2, tmp);
#else
		r64_mul_simple(p_src1, p_src2, tmp, R64_SIZE);
#endif
	}
#endif

	r64_long_mod(tmp);
	ua_copy(tmp, p_dst, R64_EXTSIZE);

	delete_t(tmp);
}

#endif /* ONLY_SSE2 */

// ---------------------------------------------------------------------
// {K

void r64_mod(uint64* r64)
{
	if (r64[R64_SIZE] == 0) return;
	r64[R64_SIZE] = 0;

	uint64 tmp = r64_r64normalize(r64);
	if (tmp != 0) {
		r64[12] += tmp;
		r64[ 5] -= tmp;
		r64[ 4] += tmp;
		r64[ 2] += tmp;
		r64[ 0] += tmp;
		uint64 tmp1 = r64_r64normalize(r64);
		if (tmp1 == 0) {
			// ̏ꍇpȉɂȂ
			if (tmp >= (uint64(1)<<63)) return;
		} else {
			// 2xӂꂽꍇpȉɂȂ
			r64[12] += tmp1;
			r64[ 5] -= tmp1;
			r64[ 4] += tmp1;
			r64[ 2] += tmp1;
			r64[ 0] += tmp1;
			uint64 tmp2 = r64_r64normalize(r64);
			assert(tmp2 == 0);
			return;
		}
	}

	if (ua_cmp(r64, MttFpBase::r64_p, R64_SIZE) < 0) return;

	r64_sub(r64, MttFpBase::r64_p, r64);
	tmp = r64_r64normalize(r64);
	assert(tmp == 0);
	r64[R64_SIZE] = 0;
}

void r64_pow(uint64* r64, uint32 const* fp)
{
	// r64mod && r64normalizeĂ邱
	// fp ͏璷Ȃ ua `
	uint64 *x = new_t<uint64>(R64_EXTSIZE);
	ua_copy(r64, x, R64_EXTSIZE);

	int len = ua_get_bitlength(fp, MI_MOD_SIZE);
	uint32 dat=*fp++, mask=2;

	//if 1bit == 0 then r64=1 else r64=x
	if((dat & 1) == 0) ua_set_uint(uint64(1), r64, R64_EXTSIZE);
	for(int i=1; i<len; i++) {
		r64_mul(x, x, x);
		r64_mod(x);
		if((dat & mask) == mask) {
			r64_mul(r64, x, r64);
			r64_mod(r64);
		}
		if (mask != ((uint32)1<<31) ) {
			mask<<=1;
		} else {
			mask = 1;
			dat = *fp++;
		}
	}

	delete_t(x);
}

void r64_ua_to_r64(uint32 const* p_src, uint64* p_dst)
{
	for(int i=0; i<MI_MOD_SIZE; i++) {
		p_dst[i] = (uint64)p_src[i];
	}
}

void r64_mi_to_r64(uint32 const* p_src, uint64* p_dst)
{
	uint32 *mi = new_t<uint32>(MI_SIZE);
	ua_copy(p_src, mi, MI_SIZE);
	mi_mod(mi);

	r64_ua_to_r64(mi, p_dst);
	p_dst[R64_SIZE] = 0;
	delete_t(mi);
}

void r64_r64_to_mi(uint64 const* p_src, uint32* p_dst)
{
	uint64 *r64 = new_t<uint64>(R64_EXTSIZE);
	ua_copy(p_src, r64, R64_EXTSIZE);
	r64_mod(r64);

	for(int i=0; i<MI_MOD_SIZE; i++) {
		p_dst[i] = (uint32)(r64[i] & 0xffffffff);
	}
	ua_clear(p_dst+MI_MOD_SIZE, MI_SIZE-MI_MOD_SIZE);
	delete_t(r64);
}

extern "C" void mis_mul(uint32 const* p_src1, uint32 const* p_src2, uint32* p_dst);

inline void mi_mul(uint32 const* p_src1, uint32 const* p_src2, uint32* p_dst)
{
	mis_mul(p_src1, p_src2, p_dst);
	ua_clear(p_dst+17, 20-17);
}

static inline void mi_modinv(uint32* mi_obj)
{
	// normalizeĂ邱
	// ֐ł͐KꂽԂŌvZ
	// mi_mul, mi_mod̏o͂MI_SIZEvfȂ̂Œ
	uint32 r0[MI_MOD_SIZE], r1[MI_MOD_SIZE], t0[MI_MOD_SIZE], t1[MI_MOD_SIZE];
	uint32 *pr0 = r0, *pr1 = r1, *pt0 = t0, *pt1 = t1;

	ua_copy(mi_p, pr0, MI_MOD_SIZE);
	ua_copy(mi_obj, pr1, MI_MOD_SIZE);
	ua_clear(pt0, MI_MOD_SIZE);
	ua_set_uint(uint32(1), pt1, MI_MOD_SIZE);

	if (ua_cmp(mi_obj, mi_2, MI_MOD_SIZE) < 0 ) {
	   ua_set_uint(uint32(1), mi_obj, MI_MOD_SIZE);
	   return;
	}

	// gGCD
	for(;;) {
		uint32 q[MI_MOD_SIZE], tmp[MI_SIZE];
		ua_div(pr0, pr1, q, pr0, MI_MOD_SIZE);
		//t[k] = t[i] - d*t[j] = mod(t[i] - mod(d*t[j])) >= 0
		mi_mul(q, pt1, tmp);
		mi_mod(tmp);
		if (ua_sub(pt0, tmp,  pt0, MI_MOD_SIZE))
			ua_add(pt0, mi_p, pt0, MI_MOD_SIZE);

		if (ua_cmp(pr0, mi_2, MI_MOD_SIZE) < 0) {
			ua_copy(pt0, mi_obj, MI_MOD_SIZE);
			break;
		}
		uint32 *p;
		p = pr0; pr0 = pr1; pr1 = p;
		p = pt0; pt0 = pt1; pt1 = p;
	}
}

static void r64_modinv(uint64* r64)
{
	uint32 mi[MI_SIZE];
	r64_r64_to_mi(r64, mi);

	mi_modinv(mi);

	r64_mi_to_r64(mi, r64);
}


// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// IuWFNg̐Ŋ֌W

// ---------------------------------------------------------------------
// @breif imp_init_value_x/imp_init_str_x: IuWFNg̏l
// 
// @note ̊֐̕ԂĺAimp_delete() ŉB

void* MttFpBase::sf_init_value(int v)
{
	uint64 *r64 = new_t<uint64>(R64_EXTSIZE);

	if (v == 0) {
		ua_clear(r64, R64_EXTSIZE);
	} else {
		uint32 *mi = (uint32*)imp_init_value_mi_fp(v);
		r64_mi_to_r64(mi, r64);
		delete_t(mi);
	}

	return r64;
}

void* MttFpBase::sf_init_str(char const* str)
{
	uint64 *r64 = new_t<uint64>(R64_EXTSIZE);

	uint32 *mi = (uint32*)imp_init_str_mi_fp(str);
	r64_mi_to_r64(mi, r64);
	delete_t(mi);

	return r64;
}


// ---------------------------------------------------------------------
// @breif imp_copy: IuWFNgRs[ĕԂ
// 
// @note ̊֐̕ԂĺAimp_delete() ŉB

void* MttFpBase::sf_copy(void const* obj)
{
	uint64 const* p_r64 = reinterpret_cast<uint64 const*>(obj);

	uint64 *r64 = new_t<uint64>(R64_EXTSIZE);
	ua_copy(p_r64, r64, R64_EXTSIZE);

	return r64;
}


// ---------------------------------------------------------------------
// @breif imp_delete(): IuWFNg̉
// 
// @note 0|C^Ȃ牽ȂB(delete ͑v free() 
// ʖڂ)

void MttFpBase::sf_delete(void* obj)
{
	uint64* p_r64 = reinterpret_cast<uint64*>(obj);
	delete_t(p_r64);
}


// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// IuWFNg̕\AK

// ---------------------------------------------------------------------
// @breif imp_normalize(): IuWFNg̐K
//

void MttFpBase::sf_normalize(void* obj)
{
	uint64* p_r64 = reinterpret_cast<uint64*>(obj);
	r64_mod(p_r64);
}


// ---------------------------------------------------------------------
// @breif imp_show(): IuWFNg̕\
// 

void MttFpBase::sf_show(void const* obj)
{
	uint64 const* p_r64 = reinterpret_cast<uint64 const*>(obj);

	uint32 mi[MI_SIZE];
	r64_r64_to_mi(p_r64, mi);

	printf("%s", imp_get_str_mi_fp(mi));
}


// ---------------------------------------------------------------------
// @breif imp_get_str(): IuWFNg̕
// 

char const* MttFpBase::sf_get_str(void const* obj)
{
	uint64 const* p_r64 = reinterpret_cast<uint64 const*>(obj);

	uint32 mi[MI_SIZE];
	r64_r64_to_mi(p_r64, mi);

	return imp_get_str_mi_fp(mi);
}


// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// IuWFNg̉Zq

// ---------------------------------------------------------------------
// @breif imp_add(): IuWFNg̉Z(*dst = *src1 + *src2)
//

void MttFpBase::sf_add(void const* src1, void const* src2, void* dst)
{
	uint64 const* p_src1 = reinterpret_cast<uint64 const*>( src1 );
	uint64 const* p_src2 = reinterpret_cast<uint64 const*>( src2 );
	uint64* p_dst = reinterpret_cast<uint64*>( dst );

	r64_add(p_src1, p_src2, p_dst);
}


// ---------------------------------------------------------------------
// @breif imp_sub(): IuWFNǧZ(*dst = *src1 - *src2)
//

void MttFpBase::sf_sub(void const* src1, void const* src2, void* dst)
{
	uint64 const* p_src1 = reinterpret_cast<uint64 const*>( src1 );
	uint64 const* p_src2 = reinterpret_cast<uint64 const*>( src2 );
	uint64* p_dst = reinterpret_cast<uint64*>( dst );

	r64_sub(p_src1, p_src2, p_dst);
}


// ---------------------------------------------------------------------
// @breif imp_mul(): IuWFNg̏Z(*dst = *src1 * *src2)
//

void MttFpBase::sf_mul(void const* src1, void const* src2, void* dst)
{
	uint64* p_src1 = reinterpret_cast<uint64*>(const_cast<void*>( src1 ));
	uint64* p_src2 = reinterpret_cast<uint64*>(const_cast<void*>( src2 ));
	uint64* p_dst = reinterpret_cast<uint64*>( dst );

	//512bitȉ̒̏Zɗ}
	r64_mod(p_src1);
	r64_mod(p_src2);
	r64_mul(p_src1, p_src2, p_dst);
}


// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// IuWFNg̉ZqȊỎZ

// ---------------------------------------------------------------------
// @breif imp_clear(): IuWFNg0
//

void MttFpBase::sf_clear(void* obj)
{
	uint64* p_r64 = reinterpret_cast<uint64*>(obj);
	ua_clear(p_r64, R64_EXTSIZE);
}

// ---------------------------------------------------------------------
// @breif imp_change_sign(): IuWFNg -1 |
//

void MttFpBase::sf_change_sign(void* obj)
{
	uint64* p_r64 = reinterpret_cast<uint64*>(obj);
	r64_change_sign(p_r64);
}

// ---------------------------------------------------------------------
// @breif imp_is_zero(): IuWFNg 0 ǂH
// 

bool MttFpBase::sf_is_zero(void const* obj)
{
	uint64 const* p_r64 = reinterpret_cast<uint64 const*>(obj);
	return ua_is_zero(p_r64, R64_SIZE);
}

// ---------------------------------------------------------------------
// @breif imp_inverse(): IuWFNg̋t(*obj = 1/ *obj)
//
// *obj  0 ȂΌʂ͕ۏ؂ȂB

void MttFpBase::sf_inverse(void* obj)
{
	uint64* p_r64 = reinterpret_cast<uint64*>(obj);
	r64_mod(p_r64);
	r64_modinv(p_r64);
}

// ---------------------------------------------------------------------
// @breif imp_cbrt(): IuWFNg(4m-1)悷
//
// œǨ́Ap, m ύX΁AύXKv
// ݂̓x^x^B

void MttFpBase::sf_cbrt(void* obj)
{
	uint64* r64 = reinterpret_cast<uint64*>(obj);
	r64_mod(r64);
	r64_pow(r64, ua_4m_1);
}


// ---------------------------------------------------------------------
// @breif imp_sqrt(): IuWFNg(p+1)/4悷

void MttFpBase::sf_sqrt(void* obj)
{
	uint64* r64 = reinterpret_cast<uint64*>(obj);
	r64_mod(r64);
	r64_pow(r64, ua_pp1d4);
}


// ---------------------------------------------------------------------
// @breif imp_pow(): IuWFNg fp 悷
//
// œǨ́Ap, m ύX΁AύXKv
// ݂̓x^x^B

void MttFpBase::sf_pow(void* obj, void const* fp)
{
	uint64* r64 = reinterpret_cast<uint64*>(obj);
	uint64 const* p = reinterpret_cast<uint64 const*>( fp );

	uint32 tmp[MI_SIZE];
	r64_r64_to_mi(p, tmp);

	r64_mod(r64);
	r64_pow(r64, tmp);
}

// ===========================================================================
// implementation for large number bit operations


// ---------------------------------------------------------------------
// @breif imp_init_object: Fp/Fmog̃IuWFNgRs[ĕԂ
// 
// @note ̊֐̕ԂĺAimp_delete_bits() ŉB

void* MttBitsBase::sf_init_object_p(void const* obj)
{
	uint64 const* p_r64 = reinterpret_cast<uint64 const*>(obj);

	uint32 mi[MI_SIZE];
	r64_r64_to_mi(p_r64, mi);

	uint32 *p = new_t<uint32>(16);
	ua_copy(mi, p, 16);
	return p;
}

// ---------------------------------------------------------------------
// @breif imp_setup(): imp̃ZbgAbv
// 

void* MttBitsBase::sf_init_object_m(void const* obj)
{
	UAS const* p_uas = reinterpret_cast<UAS const*>(obj);
	UAS uas = *p_uas;

	MttFmBase::sf_normalize(&uas);

	uint32 *ua = new_t<uint32>(16);
	ua_copy(uas.ua, ua, 16);
	return ua;
}

void MttFpBase::setup()
{
#ifdef ONLY_SSE2
	if (!cpu.hasSSE2()) {
		fprintf(stderr, "can't use SSE2\n");
		exit(1);
	}
#endif
	r64_p = new_t<uint64>(R64_EXTSIZE);
	r64_0 = new_t<uint64>(R64_EXTSIZE);
	{
		// mi
		uint32 mi_1[MI_SIZE];
		uint32 mi_4[MI_SIZE];
		uint32 mi_p[MI_SIZE];
		uint32 mi_m[MI_SIZE];

		ua_set_uint(uint32(1), mi_1, MI_SIZE);
		ua_set_uint(uint32(4), mi_4, MI_SIZE);

		// p
		ua_init_from_str(TEXT_PARAM_P, mi_p, MI_SIZE);

		// m
		ua_init_from_str(TEXT_PARAM_M, mi_m, MI_SIZE);

		// 4m-1
		uint32 mi_4m[MI_SIZE];
		ua_mul_s(mi_m, 4, mi_4m, MI_MOD_SIZE);
		ua_sub(mi_4m, mi_1, ua_4m_1, MI_MOD_SIZE);

		// (p+1)/4
		ua_add(mi_p, mi_1, ua_pp1d4, MI_MOD_SIZE);
		ua_div(ua_pp1d4, mi_4, ua_pp1d4, mi_4, MI_MOD_SIZE);

		// r64
		r64_ua_to_r64(mi_p, MttFpBase::r64_p);

		ua_set_uint(uint64(0), r64_0, R64_EXTSIZE);
	}
	r64_asm_init(r64_p);
}

UAS MttFmBase::uas_m;
UAS MttFmBase::uas_0;
UAS MttFmBase::uas_2;

void MttFmBase::setup()
{
	static UAS uas_p;
	// uas 萔
	uas_p.InitFromStr(TEXT_PARAM_P, 0);
	uas_m.InitFromStr(TEXT_PARAM_M, &uas_p);
	uas_0.InitFromStr("0", &uas_p);
	uas_2.InitFromStr("2", &uas_p);
}
