#ifndef MIE_FP_BASE_H_
#define MIE_FP_BASE_H_

namespace MTT {

class MttFpBase {
protected:
	// for ctor/dtor
	static void* sf_init_value(int);
	static void* sf_init_str(char const*);
	static void* sf_copy(void const*);
	static void sf_delete(void*);
	
	// for access
	static char const* sf_get_str(void const*);
	static void sf_show(void const*);
	
	// for operator
	static void sf_add(void const*, void const*, void*);
	static void sf_sub(void const*, void const*, void*);
	static void sf_mul(void const*, void const*, void*);
	
	// for operation
	static void sf_inverse(void*);
	static void sf_normalize(void*);
	static void sf_clear(void*);
	static void sf_change_sign(void*);
	static void sf_cbrt(void*);
	static void sf_sqrt(void*);
	static void sf_pow(void*, void const*);
	static bool sf_is_zero(void const*);
	
public:
	static uint64 *r64_p;
	static void setup();
};

} // end of namespace

#endif /* MIE_FP_BASE_H_ */
