
////////////////////////////////////////////////////////////////////////////
// for specification of CPU

#include <sstream>
#include <string>
#include "../cpu_state.h"

#include <setjmp.h>
#include <signal.h>

#if defined(_MSC_VER)
#include <excpt.h>
#endif

using namespace std;
using namespace MTT;

extern "C" int haveUNITa(void); /* defined in cpua.nas */
extern "C" void setPIII_round(void);

static jmp_buf jmpPtr;

#ifndef _MSC_VER
static void
SSE_not_supported(int sig)
{
	signal(SIGILL, SIG_DFL);
	longjmp(jmpPtr, 1);
}
#endif

static bool
Init_SSE()
{
	/* SSE  OS ɂăT|[gĂȂƎgpłȂ */
	bool SSE_supported = false;

	/* قƂǂ̊ Illegal Instruction Exception  try/catch ňȂ */
#if defined(_MSC_VER)
	/*
		WinNT ł SIGILL ͐Ȃ̂ __try/__except gp
		WinNT+SP4 ȍ~ SSE ɑΉĂ
	*/
	__try{
		setPIII_round();
		SSE_supported = true;
	}
	__except(EXCEPTION_EXECUTE_HANDLER) {
	}
#else
	int ret;
	ret = setjmp(jmpPtr);
	if (ret == 0) {
		signal(SIGILL, SSE_not_supported);
		setPIII_round();
		signal(SIGILL, SIG_DFL);
		SSE_supported = true;
	}
#endif

	return SSE_supported;
}

Ccpu::Ccpu()
{
	unit = haveUNITa();

	if (unit & tSSE) {
		if (!Init_SSE()) {
			unit &= ~(tSSE|tSSE2);
		}
	}
}

const string Ccpu::toString() const
{
	ostringstream ostr;
	ostr << "family:" << family() << " ";
	if (hasMMX()) ostr << "MMX ";
	if (has3DN()) ostr << "3DN ";
	if (hasSSE()) ostr << "SSE ";
	if (hasCMOV()) ostr << "CMOV ";
	if (hasE3DN()) ostr << "E3DN ";
	if (hasEMMX()) ostr << "EMMX ";
	if (hasSSE2()) ostr << "SSE2 ";
	if (hasCLFLUSH()) ostr << "CLFLUSH ";
	return ostr.str();
}
