
;   for MTT
;   Copyright (C) 2002

%include "nasm.cfg"

    segment_data

    segment_text

; return carry
;bool ua_add(uint32 const* p_src1, uint32 const* p_src2, uint32* p_dst, int len)
proc ua_add
        push    edi
        push    esi
%assign _P  8

        mov     esi,[esp+_P+4]  ; p_src1
        mov     edx,[esp+_P+8]  ; p_src2
        mov     edi,[esp+_P+12] ; p_dst
        mov     ecx,[esp+_P+16] ; len
        lea     esi,[esi+ecx*4]
        lea     edx,[edx+ecx*4]
        lea     edi,[edi+ecx*4]
        neg     ecx
        clc
.lp0:   mov     eax,[esi+ecx*4]
        adc     eax,[edx+ecx*4]
        mov     [edi+ecx*4],eax
        inc     ecx
        jnz     .lp0

        setc    al
        movzx   eax,al
        pop     esi
        pop     edi
        ret

; return borrow
;bool ua_sub(uint32 const* p_src1, uint32 const* p_src2, uint32* p_dst, int len)
proc ua_sub
        push    edi
        push    esi
%assign _P  8

        mov     esi,[esp+_P+4]  ; p_src1
        mov     edx,[esp+_P+8]  ; p_src2
        mov     edi,[esp+_P+12] ; p_dst
        mov     ecx,[esp+_P+16] ; len
        lea     esi,[esi+ecx*4]
        lea     edx,[edx+ecx*4]
        lea     edi,[edi+ecx*4]
        neg     ecx
        clc
.lp0:   mov     eax,[esi+ecx*4]
        sbb     eax,[edx+ecx*4]
        mov     [edi+ecx*4],eax
        inc     ecx
        jnz     .lp0

        setc    al
        movzx   eax,al
        pop     esi
        pop     edi
        ret

; nvf * 1vf = n+1vf
;void ua_mul_s(uint32 const* p_src, uint32 src, uint32* p_dst, int len)
proc ua_mul_s
        push    esi
        push    edi
        push    ebx
        push    ebp
%assign _P  16

        mov     esi,[esp+_P+4]  ; p_src
        mov     ebx,[esp+_P+8]  ; src
        mov     edi,[esp+_P+12] ; p_dst
        mov     ecx,[esp+_P+16] ; len
        lea     esi,[esi+ecx*4]
        lea     edi,[edi+ecx*4]
        neg     ecx
        xor     ebp,ebp         ; tmp
.lp0:   mov     eax,[esi+ecx*4]
        mul     ebx
        add     eax,ebp
        adc     edx,byte 0
        mov     [edi+ecx*4],eax
        mov     ebp,edx
        inc     ecx
        jnz     .lp0

        mov     [edi],ebp
        pop     ebp
        pop     ebx
        pop     edi
        pop     esi
        ret

; nvf * 1vf = n+1vfAo͉Z㏑Aŏʂ͏㏑
; void ua_mul_add_s(uint32 const* p_src, uint32 src, uint32* p_dst, int len)
proc ua_mul_add_s
        push    esi
        push    edi
        push    ebx
        push    ebp
%assign _P  16

        mov     esi,[esp+_P+4]  ; p_src
        mov     ebx,[esp+_P+8]  ; src
        mov     edi,[esp+_P+12] ; p_dst
        mov     ecx,[esp+_P+16] ; len
        lea     esi,[esi+ecx*4]
        lea     edi,[edi+ecx*4]
        neg     ecx
        xor     ebp,ebp         ; tmp
.lp0:   mov     eax,[esi+ecx*4]
        mul     ebx
        add     eax,ebp
        adc     edx,byte 0
        add     eax, [edi+ecx*4]
        adc     edx,byte 0
        mov     [edi+ecx*4],eax
        mov     ebp,edx
        inc     ecx
        jnz     .lp0

        mov     [edi],ebp
        pop     ebp
        pop     ebx
        pop     edi
        pop     esi
        ret

; 2p
; nvf * 1vf = n+1vf
; void ua_square_s(uint32 const* p_src, uint32* p_dst, int len) {
proc ua_square_s
        push    esi
        push    edi
        push    ebx
        push    ebp
        sub     esp,byte 8
%define src esp
%define len esp+4
%assign _P  (4*4+8)

        mov     esi,[esp+_P+4]  ; p_src
        mov     edi,[esp+_P+8]  ; p_dst
        mov     ebp,[esp+_P+12] ; len

        mov     eax,[esi]       ; src
        mov     ecx,eax
        mul     eax
        mov     [edi],eax
        cmp     ebp,byte 1
        ja     .lp0_init
        mov     [edi+4],edx
        jmp short .exit

    .lp0_init:
        mov     [src],ecx
        add     esi, byte 4
        add     edi, byte 4
        dec     ebp
        mov     [len],ebp
        mov     ecx,edx
        xor     ebp,ebp

        ; ebx:edx:eax = (a*src)*2
        ;     ebp:ecx = tmp
    .lp0:
        mov     eax, [esi]
        add     esi,byte 4
        mul     dword [src]     ; (a*src)
        xor     ebx,ebx
        add     eax,eax
        adc     edx,edx
        adc     ebx,ebx         ; (a*src)*2
        add     eax,ecx
        adc     edx,ebp
        adc     ebx,byte 0      ; (a*src)*2+tmp
        mov     [edi],eax
        add     edi,byte 4
        mov     ecx,edx
        mov     ebp,ebx
        dec     dword [len]
        jnz     .lp0
        mov     [edi],ecx
        mov     [edi+4],ebp
    .exit:
%undef  src
%undef  len
        add     esp,byte 8
        pop     ebp
        pop     ebx
        pop     edi
        pop     esi
        ret

; 2p
; nvf * 1vf = n+1vfAo͉Z㏑Aŏʂ͏㏑
; void ua_square_add_s(uint32 const* p_src, uint32* p_dst, int len) {
proc ua_square_add_s
        push    esi
        push    edi
        push    ebx
        push    ebp
        sub     esp,byte 8
%define src esp
%define len esp+4
%assign _P  (4*4+8)

        mov     esi,[esp+_P+4]  ; p_src
        mov     edi,[esp+_P+8]  ; p_dst
        mov     ebp,[esp+_P+12] ; len

        mov     eax,[esi]       ; src
        mov     ecx,eax
        mov     [src],eax
        mul     eax
        add     eax,[edi]
        adc     edx,byte 0
        mov     [edi],eax
        cmp     ebp,byte 1
        ja     .lp0_init
        add     edx,[edi+4]
        mov     [edi+4],edx
        jmp short .exit

    .lp0_init:
        mov     [src],ecx
        add     esi, byte 4
        add     edi, byte 4
        dec     ebp
        mov     [len],ebp
        mov     ecx,edx
        xor     ebp,ebp

        ; ebx:edx:eax = (a*src)*2
        ;     ebp:ecx = tmp
    .lp0:
        mov     eax, [esi]
        add     esi,byte 4
        mul     dword [src]     ; (a*src)
        xor     ebx,ebx
        add     eax,eax
        adc     edx,edx
        adc     ebx,ebx         ; (a*src)*2
        add     eax,ecx
        adc     edx,ebp
        adc     ebx,byte 0      ; (a*src)*2+tmp
        add     eax,[edi]
        adc     edx,byte 0
        adc     ebx,byte 0      ; (a*src)*2+tmp+dst
        mov     [edi],eax
        add     edi,byte 4
        mov     ecx,edx
        mov     ebp,ebx
        dec     dword [len]
        jnz     .lp0
    .lp0_skip:
        add     edx,[edi]
        adc     ebx,byte 0
        mov     [edi],edx
        mov     [edi+4],ebx
    .exit:
%undef  src
%undef  len
        add     esp,byte 8
        pop     ebp
        pop     ebx
        pop     edi
        pop     esi
        ret

; nvf / 1vf = nvf + ]nvf
; uint32 ua_div_s(uint32 const* p_src, uint32 src, uint32* p_dst, int len) {
proc ua_div_s
        push    esi
        push    edi
        push    ebx
%assign _P  12

        mov     esi,[esp+_P+4]  ; p_src
        mov     ebx,[esp+_P+8]  ; src = divisor
        mov     edi,[esp+_P+12] ; p_dst
        mov     ecx,[esp+_P+16] ; len
        xor     edx,edx         ; rem

.lp0:   mov     eax,[esi+ecx*4-4]
        div     ebx
        mov     [edi+ecx*4-4],eax
        dec     ecx
        jnz     .lp0

        mov     eax,edx         ; return rem
        pop     ebx
        pop     edi
        pop     esi
        ret

        end
