
;	for MTT
;	Copyright (C) 2002

%include "nasm.cfg"

	segment_data

	segment_text

%macro mul_s_1line 1
		mov			eax, [edi+(%1)*4]	; p_src1[i]
		mul			ebx					; p_src1[i] * p_src2[0]
		add			eax, ebp			; p_src1[i] * p_src2[i] + carry
		adc			edx, byte 0
		mov			[tmp+(%1)*4], eax
		mov			ebp, edx
%endm

%macro mul_add_s_1line 1
		mov			eax, [edi+(%1)*4]			; p_src1[j]
		mul			ebx							; p_src1[j] * p_src2[i]
		add			eax, ebp					; p_src1[j] * p_src2[i] + carry
		adc			edx, byte 0
		add			eax, [tmp+ecx*4+(%1)*4]		; tmp[i+j]
		adc			edx, byte 0
		mov			[tmp+ecx*4+(%1)*4], eax
		mov			ebp, edx
%endm

%macro add64 3
		add			%2, %3
		adc			%1, ZERO
%endm

%macro adc64 3
		adc			%2, %3
		adc			%1, ZERO
%endm

%macro sub64 3
		sub			%2, %3
		sbb			%1, ZERO
%endm

%macro mod128_T1_1line 1
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+(%1+ 0)*4]
		sub64		edx, eax, [esi+(%1+11)*4]
		add64		edx, eax, [esi+(%1+12)*4]
		add64		edx, eax, [esi+(%1+14)*4]
		add64		edx, eax, [esi+(%1+16)*4]
		mov			[edi+(%1)*4], eax
%endm

%macro mod128_T2_1line 1
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+(%1+ 0)*4]
		add64		edx, eax, [esi+(%1+ 4)*4]
		sub64		edx, eax, [esi+(%1+11)*4]
		add64		edx, eax, [esi+(%1+12)*4]
		add64		edx, eax, [esi+(%1+14)*4]
		add64		edx, eax, [esi+(%1+16)*4]
		mov			[edi+(%1)*4], eax
%endm

%macro mod128_T3_1line 1
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+(%1+4)*4]
		mov			[edi+(%1)*4], eax
%endm


; void mis_mul(uint32 const* p_src1, uint32 const* p_src2, uint32* p_dst)
proc	mis_mul
		push		ebx
		push		esi
		push		edi
		push		ebp
%assign _LOCAL (32+32)*4
		sub			esp, _LOCAL
%define	tmp esp
%define	mod esp+32*4
%assign _P (4*4+_LOCAL)

		mov			edi, [esp+_P+4]		; p_src1
		mov			esi, [esp+_P+8]		; p_src2

		mov			ecx, 15
	.mul_pre_lp:
		mov			eax, [edi+ecx*4]
		cmp			eax, [esi+ecx*4]
		ja			.mul_s
		jb			.mul_pre_exchange
		sub			ecx, byte 1
		jnz			.mul_pre_lp
	.mul_pre_exchange:
		mov			eax, edi
		mov			edi, esi
		mov			esi, eax

	.mul_s:
		mov			ebx, [esi+ 0*4]	; p_src2[0]
		; 0
		mov			eax, [edi+ 0*4]	; p_src1[0]
		mul			ebx				; p_src1[0] * p_src2[0]
		mov			[tmp+ 0*4], eax
		mov			ebp, edx		; carry
		; 1-14
		mul_s_1line 1
		mul_s_1line 2
		mul_s_1line 3
		mul_s_1line 4
		mul_s_1line 5
		mul_s_1line 6
		mul_s_1line 7
		mul_s_1line 8
		mul_s_1line 9
		mul_s_1line 10
		mul_s_1line 11
		mul_s_1line 12
		mul_s_1line 13
		mul_s_1line 14
		; 15
		mov			eax, [edi+15*4]
		mul			ebx
		add			eax, ebp
		adc			edx, byte 0
		mov			[tmp+15*4], eax
		mov			[tmp+16*4], edx

		mov			ecx, 1	; loopcouter
	.mul_add_s:
		mov			ebx, [esi+ecx*4]		; p_src2[i]
		test		ebx, ebx
		mov			edx, ebx
		jz near		.mul_add_s_skip
		; 0
		mov			eax, [edi+ 0*4]			; p_src1[0]
		mul			ebx						; p_src1[0] * p_src2[i]
		add			eax, [tmp+ecx*4+ 0*4]	; tmp[i+0]
		adc			edx, byte 0
		mov			[tmp+ecx*4+ 0*4], eax
		mov			ebp, edx				; carry
		; 1-14
		mul_add_s_1line 1
		mul_add_s_1line 2
		mul_add_s_1line 3
		mul_add_s_1line 4
		mul_add_s_1line 5
		mul_add_s_1line 6
		mul_add_s_1line 7
		mul_add_s_1line 8
		mul_add_s_1line 9
		mul_add_s_1line 10
		mul_add_s_1line 11
		mul_add_s_1line 12
		mul_add_s_1line 13
		mul_add_s_1line 14
		; 15
		mov			eax, [edi+15*4]
		mul			ebx
		add			eax, ebp
		adc			edx, byte 0
		add			eax, [tmp+ecx*4+15*4]
		adc			edx, byte 0
		mov			[tmp+ecx*4+15*4], eax
	.mul_add_s_skip:
		mov			[tmp+ecx*4+16*4], edx

		add			ecx, 1
		cmp			ecx, 16
		jb near		.mul_add_s

	.mod_32_to_29:
		lea			esi, [tmp]
		lea			edi, [mod]
		xor			ebx, ebx
%define ZERO ebx
		; 0 + 16
		mov			eax, [esi+ 0*4]
		add			eax, [esi+16*4]
		mov			[edi+ 0*4], eax
		; 1 + 17 + carry
		mov			eax, [esi+ 1*4]
		adc			eax, [esi+17*4]
		mov			[edi+ 1*4], eax
		; 2 + 16 + 18 + carry
		mov			edx, ZERO
		mov			eax, [esi+ 2*4]
		adc64		edx, eax, [esi+16*4]
		add			     eax, [esi+18*4]
		mov			[edi+ 2*4], eax
		; 3 + 17 + 19 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 3*4]
		add64		eax, edx, [esi+17*4]
		add			     edx, [esi+19*4]
		mov			[edi+ 3*4], edx
		; 4 + 16 + 18 + 20 + carry
		mov			edx, ZERO
		adc64		edx, eax, [esi+ 4*4]
		add64		edx, eax, [esi+16*4]
		add64		edx, eax, [esi+18*4]
		add			     eax, [esi+20*4]
		mov			[edi+ 4*4], eax
		; 5 - 16 + 17 + 19 + 21 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 5*4]
		sub64		eax, edx, [esi+16*4]
		add64		eax, edx, [esi+17*4]
		add64		eax, edx, [esi+19*4]
		add64		eax, edx, [esi+21*4]
		mov			[edi+ 5*4], edx
		; 6 - 17 + 18 + 20 + 22 + carry
		cdq
		add64		edx, eax, [esi+ 6*4]
		sub64		edx, eax, [esi+17*4]
		add64		edx, eax, [esi+18*4]
		add64		edx, eax, [esi+20*4]
		add64		edx, eax, [esi+22*4]
		mov			[edi+ 6*4], eax
		; 7 - 18 + 19 + 21 + 23 + carry
		; 8 - 19 + 20 + 22 + 24 + carry
		; 9 - 20 + 21 + 23 + 25 + carry
		; 10 - 21 + 22 + 24 + 26 + carry
		; 11 - 22 + 23 + 25 + 27 + carry
		mod128_T1_1line 7
		mod128_T1_1line 8
		mod128_T1_1line 9
		mod128_T1_1line 10
		mod128_T1_1line 11
		; 12 + 16 - 23 + 24 + 26 + 28 + carry
		; 13 + 17 - 24 + 25 + 27 + 29 + carry
		; 14 + 18 - 25 + 26 + 28 + 30 + carry
		; 15 + 19 - 26 + 27 + 29 + 31 + carry
		mod128_T2_1line 12
		mod128_T2_1line 13
		mod128_T2_1line 14
		mod128_T2_1line 15
		; 20 - 27 + 28 + 30 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+20*4]
		sub64		edx, eax, [esi+27*4]
		add64		edx, eax, [esi+28*4]
		add64		edx, eax, [esi+30*4]
		mov			[edi+16*4], eax
		; 21 - 28 + 29 + 31 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+21*4]
		sub64		edx, eax, [esi+28*4]
		add64		edx, eax, [esi+29*4]
		add64		edx, eax, [esi+31*4]
		mov			[edi+17*4], eax
		; 22 - 29 + 30 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+22*4]
		sub64		edx, eax, [esi+29*4]
		add64		edx, eax, [esi+30*4]
		mov			[edi+18*4], eax
		; 23 - 30 + 31 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+23*4]
		sub64		edx, eax, [esi+30*4]
		add64		edx, eax, [esi+31*4]
		mov			[edi+19*4], eax
		; 24 - 31 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+24*4]
		sub64		edx, eax, [esi+31*4]
		mov			[edi+20*4], eax
		; 25 + carry
		; 26 + carry
		; 27 + carry
		; 28 + carry
		; 29 + carry
		; 30 + carry
		; 31 + carry
		mod128_T3_1line 21
		mod128_T3_1line 22
		mod128_T3_1line 23
		mod128_T3_1line 24
		mod128_T3_1line 25
		mod128_T3_1line 26
		mod128_T3_1line 27
		mov			[edi+28*4], edx

	.mod_29_to_25:
		lea			esi, [mod]
		lea			edi, [tmp]
		; 0 + 16
		mov			eax, [esi+ 0*4]
		add			eax, [esi+16*4]
		mov			[edi+ 0*4], eax
		; 1 + 17 + carry
		mov			eax, [esi+ 1*4]
		adc			eax, [esi+17*4]
		mov			[edi+ 1*4], eax
		; 2 + 16 + 18 + carry
		mov			edx, ZERO
		mov			eax, [esi+ 2*4]
		adc64		edx, eax, [esi+16*4]
		add			     eax, [esi+18*4]
		mov			[edi+ 2*4], eax
		; 3 + 17 + 19 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 3*4]
		add64		eax, edx, [esi+17*4]
		add			     edx, [esi+19*4]
		mov			[edi+ 3*4], edx
		; 4 + 16 + 18 + 20 + carry
		mov			edx, ZERO
		adc64		edx, eax, [esi+ 4*4]
		add64		edx, eax, [esi+16*4]
		add64		edx, eax, [esi+18*4]
		add			     eax, [esi+20*4]
		mov			[edi+ 4*4], eax
		; 5 - 16 + 17 + 19 + 21 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 5*4]
		sub64		eax, edx, [esi+16*4]
		add64		eax, edx, [esi+17*4]
		add64		eax, edx, [esi+19*4]
		add64		eax, edx, [esi+21*4]
		mov			[edi+ 5*4], edx
		; 6 - 17 + 18 + 20 + 22 + carry
		cdq
		add64		edx, eax, [esi+ 6*4]
		sub64		edx, eax, [esi+17*4]
		add64		edx, eax, [esi+18*4]
		add64		edx, eax, [esi+20*4]
		add64		edx, eax, [esi+22*4]
		mov			[edi+ 6*4], eax
		; 7 - 18 + 19 + 21 + 23 + carry
		; 8 - 19 + 20 + 22 + 24 + carry
		; 9 - 20 + 21 + 23 + 25 + carry
		; 10 - 21 + 22 + 24 + 26 + carry
		; 11 - 22 + 23 + 25 + 27 + carry
		mod128_T1_1line 7
		mod128_T1_1line 8
		mod128_T1_1line 9
		mod128_T1_1line 10
		mod128_T1_1line 11
		; 12 + 16 - 23 + 24 + 26 + 28 + carry
		mod128_T2_1line 12
		; 13 + 17 - 24 + 25 + 27 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+13*4]
		add64		edx, eax, [esi+17*4]
		sub64		edx, eax, [esi+24*4]
		add64		edx, eax, [esi+25*4]
		add64		edx, eax, [esi+27*4]
		mov			[edi+13*4], eax
		; 14 + 18 - 25 + 26 + 28 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+14*4]
		add64		edx, eax, [esi+18*4]
		sub64		edx, eax, [esi+25*4]
		add64		edx, eax, [esi+26*4]
		add64		edx, eax, [esi+28*4]
		mov			[edi+14*4], eax
		; 15 + 19 - 26 + 27 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+15*4]
		add64		edx, eax, [esi+19*4]
		sub64		edx, eax, [esi+26*4]
		add64		edx, eax, [esi+27*4]
		mov			[edi+15*4], eax
		; 20 - 27 + 28 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+20*4]
		sub64		edx, eax, [esi+27*4]
		add64		edx, eax, [esi+28*4]
		mov			[edi+16*4], eax
		; 21 - 28 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+21*4]
		sub64		edx, eax, [esi+28*4]
		mov			[edi+17*4], eax
		; 22 + carry
		; 23 + carry
		; 24 + carry
		; 25 + carry
		; 26 + carry
		; 27 + carry
		; 28 + carry
		; 29 + carry
		; 30 + carry
		; 31 + carry
		mod128_T3_1line 18
		mod128_T3_1line 19
		mod128_T3_1line 20
		mod128_T3_1line 21
		mod128_T3_1line 22
		mod128_T3_1line 23
		mov			[edi+24*4], edx

	.mod_25_to_21:
		lea			esi, [tmp]
		lea			edi, [mod]
		; 0 + 16
		mov			eax, [esi+ 0*4]
		add			eax, [esi+16*4]
		mov			[edi+ 0*4], eax
		; 1 + 17 + carry
		mov			eax, [esi+ 1*4]
		adc			eax, [esi+17*4]
		mov			[edi+ 1*4], eax
		; 2 + 16 + 18 + carry
		mov			edx, ZERO
		mov			eax, [esi+ 2*4]
		adc64		edx, eax, [esi+16*4]
		add			     eax, [esi+18*4]
		mov			[edi+ 2*4], eax
		; 3 + 17 + 19 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 3*4]
		add64		eax, edx, [esi+17*4]
		add			     edx, [esi+19*4]
		mov			[edi+ 3*4], edx
		; 4 + 16 + 18 + 20 + carry
		mov			edx, ZERO
		adc64		edx, eax, [esi+ 4*4]
		add64		edx, eax, [esi+16*4]
		add64		edx, eax, [esi+18*4]
		add			     eax, [esi+20*4]
		mov			[edi+ 4*4], eax
		; 5 - 16 + 17 + 19 + 21 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 5*4]
		sub64		eax, edx, [esi+16*4]
		add64		eax, edx, [esi+17*4]
		add64		eax, edx, [esi+19*4]
		add64		eax, edx, [esi+21*4]
		mov			[edi+ 5*4], edx
		; 6 - 17 + 18 + 20 + 22 + carry
		cdq
		add64		edx, eax, [esi+ 6*4]
		sub64		edx, eax, [esi+17*4]
		add64		edx, eax, [esi+18*4]
		add64		edx, eax, [esi+20*4]
		add64		edx, eax, [esi+22*4]
		mov			[edi+ 6*4], eax
		; 7 - 18 + 19 + 21 + 23 + carry
		; 8 - 19 + 20 + 22 + 24 + carry
		mod128_T1_1line 7
		mod128_T1_1line 8
		; 9 - 20 + 21 + 23 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+ 9*4]
		sub64		edx, eax, [esi+20*4]
		add64		edx, eax, [esi+21*4]
		add64		edx, eax, [esi+23*4]
		mov			[edi+ 9*4], eax
		; 10 - 21 + 22 + 24 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+10*4]
		sub64		edx, eax, [esi+21*4]
		add64		edx, eax, [esi+22*4]
		add64		edx, eax, [esi+24*4]
		mov			[edi+10*4], eax
		; 11 - 22 + 23 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+11*4]
		sub64		edx, eax, [esi+22*4]
		add64		edx, eax, [esi+23*4]
		mov			[edi+11*4], eax
		; 12 + 16 - 23 + 24 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+12*4]
		add64		edx, eax, [esi+16*4]
		sub64		edx, eax, [esi+23*4]
		add64		edx, eax, [esi+24*4]
		mov			[edi+12*4], eax
		; 13 + 17 - 24 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+13*4]
		add64		edx, eax, [esi+17*4]
		sub64		edx, eax, [esi+24*4]
		mov			[edi+13*4], eax
		; 14 + 18 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+14*4]
		add64		edx, eax, [esi+18*4]
		mov			[edi+14*4], eax
		; 15 + 19 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+15*4]
		add64		edx, eax, [esi+19*4]
		mov			[edi+15*4], eax
		; 20 + carry
		; 21 + carry
		; 22 + carry
		; 23 + carry
		; 24 + carry
		mod128_T3_1line 16
		mod128_T3_1line 17
		mod128_T3_1line 18
		mod128_T3_1line 19
		mov			[edi+20*4], edx

	.mod_21_to_17:
		lea			esi, [mod]
		mov			edi, [esp+_P+12]	; p_dst
		; 0 + 16
		mov			eax, [esi+ 0*4]
		add			eax, [esi+16*4]
		mov			[edi+ 0*4], eax
		; 1 + 17 + carry
		mov			eax, [esi+ 1*4]
		adc			eax, [esi+17*4]
		mov			[edi+ 1*4], eax
		; 2 + 16 + 18 + carry
		mov			edx, ZERO
		mov			eax, [esi+ 2*4]
		adc64		edx, eax, [esi+16*4]
		add			     eax, [esi+18*4]
		mov			[edi+ 2*4], eax
		; 3 + 17 + 19 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 3*4]
		add64		eax, edx, [esi+17*4]
		add			     edx, [esi+19*4]
		mov			[edi+ 3*4], edx
		; 4 + 16 + 18 + 20 + carry
		mov			edx, ZERO
		adc64		edx, eax, [esi+ 4*4]
		add64		edx, eax, [esi+16*4]
		add64		edx, eax, [esi+18*4]
		add			     eax, [esi+20*4]
		mov			[edi+ 4*4], eax
		; 5 - 16 + 17 + 19 + carry
		mov			eax, ZERO
		adc64		eax, edx, [esi+ 5*4]
		sub64		eax, edx, [esi+16*4]
		add64		eax, edx, [esi+17*4]
		add64		eax, edx, [esi+19*4]
		mov			[edi+ 5*4], edx
		; 6 - 17 + 18 + 20 + carry
		cdq
		add64		edx, eax, [esi+ 6*4]
		sub64		edx, eax, [esi+17*4]
		add64		edx, eax, [esi+18*4]
		add64		edx, eax, [esi+20*4]
		mov			[edi+ 6*4], eax
		; 7 - 18 + 19 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+ 7*4]
		sub64		edx, eax, [esi+18*4]
		add64		edx, eax, [esi+19*4]
		mov			[edi+ 7*4], eax
		; 8 - 19 + 20 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+ 8*4]
		sub64		edx, eax, [esi+19*4]
		add64		edx, eax, [esi+20*4]
		mov			[edi+ 8*4], eax
		; 9 - 20 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+ 9*4]
		sub64		edx, eax, [esi+20*4]
		mov			[edi+ 9*4], eax
		; 10 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+10*4]
		mov			[edi+10*4], eax
		; 11 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+11*4]
		mov			[edi+11*4], eax
		; 12 + 16 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+12*4]
		add64		edx, eax, [esi+16*4]
		mov			[edi+12*4], eax
		; 13 + 17 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+13*4]
		add64		edx, eax, [esi+17*4]
		mov			[edi+13*4], eax
		; 14 + 18 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+14*4]
		add64		edx, eax, [esi+18*4]
		mov			[edi+14*4], eax
		; 15 + 19 + carry
		mov			eax, edx
		cdq
		add64		edx, eax, [esi+15*4]
		add			eax, [esi+19*4]
		mov			[edi+15*4], eax
		; 20 + carry
		adc			edx, [esi+20*4]
		mov			[edi+16*4], edx
%undef ZERO

		add			esp, _LOCAL
		pop			ebp
		pop			edi
		pop			esi
		pop			ebx
		ret


%macro mod_T1_1line 1
		mov			eax, edx
		cdq
		add			eax, [ebx+(%1)*4]
		adc			edx, ZERO
		mov			[ebx+(%1)*4], eax
%endm

%macro mod_sub_p_1line 1
		mov			eax, [ebx+(%1)*4]
		sbb			eax, [edx+(%1)*4]
		mov			[ebx+(%1)*4], eax
%endm

		end
