
;	for MTT
;	Copyright (C) 2002

%include "nasm.cfg"

%define R64_SIZE 16		; defined in mttimp4.cpp

	segment_data
	align 16
Q_LOW_MASK	dd	0xFFFFFFFF, 0, 0xFFFFFFFF, 0
DQ_1        dd  1, 0, 1, 0
Q_ALL1:
DQ_LOW_MASK dd  0xFFFFFFFF, 0xFFFFFFFF, 0, 0

r64_p   dd  0

	segment_text

; void r64_asm_init(uint64 const* r64_p_)
proc    r64_asm_init
%assign _P (4)
        mov         eax, [esp+_P+0]     ; r64_p_
        mov         [r64_p], eax
        ret


; 2002/12/07 130clk
;void 
proc  r64_add_SSE2; (uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst)
%if R64_SIZE != 16
%error R64_SIZE is assumed 64
%endif
		mov			eax, [esp + 4]	; p_src1
		mov			edx, [esp + 8]	; p_src2
		mov			ecx, [esp + 12]	; p_dst

		movdqa		xmm0, [eax + 0]
		movdqa		xmm1, [eax + 16]
		movdqa		xmm2, [eax + 32]
		movdqa		xmm3, [eax + 48]
		movdqa		xmm4, [eax + 64]
		movdqa		xmm5, [eax + 80]
		movdqa		xmm6, [eax + 96]
		movdqa		xmm7, [eax + 112]
		paddq		xmm0, [edx + 0]
		paddq		xmm1, [edx + 16]
		paddq		xmm2, [edx + 32]
		paddq		xmm3, [edx + 48]
		paddq		xmm4, [edx + 64]
		paddq		xmm5, [edx + 80]
		paddq		xmm6, [edx + 96]
		paddq		xmm7, [edx + 112]
		movdqa		[ecx + 0],  xmm0
		movdqa		[ecx + 16],  xmm1
		movdqa		[ecx + 32], xmm2
		movdqa		[ecx + 48], xmm3
		movdqa		[ecx + 64], xmm4
		movdqa		[ecx + 80], xmm5
		movdqa		[ecx + 96], xmm6
		movdqa		[ecx + 112], xmm7

        mov         eax, [eax + R64_SIZE * 8]
        add         eax, [edx + R64_SIZE * 8]
        add         eax, byte 1
        mov         [ecx + R64_SIZE * 8 + 0], eax
        xor         edx, edx
        mov         [ecx + R64_SIZE * 8 + 4], edx
        cmp         eax, (1<<30)-1
        jb          .exit
        push        ecx
        call        r64_semimod_SSE2
        add         esp, byte 4
    .exit:
		ret

; 2002/12/07 130clk
;void 
proc  r64_sub_SSE2; (uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst)
%if R64_SIZE != 16
%error R64_SIZE is assumed 64
%endif
		mov			eax, [esp + 4]	; p_src1
		mov			edx, [esp + 8]	; p_src2
		mov			ecx, [esp + 12]	; p_dst

		movdqa		xmm0, [eax + 0]
		movdqa		xmm1, [eax + 16]
		movdqa		xmm2, [eax + 32]
		movdqa		xmm3, [eax + 48]
		movdqa		xmm4, [eax + 64]
		movdqa		xmm5, [eax + 80]
		movdqa		xmm6, [eax + 96]
		movdqa		xmm7, [eax + 112]
		psubq		xmm0, [edx + 0]
		psubq		xmm1, [edx + 16]
		psubq		xmm2, [edx + 32]
		psubq		xmm3, [edx + 48]
		psubq		xmm4, [edx + 64]
		psubq		xmm5, [edx + 80]
		psubq		xmm6, [edx + 96]
		psubq		xmm7, [edx + 112]
		movdqa		[ecx + 0],  xmm0
		movdqa		[ecx + 16],  xmm1
		movdqa		[ecx + 32], xmm2
		movdqa		[ecx + 48], xmm3
		movdqa		[ecx + 64], xmm4
		movdqa		[ecx + 80], xmm5
		movdqa		[ecx + 96], xmm6
		movdqa		[ecx + 112], xmm7

        mov         eax, [eax + R64_SIZE * 8]
        add         eax, [edx + R64_SIZE * 8]
        add         eax, byte 1
        mov         [ecx + R64_SIZE * 8 + 0], eax
        xor         edx, edx
        mov         [ecx + R64_SIZE * 8 + 4], edx
        cmp         eax, (1<<30)-1
        jb          .exit
        push        ecx
        call        r64_semimod_SSE2
        add         esp, byte 4
    .exit:
		ret

; 2002/12/19 130clk
;void 
proc r64_change_sign_SSE2; (uint64* r64) {
%if R64_SIZE != 16
%error R64_SIZE is assumed 16
%endif
        mov         eax, [esp + 4]  ; r64

        pxor        xmm0, xmm0
        pxor        xmm1, xmm1
        pxor        xmm2, xmm2
        movdqa      xmm3, xmm0
        movdqa      xmm4, xmm0
        movdqa      xmm5, xmm0
        movdqa      xmm6, xmm0
        movdqa      xmm7, xmm0
        psubq       xmm0, [eax + 0]
        psubq       xmm1, [eax + 16]
        psubq       xmm2, [eax + 32]
        psubq       xmm3, [eax + 48]
        psubq       xmm4, [eax + 64]
        psubq       xmm5, [eax + 80]
        psubq       xmm6, [eax + 96]
        psubq       xmm7, [eax + 112]
        mov         edx, [eax + R64_SIZE * 8]
        movdqa      [eax + 0],  xmm0
        movdqa      [eax + 16], xmm1
        movdqa      [eax + 32], xmm2
        movdqa      [eax + 48], xmm3
        or          edx, byte 1
        movdqa      [eax + 64], xmm4
        movdqa      [eax + 80], xmm5
        movdqa      [eax + 96], xmm6
        movdqa      [eax + 112], xmm7
        mov         [eax + R64_SIZE * 8], edx
        ret

; input  : [edx:eax] = tmp, esi = r64, edi = 0
; output : [edx:eax]
%macro norm1line 1
		add			eax, [esi+%1*8]
		adc			edx, [esi+%1*8+4]
		mov			[esi+%1*8], eax
;		mov			[esi+%1*8+4], dword 0
		mov			[esi+%1*8+4], edi
		mov			eax, edx			; tmp>>32
		sar			edx, 31
%endm

; return [edx:eax]
;uint64
proc	r64_r64normalize_x86;(uint64* r64)
		push		ebx
		push		esi
		push		edi
%assign _P (4*3)

		xor			eax, eax
		xor			edx, edx
		xor			edi, edi
		mov			esi, [esp+_P+4]		; r64

%if 1
		; PȂ蔲(^^;
		norm1line	0
		norm1line	1
		norm1line	2
		norm1line	3
		norm1line	4
		norm1line	5
		norm1line	6
		norm1line	7
		norm1line	8
		norm1line	9
		norm1line	10
		norm1line	11
		norm1line	12
		norm1line	13
		norm1line	14
		norm1line	15
%else
		mov			ecx, R64_SIZE
.lp:
		add			eax, [esi]
		adc			edx, [esi+4]
		mov			[esi], eax
		mov			[esi+4], edi
		mov			eax, edx			; tmp>>32
		sar			edx, 31
		add			esi, byte 8
		dec			ecx
		jnz			.lp
%endif
.exit:
		pop			edi
		pop			esi
		pop			ebx
		ret

; 2002/11/20 275clk Ȃ݂ɓPCr64_r64normalize_x86265clk...
; 2002/11/20 255clk 
; return [edx:eax]
;uint64
proc	r64_r64normalize_SSE2;(uint64* r64)
; CLKBEGIN
%if R64_SIZE = 16
		mov			edx, [esp+4]		; r64
		pxor		mm0, mm0
		xor			eax, eax
%assign i 0
		por			mm0, [edx + i * 8]
		mov			[edx + i * 8 + 4], eax
		movq		mm2, mm0		; [H:L]
		psrad		mm0, 31			; [sign H:*]
		punpckhdq	mm2, mm0		; [sign H:H]
%assign i i+1
		paddq		mm2, [edx + i * 8]
		mov			[edx + i * 8 + 4], eax
		movq		mm0, mm2		; [H:L]
		movd		[edx + i * 8], mm2
		psrad		mm2, 31			; [sign H:*]
		punpckhdq	mm0, mm2		; [sign H:H]
%assign i i+1
%rep 7
		paddq		mm0, [edx + i * 8]
		mov			[edx + i * 8 + 4], eax
		movq		mm2, mm0		; [H:L]
		movd		[edx + i * 8], mm0
		psrad		mm0, 31			; [sign H:*]
		punpckhdq	mm2, mm0		; [sign H:H]
%assign i i+1
		paddq		mm2, [edx + i * 8]
		mov			[edx + i * 8 + 4], eax
		movq		mm0, mm2		; [H:L]
		movd		[edx + i * 8], mm2
		psrad		mm2, 31			; [sign H:*]
		punpckhdq	mm0, mm2		; [sign H:H]
%assign i i+1
%endrep
%else
		mov			edx, [esp+4]		; r64
		pxor		mm0, mm0
		movq		mm7, [Q_LOW_MASK]
		mov			ecx, R64_SIZE
.lp:
		paddq		mm0, [edx]
		movq		mm1, mm0
		pand		mm1, mm7
		movq		[edx], mm1
		movq		mm1, mm0		; [H:L]
		psrad		mm1, 31			; [sign H:*]
		punpckhdq	mm0, mm1		; [sign H:H]
		add			edx, byte 8
		sub			ecx, 1
		jnz			.lp
.exit:
%endif
		movd		eax, mm0
		psrlq		mm0, 32
		movd		edx, mm0
		emms
; CLKEND
		ret

; void r64_semimod(uint64* r64)
proc    r64_semimod_SSE2
%assign _P (4)

        mov         eax, [esp+_P+0]     ; r64
        push        eax
        call        r64_r64normalize_SSE2   ; return = edx:eax
        add         esp, byte 4

        movd        mm6, eax
        movd        mm7, edx
        punpckldq   mm6, mm7            ; tmp

        mov         eax, [esp+_P+0]     ; r64
        movq        mm0, [eax+12*8]
        movq        mm1, [eax+ 5*8]
        movq        mm2, [eax+ 4*8]
        movq        mm3, [eax+ 2*8]
        movq        mm4, [eax+ 0*8]
        paddq       mm0, mm6
        psubq       mm1, mm6
        paddq       mm2, mm6
        paddq       mm3, mm6
        paddq       mm4, mm6
        movq        [eax+12*8], mm0
        movq        [eax+ 5*8], mm1
        movq        [eax+ 4*8], mm2
        movq        [eax+ 2*8], mm3
        movq        [eax+ 0*8], mm4

        xor         edx, edx
        mov         [eax+R64_SIZE*8+4], edx
        add         edx, byte 1
        mov         [eax+R64_SIZE*8+0], edx

        emms
        ret

proc    r64_mul_simple_SSE2
        push        ebx
        push        esi
        push        edi
        push        ebp
%assign _P (4+4*4)

        mov         esi, [esp+_P+0]     ; p_src1
        mov         ebp, [esp+_P+4]     ; p_src2
        mov         edi, [esp+_P+8]     ; p_dst
        mov         ecx, [esp+_P+12]    ; len

        movq        xmm0, [ebp+0]       ; p_src2[0]
        punpcklqdq  xmm0, xmm0          ; p_src2[0] | p_src2[0]
        movq        xmm1, [ebp+8]       ; p_src2[1]
        punpcklqdq  xmm1, xmm1          ; p_src2[1] | p_src2[1]
        pxor        xmm2, xmm2          ; carry = 0
        pxor        xmm7, xmm7          ; 0
    .lp0:
        movdqa      xmm3, [esi]
        add         esi, byte 16
        movdqa      xmm4, xmm3
        pmuludq     xmm3, xmm0          ; p_src1[i+1] * p_src2[0] | p_src1[i+0] * p_src2[0]
        pmuludq     xmm4, xmm1          ; p_src1[i+1] * p_src2[1] | p_src1[i+0] * p_src2[1]
        movdqa      xmm5, xmm3
        punpckldq   xmm5, xmm7
        punpckhdq   xmm3, xmm7
        movdqa      xmm6, xmm4
        punpckldq   xmm6, xmm7
        punpckhdq   xmm4, xmm7
        paddq       xmm5, xmm2          ; +carry
        paddq       xmm3, xmm6          ; mid
        movdqa      xmm2, xmm7
        punpcklqdq  xmm2, xmm3
        paddq       xmm2, xmm5          ; +mid.l
        punpckhqdq  xmm3, xmm7
        paddq       xmm3, xmm4          ; +mid.h
        movdqa      [edi], xmm2
        add         edi, byte 16
        movdqa      xmm2, xmm3
        sub         ecx, byte 2
        jnz         .lp0
        movdqa      [edi], xmm2         ; p_dst[i] = carry

        add         ebp, byte 16        ; p_src2+=2
        mov         edi, [esp+_P+8]     ; p_dst
        lea         eax, [edi+16]       ; eax = p_dst+2
        mov         ebx, [esp+_P+12]    ; len
        sub         ebx, byte 2         ; j = len-2
    .lp_j:
        mov         esi, [esp+_P+0]     ; p_src1
        mov         ecx, [esp+_P+12]    ; ecx = len
        mov         edi, eax

        movq        xmm0, [ebp+0]
        punpcklqdq  xmm0, xmm0
        movq        xmm1, [ebp+8]
        punpcklqdq  xmm1, xmm1
        pxor        xmm2, xmm2
    .lp_i:
        movdqa      xmm3, [esi]
        add         esi, byte 16
        movdqa      xmm4, xmm3
        pmuludq     xmm3, xmm0
        pmuludq     xmm4, xmm1
        paddq       xmm2, [edi]
        movdqa      xmm5, xmm3
        punpckldq   xmm5, xmm7
        punpckhdq   xmm3, xmm7
        movdqa      xmm6, xmm4
        punpckldq   xmm6, xmm7
        punpckhdq   xmm4, xmm7
        paddq       xmm5, xmm2
        paddq       xmm3, xmm6
        movdqa      xmm2, xmm7
        punpcklqdq  xmm2, xmm3
        paddq       xmm2, xmm5
        punpckhqdq  xmm3, xmm7
        paddq       xmm3, xmm4
        movdqa      [edi], xmm2
        add         edi, byte 16
        movdqa      xmm2, xmm3
        sub         ecx, byte 2
        jnz         .lp_i
        movdqa      [edi], xmm2
        add         eax, byte 16
        add         ebp, byte 16
        sub         ebx, byte 2
        jnz near    .lp_j
    .exit:
        pop         ebp
        pop         edi
        pop         esi
        pop         ebx
        ret

; r64_square_simple_SSE2_len8(uint64 const* p_src, uint64* p_dst)
proc    r64_square_simple_SSE2_len8
        push        ebx
        push        esi
        push        edi
        push        ebp
%assign _P (4+4*4)

        mov         esi, [esp+_P+0]     ; p_src
        mov         edi, [esp+_P+4]     ; p_dst
        pxor        xmm7, xmm7

        ; 0-1
        movdqa      xmm0, [esi+0*8]     ; 1 | 0
        pmuludq     xmm0, xmm0          ; 11 | 00
        movdqa      xmm1, xmm0
        punpckldq   xmm0, xmm7          ; 00.h | 00.l
        punpckhdq   xmm1, xmm7          ; 11.h | 11.l
        movdqa      [edi+0*8], xmm0

        ;2-3
        ; xmm1 = 11
        movq        xmm0, [esi+0*8]     ; 0
        punpcklqdq  xmm0, xmm0          ; 0 | 0
        movq        xmm2, [esi+2*8]     ; 2
        punpcklqdq  xmm2, [esi+4*8]     ; 4 | 2
        pmuludq     xmm0, xmm2          ; 40 | 20
        movdqa      xmm2, xmm0
        punpckldq   xmm0, xmm7          ; 20.h | 20.l
        punpckhdq   xmm2, xmm7          ; 40.h | 40.l
        paddq       xmm0, xmm0          ; 20*2
        paddq       xmm0, xmm1          ; 20*2 + 11
        movdqa      [edi+2*8], xmm0

        ;4-5
        ; xmm2 = 40
        movdqa      xmm0, [esi+2*8]     ; 3 | 2
        pmuludq     xmm0, xmm0          ; 33 | 22
        movdqa      xmm1, xmm0
        punpckldq   xmm0, xmm7          ; 22.h | 22.l
        punpckhdq   xmm1, xmm7          ; 33.h | 33.l

        movq        xmm3, [esi+1*8]     ; 1
        punpcklqdq  xmm3, xmm3          ; 1 | 1
        movq        xmm4, [esi+3*8]     ; 3
        movq        xmm6, [esi+5*8]
        punpcklqdq  xmm4, xmm6          ; 5 | 3
        pmuludq     xmm3, xmm4          ; 51 | 31
        movdqa      xmm4, xmm3
        punpckldq   xmm3, xmm7          ; 31.h | 31.l
        punpckhdq   xmm4, xmm7          ; 51.h | 51.l
        paddq       xmm2, xmm3          ; 04 + 31
        paddq       xmm2, xmm2          ; (04 + 31)*2
        paddq       xmm0, xmm2          ; (04 + 31)*2 + 22
        movdqa      [edi+4*8], xmm0

        ;6-7
        ; xmm1 = 33
        ; xmm4 = 51
        movq        xmm0, [esi+6*8]     ; 6
        punpcklqdq  xmm0, xmm0          ; 6 | 6
        movq        xmm2, [esi+0*8]     ; 0
        punpcklqdq  xmm2, [esi+2*8]     ; 2 | 0
        pmuludq     xmm0, xmm2          ; 26 | 06
        movdqa      xmm2, xmm0
        punpckldq   xmm0, xmm7          ; 06.h | 06.l
        punpckhdq   xmm2, xmm7          ; 26.h | 26.l
        paddq       xmm0, xmm4          ; 51 + 06

        ; xmm0 = 51 + 06
        ; xmm1 = 33
        ; xmm2 = 26
        movdqa      xmm3, [esi+2*8]     ; 3 | 2
        pmuludq     xmm3, [esi+4*8]     ; 5 | 4
        movdqa      xmm4, xmm3
        punpckldq   xmm3, xmm7          ; 24.h | 24.l
        punpckhdq   xmm4, xmm7          ; 35.h | 35.l
        paddq       xmm0, xmm3          ; 51 + 06 +24
        paddq       xmm2, xmm4          ; 26 + 35
        paddq       xmm0, xmm0          ; (51 + 06 + 24)*2
        paddq       xmm0, xmm1          ; (51 + 06 + 24)*2 + 33
        movdqa      [edi+6*8], xmm0

        ;8-9
        ; xmm2 = 26 + 35
        movdqa      xmm0, [esi+4*8]     ; 5 | 4
        pmuludq     xmm0, xmm0          ; 55 | 44
        movdqa      xmm1, xmm0
        punpckldq   xmm0, xmm7          ; 44.h | 44.l
        punpckhdq   xmm1, xmm7          ; 55.h | 55.l

        movq        xmm3, [esi+7*8]     ; 7
        punpcklqdq  xmm3, xmm3          ; 7 | 7
        movq        xmm4, [esi+1*8]     ; 1
        movq        xmm5, [esi+3*8]
        punpcklqdq  xmm4, xmm5          ; 3 | 1
        pmuludq     xmm3, xmm4          ; 37 | 17
        movdqa      xmm4, xmm3
        punpckldq   xmm3, xmm7          ; 17.h | 17.l
        punpckhdq   xmm4, xmm7          ; 37.h | 37.l
        paddq       xmm2, xmm3          ; 26 + 35 + 17
        paddq       xmm2, xmm2          ; (26 + 35 + 17)*2
        paddq       xmm0, xmm2          ; (26 + 35 + 17)*2 + 44
        movdqa      [edi+8*8], xmm0

        ;10-11
        ; xmm1 = 55
        ; xmm4 = 37
        movdqa      xmm0, [esi+4*8]     ; 5 | 4
        pmuludq     xmm0, [esi+6*8]     ; 7 | 6
        movdqa      xmm2, xmm0
        punpckldq   xmm0, xmm7          ; 46.h | 46.l
        punpckhdq   xmm2, xmm7          ; 57.h | 57.l
        paddq       xmm0, xmm4          ; 46 + 37
        paddq       xmm0, xmm0          ; (46 + 37)*2
        paddq       xmm0, xmm1          ; (46 + 37)*2 + 55
        movdqa      [edi+10*8], xmm0

        ;12-13, 14-15
        ; xmm2 = 57
        movdqa      xmm0, [esi+6*8]     ; 7 | 6
        pmuludq     xmm0, xmm0          ; 77 | 66
        movdqa      xmm1, xmm0
        punpckldq   xmm0, xmm7          ; 66.h | 66.l
        punpckhdq   xmm1, xmm7          ; 77.h | 77.l
        paddq       xmm2, xmm2          ; 57*2
        paddq       xmm0, xmm2          ; 57*2 + 66
        movdqa      [edi+12*8], xmm0
        movdqa      [edi+14*8], xmm1

        ;+1
        movq        xmm0, [esi+0*8]     ; 0
        punpcklqdq  xmm0, xmm0          ; 0 | 0
        movq        xmm1, [esi+1*8]     ; 1
        movq        xmm2, [esi+3*8]
        punpcklqdq  xmm1, xmm2          ; 3 | 1
        movdqa      xmm6, xmm1
        pmuludq     xmm1, xmm0          ; 30 | 10
        movdqa      xmm2, xmm1
        punpckldq   xmm1, xmm7          ; 10.h | 10.l
        punpckhdq   xmm2, xmm7          ; 30.h | 30.l
        paddq       xmm1, xmm1          ; 10*2
        movq        xmm3, [edi+1*8]     ; 1
        paddq       xmm3, xmm1          ; 1 + 10*2.l
        punpckhqdq  xmm1, xmm1          ; 10*2.h
        movq        xmm4, [edi+2*8]     ; 2
        paddq       xmm4, xmm1          ; 2 + 10*2.h
        movq        [edi+1*8], xmm3
        movq        [edi+2*8], xmm4

        ;+3
        ; xmm0 = 0 | 0
        ; xmm2 = 30
        ; xmm6 = 3 | 1
        movq        xmm1, [esi+1*8]     ; 1
        punpcklqdq  xmm1, xmm1          ; 1 | 1
        movq        xmm3, [esi+2*8]     ; 2
        punpcklqdq  xmm3, [esi+4*8]     ; 4 | 2
        pmuludq     xmm1, xmm3          ; 41 | 21
        movdqa      xmm4, xmm1
        punpckldq   xmm1, xmm7          ; 21.h | 21.l
        punpckhdq   xmm4, xmm7          ; 41.h | 41.l
        paddq       xmm1, xmm2          ; 21 + 30
        paddq       xmm1, xmm1          ; (21 + 30)*2
        movq        xmm2, [edi+3*8]     ; 3
        paddq       xmm2, xmm1          ; 3 + 3'l
        punpckhqdq  xmm1, xmm1          ; 3'h
        movq        xmm5, [edi+4*8]     ; 4
        paddq       xmm5, xmm1          ; 4 + 3'h
        movq        [edi+3*8], xmm2
        movq        [edi+4*8], xmm5

        ;+5
        ; xmm0 = 0 | 0
        ; xmm3 = 4 | 2
        ; xmm4 = 41
        ; xmm6 = 3 | 1
        movq        xmm1, [esi+5*8]     ; 5
        movq        xmm2, [esi+7*8]
        punpcklqdq  xmm1, xmm2          ; 7 | 5
        pmuludq     xmm0, xmm1          ; 07 | 05
        movdqa      xmm2, xmm0
        punpckldq   xmm0, xmm7          ; 05.h | 05.l
        punpckhdq   xmm2, xmm7          ; 07.h | 07.l
        paddq       xmm0, xmm4          ; 05 + 41

        movq        xmm4, [esi+2*8]     ; 2
        punpcklqdq  xmm4, xmm4          ; 2 | 2
        movq        xmm5, [esi+3*8]     ; 3
        movq        xmm1, [esi+5*8]
        punpcklqdq  xmm5, xmm1          ; 5 | 3
        pmuludq     xmm4, xmm5          ; 52 | 32
        movdqa      xmm1, xmm4
        punpckldq   xmm4, xmm7          ; 32.h | 32.l
        punpckhdq   xmm1, xmm7          ; 52.h | 52.l
        paddq       xmm0, xmm4          ; 05 + 41 + 32
        paddq       xmm1, xmm2          ; 52 + 07
        paddq       xmm0, xmm0          ; (05 + 41 + 32)*2
        movq        xmm4, [edi+5*8]     ; 5
        paddq       xmm4, xmm0          ; 5 + 5'l
        punpckhqdq  xmm0, xmm0          ; 5'h
        movq        [edi+5*8], xmm4
        movq        xmm4, [edi+6*8]     ; 6
        paddq       xmm4, xmm0          ; 6 + 5'h
        movq        [edi+6*8], xmm4

        ;+7
        ; xmm1 = 52 + 07
        ; xmm3 = 4 | 2
        ; xmm6 = 3 | 1
        movq        xmm0, [esi+6*8]     ; 6
        punpcklqdq  xmm0, xmm0          ; 6 | 6
        pmuludq     xmm0, xmm6          ; 63 | 61
        movdqa      xmm6, xmm0
        punpckldq   xmm0, xmm7          ; 61.h | 61.l
        punpckhdq   xmm6, xmm7          ; 63.h | 63.l
        paddq       xmm0, xmm1          ; 52 + 07 + 61

        ; xmm0 = 52 + 07 + 61
        ; xmm3 = 4 | 2
        ; xmm6 = 63
        movq        xmm1, [esi+4*8]     ; 4
        punpcklqdq  xmm1, xmm1          ; 4 | 4
        movq        xmm2, [esi+3*8]     ; 3
        movq        xmm4, [esi+5*8]
        punpcklqdq  xmm2, xmm4          ; 5 | 3
        pmuludq     xmm1, xmm2          ; 54 | 34
        movdqa      xmm2, xmm1
        punpckldq   xmm1, xmm7          ; 34.h | 34.l
        punpckhdq   xmm2, xmm7          ; 54.h | 54.l
        paddq       xmm0, xmm1          ; 52 + 07 + 61 + 34
        paddq       xmm0, xmm0          ; (52 + 07 + 61 + 34)*2
        movq        xmm1, [edi+7*8]     ; 7
        paddq       xmm1, xmm0          ; 7 + 7'l
        punpckhqdq  xmm0, xmm0          ; 7'h
        movq        xmm4, [edi+8*8]     ; 8
        paddq       xmm4, xmm0          ; 8 + 7'h
        movq        [edi+7*8], xmm1
        movq        [edi+8*8], xmm4

        ;+9
        ; xmm2 = 54
        ; xmm3 = 4 | 2
        ; xmm6 = 63
        movq        xmm0, [esi+7*8]     ; 7
        punpcklqdq  xmm0, xmm0          ; 7 | 7
        pmuludq     xmm0, xmm3          ; 74 | 72
        movdqa      xmm3, xmm0
        punpckldq   xmm0, xmm7          ; 72.h | 72.l
        punpckhdq   xmm3, xmm7          ; 74.h | 74.l
        paddq       xmm2, xmm6          ; 54 + 63
        paddq       xmm0, xmm2          ; 54 + 63 + 72
        paddq       xmm0, xmm0          ; (54 + 63 + 72)*2
        movq        xmm4, [edi+9*8]     ; 9
        paddq       xmm4, xmm0          ; 9 + 9'l
        punpckhqdq  xmm0, xmm0          ; 9'h
        movq        [edi+9*8], xmm4
        movq        xmm4, [edi+10*8]    ; 10
        paddq       xmm4, xmm0          ; 10 + 9'h
        movq        [edi+10*8], xmm4

        ;+11, +13
        ; xmm3 = 74
        movq        xmm0, [esi+6*8]     ; 6
        punpcklqdq  xmm0, xmm0          ; 6 | 6
        movq        xmm1, [esi+5*8]     ; 5
        movq        xmm2, [esi+7*8]
        punpcklqdq  xmm1, xmm2          ; 7 | 5
        pmuludq     xmm0, xmm1          ; 67 | 65
        movdqa      xmm1, xmm0
        punpckldq   xmm0, xmm7          ; 65.h | 65.l
        punpckhdq   xmm1, xmm7          ; 67.h | 67.l
        paddq       xmm0, xmm3          ; 65 + 74
        paddq       xmm1, xmm1          ; 67*2
        paddq       xmm0, xmm0          ; (65 + 74)*2

        movq        xmm4, [edi+11*8]    ; 11
        paddq       xmm4, xmm0          ; 11 + 11'l
        punpckhqdq  xmm0, xmm0          ; 11'h
        movq        [edi+11*8], xmm4
        movq        xmm4, [edi+12*8]    ; 12
        paddq       xmm4, xmm0          ; 12 + 12'h
        movq        [edi+12*8], xmm4

        movq        xmm4, [edi+13*8]    ; 13
        paddq       xmm4, xmm1          ; 13 + 13'l
        punpckhqdq  xmm1, xmm1          ; 13'h
        movq        [edi+13*8], xmm4
        movq        xmm4, [edi+14*8]    ; 14
        paddq       xmm4, xmm1          ; 14 + 14'h
        movq        [edi+14*8], xmm4
    .exit:
        pop         ebp
        pop         edi
        pop         esi
        pop         ebx
        ret

; void r64_square_karatsuba(uint64 const* p_src, uint64* p_dst)
proc    r64_square_karatsuba_SSE2
        push        ebx
        push        esi
        push        edi
        push        ebp
%assign _LOCAL 16*8+16+4
		sub			esp, _LOCAL
%define	p_tmp [esp]
        mov         eax, esp
        add         eax, 16+4
        and         eax, -16
        mov         p_tmp, eax
%assign _P (4+4*4+_LOCAL)

        mov         esi, [esp+_P+0]     ; p_src
        mov         edi, [esp+_P+4]     ; p_dst
        pxor        mm7, mm7

        pxor        mm0, mm0            ; carry = 0
        xor         eax, eax
    .lp0:
        paddq       mm0, [esi+eax*8+ 8*8]
        psubq       mm0, [esi+eax*8+ 0*8]
        movq        mm1, mm0
        movq        mm2, mm0
        psrad       mm1, 31
        punpckhdq   mm0, mm1            ; (signed mm0)>>32
        punpckldq   mm2, mm7            ; mm0 & 0xffffffff
        movq        [edi+eax*8], mm2
        add         eax, 1
        cmp         eax, 8
        jb          .lp0

        punpckhdq   mm0, mm7
        movq        mm6, mm0            ; mask
        pand        mm0, [DQ_1]         ; carry
        xor         eax, eax
    .lp1:
        movq        mm1, [edi+eax*8]
        pxor        mm1, mm6
        paddq       mm0, mm1
        movq        mm1, mm0
        punpckhdq   mm0, mm7
        punpckldq   mm1, mm7
        movq        [edi+eax*8], mm1
        add         eax, 1
        cmp         eax, 8
        jb          .lp1

        mov         eax, p_tmp
        push        eax
        push        edi
        call r64_square_simple_SSE2_len8

        lea         eax, [edi+16*8]
        push        eax
        lea         eax, [esi+ 8*8]
        push        eax
        call r64_square_simple_SSE2_len8

        push        edi
        push        esi
        call r64_square_simple_SSE2_len8

        add         esp, byte 6*4

        mov         eax, p_tmp
        movdqa      xmm0, [edi+ 0*8]
        movdqa      xmm4, [edi+ 8*8]
        paddq       xmm0, xmm4
        paddq       xmm0, [edi+16*8]
        psubq       xmm0, [eax+ 0*8]
        movdqa      [edi+ 8*8], xmm0
        ;
        movdqa      xmm1, [edi+ 2*8]
        movdqa      xmm5, [edi+10*8]
        paddq       xmm1, xmm5
        paddq       xmm1, [edi+18*8]
        psubq       xmm1, [eax+ 2*8]
        movdqa      [edi+10*8], xmm1
        ;
        movdqa      xmm2, [edi+ 4*8]
        movdqa      xmm6, [edi+12*8]
        paddq       xmm2, xmm6
        paddq       xmm2, [edi+20*8]
        psubq       xmm2, [eax+ 4*8]
        movdqa      [edi+12*8], xmm2
        ;
        movdqa      xmm3, [edi+ 6*8]
        movdqa      xmm7, [edi+14*8]
        paddq       xmm3, xmm7
        paddq       xmm3, [edi+22*8]
        psubq       xmm3, [eax+ 6*8]
        movdqa      [edi+14*8], xmm3
        ;
        paddq       xmm4, [edi+16*8]
        paddq       xmm4, [edi+24*8]
        psubq       xmm4, [eax+ 8*8]
        movdqa      [edi+16*8], xmm4
        ;
        paddq       xmm5, [edi+18*8]
        paddq       xmm5, [edi+26*8]
        psubq       xmm5, [eax+10*8]
        movdqa      [edi+18*8], xmm5
        ;
        paddq       xmm6, [edi+20*8]
        paddq       xmm6, [edi+28*8]
        psubq       xmm6, [eax+12*8]
        movdqa      [edi+20*8], xmm6
        ;
        paddq       xmm7, [edi+22*8]
        paddq       xmm7, [edi+30*8]
        psubq       xmm7, [eax+14*8]
        movdqa      [edi+22*8], xmm7

      .exit:
        emms
		add			esp, _LOCAL
        pop         ebp
        pop         edi
        pop         esi
        pop         ebx
        ret

; void r64_mul_karatsuba(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst)
proc    r64_mul_karatsuba_SSE2
        push        ebx
        push        esi
        push        edi
        push        ebp
%assign _LOCAL (16*8)+(16)+8+16
		sub			esp, _LOCAL
%define	p_tmp  [esp+4]
%define	p_mask [esp]
        mov         eax, esp
        add         eax, 8+16
        and         eax, -16
        mov         p_mask, eax
        add         eax, 16
        mov         p_tmp, eax
%assign _P (4+4*4+_LOCAL)

        mov         esi, [esp+_P+0]     ; p_src1
        mov         ebx, [esp+_P+4]     ; p_src2
        mov         edi, [esp+_P+8]     ; p_dst
        pxor        mm7, mm7

        pxor        mm0, mm0            ; carry_a = 0
        pxor        mm1, mm1            ; carry_b = 0
        xor         eax, eax
    .lp0:
        paddq       mm0, [esi+eax*8+ 8*8]
        paddq       mm1, [ebx+eax*8+ 8*8]
        psubq       mm0, [esi+eax*8+ 0*8]
        psubq       mm1, [ebx+eax*8+ 0*8]
        movq        mm2, mm0
        movq        mm3, mm1
        psrad       mm2, 31
        psrad       mm3, 31
        movq        mm4, mm0
        movq        mm5, mm1
        punpckhdq   mm0, mm2            ; (signed mm0)>>32
        punpckhdq   mm1, mm3
        punpckldq   mm4, mm7            ; mm0 & 0xffffffff
        punpckldq   mm5, mm7
        movq        [edi+eax*8+8*8], mm4
        movq        [edi+eax*8+0*8], mm5
        add         eax, 1
        cmp         eax, 8
        jb          .lp0

        punpckhdq   mm0, mm7
        punpckhdq   mm1, mm7
        movq        mm5, mm0            ; mask
        movq        mm6, mm1
        movq        mm2, [DQ_1]
        pand        mm0, mm2            ; carry
        pand        mm1, mm2
        xor         eax, eax
    .lp1:
        movq        mm2, [edi+eax*8+8*8]
        movq        mm3, [edi+eax*8+0*8]
        pxor        mm2, mm5
        pxor        mm3, mm6
        paddq       mm0, mm2
        paddq       mm1, mm3
        movq        mm2, mm0
        movq        mm3, mm1
        punpckhdq   mm0, mm7
        punpckhdq   mm1, mm7
        punpckldq   mm2, mm7
        punpckldq   mm3, mm7
        movq        [edi+eax*8+8*8], mm2
        movq        [edi+eax*8+0*8], mm3
        add         eax, 1
        cmp         eax, 8
        jb          .lp1

        pxor        mm5, mm6
        punpckldq   mm5, mm5            ; mask
        mov         eax, p_mask
        movq        [eax+0], mm5
        movq        [eax+8], mm5

        mov         edx, p_tmp
        push        dword 8
        push        edx
        push        edi
        lea         eax, [edi+8*8]
        push        eax
        call r64_mul_simple_SSE2

        push        dword 8
        lea         eax, [edi+16*8]
        push        eax
        lea         eax, [ebx+ 8*8]
        push        eax
        lea         eax, [esi+ 8*8]
        push        eax
        call r64_mul_simple_SSE2

        push        dword 8
        push        edi
        push        ebx
        push        esi
        call r64_mul_simple_SSE2

        add         esp, byte 12*4

        mov         eax, p_mask
        movdqa      xmm7, [eax]
        mov         eax, p_tmp
        ;
        movdqa      xmm0, [edi+ 0*8]
        movdqa      xmm3, [edi+ 8*8]
        paddq       xmm0, xmm3
        paddq       xmm0, [edi+16*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+ 0*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm0, xmm1
        paddq       xmm0, xmm2
        movdqa      [edi+ 8*8], xmm0
        ;
        movdqa      xmm0, [edi+ 2*8]
        movdqa      xmm4, [edi+10*8]
        paddq       xmm0, xmm4
        paddq       xmm0, [edi+18*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+ 2*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm0, xmm1
        paddq       xmm0, xmm2
        movdqa      [edi+10*8], xmm0
        ;
        movdqa      xmm0, [edi+ 4*8]
        movdqa      xmm5, [edi+12*8]
        paddq       xmm0, xmm5
        paddq       xmm0, [edi+20*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+ 4*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm0, xmm1
        paddq       xmm0, xmm2
        movdqa      [edi+12*8], xmm0
        ;
        movdqa      xmm0, [edi+ 6*8]
        movdqa      xmm6, [edi+14*8]
        paddq       xmm0, xmm6
        paddq       xmm0, [edi+22*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+ 6*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm0, xmm1
        paddq       xmm0, xmm2
        movdqa      [edi+14*8], xmm0
        ;
        paddq       xmm3, [edi+16*8]
        paddq       xmm3, [edi+24*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+ 8*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm3, xmm1
        paddq       xmm3, xmm2
        movdqa      [edi+16*8], xmm3
        ;
        paddq       xmm4, [edi+18*8]
        paddq       xmm4, [edi+26*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+10*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm4, xmm1
        paddq       xmm4, xmm2
        movdqa      [edi+18*8], xmm4
        ;
        paddq       xmm5, [edi+20*8]
        paddq       xmm5, [edi+28*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+12*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm5, xmm1
        paddq       xmm5, xmm2
        movdqa      [edi+20*8], xmm5
        ;
        paddq       xmm6, [edi+22*8]
        paddq       xmm6, [edi+30*8]
        movdqa      xmm1, xmm7
        movdqa      xmm2, [eax+14*8]
        pandn       xmm1, xmm2
        pand        xmm2, xmm7
        psubq       xmm6, xmm1
        paddq       xmm6, xmm2
        movdqa      [edi+22*8], xmm6

      .exit:
        emms
		add			esp, _LOCAL
        pop         ebp
        pop         edi
        pop         esi
        pop         ebx
        ret

; void r64_long_mod(uint64* p_dst)
proc    r64_long_mod_SSE2
        push        ebx
        push        esi
        push        edi
        push        ebp
%assign _P (4+4*4)

        ; modA512bitȏ̐̕܏
        pxor        xmm7, xmm7
        mov         eax, [esp+_P+0]     ; p_dst
        mov         ebx, 16
        xor         edi, edi
    .lp0:
        movdqa      xmm0, [eax+edi*8+16*8]
        movdqa      xmm1, [eax+edi*8+12*8]
        movdqa      xmm2, [eax+edi*8+ 6*8]
        movdqa      xmm3, [eax+edi*8+ 4*8]
        movdqa      xmm4, [eax+edi*8+ 2*8]
        movdqa      xmm5, [eax+edi*8+ 0*8]

        paddq       xmm1, xmm0
        paddq       xmm3, xmm0
        paddq       xmm4, xmm0
        paddq       xmm5, xmm0
        ;
        movdqa      xmm6, xmm7          ; 0   | 0
        punpcklqdq  xmm6, xmm0          ; t.l | 0
        punpckhqdq  xmm0, xmm7          ; 0   | t.h
        psubq       xmm2, xmm0
        psubq       xmm3, xmm6

        movdqa      [eax+edi*8+16*8], xmm7
        movdqa      [eax+edi*8+12*8], xmm1
        movdqa      [eax+edi*8+ 6*8], xmm2
        movdqa      [eax+edi*8+ 4*8], xmm3
        movdqa      [eax+edi*8+ 2*8], xmm4
        movdqa      [eax+edi*8+ 0*8], xmm5
        add         edi, byte 2
        cmp         edi, ebx
        jne         .lp0
        xor         edi, edi
        sub         ebx, 4
        jnz near    .lp0

        ; 512bitȏ̏璷
        movq        mm0, [eax+15*8]
        movq        mm1, mm0
        movq        mm2, mm0
        psrad       mm1, 31
        punpckhdq   mm0, mm1
        pxor        mm7, mm7
        punpckldq   mm2, mm7
        movq        [eax+15*8], mm2
        movq        mm1, [eax+12*8]
        movq        mm2, [eax+ 5*8]
        movq        mm3, [eax+ 4*8]
        movq        mm4, [eax+ 2*8]
        movq        mm5, [eax+ 0*8]
        paddq       mm1, mm0
        psubq       mm2, mm0
        paddq       mm3, mm0
        paddq       mm4, mm0
        paddq       mm5, mm0
        movq        [eax+12*8], mm1
        movq        [eax+ 5*8], mm2
        movq        [eax+ 4*8], mm3
        movq        [eax+ 2*8], mm4
        movq        [eax+ 0*8], mm5

        mov         edx, (1<<30)
        mov         [eax+R64_SIZE*8+0], edx
        xor         edx, edx
        mov         [eax+R64_SIZE*8+4], edx

        emms
		pop			ebp
		pop			edi
		pop			esi
		pop			ebx
		ret

; void r64_mul(uint64 const* p_src1, uint64 const* p_src2, uint64* p_dst) {
proc    r64_mul_SSE2
        push        ebx
        push        esi
        push        edi
        push        ebp
%assign _LOCAL (32*8)+4+16
		sub			esp, _LOCAL
%define	p_tmp  [esp]
        mov         eax, esp
        add         eax, 4+16
        and         eax, -16
        mov         p_tmp, eax
%assign _P (4+4*4+_LOCAL)

        mov         esi, [esp+_P+0]     ; p_src1
        mov         ebx, [esp+_P+4]     ; p_src2
        mov         edi, [esp+_P+8]     ; p_dst
        push        eax
        push        ebx

        cmp         esi, ebx
        je          .square
    .mul:
        push        esi
        call        r64_mul_karatsuba_SSE2
        add         esp, byte 12
        jmp         .mod
    .square:
        call        r64_square_karatsuba_SSE2
        add         esp, byte 8

    .mod:
        mov         eax, p_tmp
        push        eax
        call        r64_long_mod_SSE2
        pop         eax

        ; copy
        mov         ecx, -16
    .copy_lp:
        movdqa      xmm0, [eax+ecx*8+16*8+ 0]
        movdqa      xmm1, [eax+ecx*8+16*8+16]
        movdqa      [edi+ecx*8+16*8+ 0], xmm0
        movdqa      [edi+ecx*8+16*8+16], xmm1
        add         ecx, byte 4
        jnz         .copy_lp
        movq        xmm0, [eax+16*8]
        movq        [edi+16*8], xmm0
    .exit:
		add			esp, _LOCAL
		pop			ebp
		pop			edi
		pop			esi
		pop			ebx
		ret

		end
