#ifndef   MTT_BITWINDOW_TMPL_H
#define   MTT_BITWINDOW_TMPL_H

// ===========================================================================
//  signed_window_tmpl.h -- ׂ扉Zwindow@ɂ荂
// ---------------------------------------------------------------------------
// wI
//  ZpĂׂ扉ZɍsȂƂlBႦ΁A
//	153 = 128 + 16 + 8 + 1 = ((8 + 1)*2 + 1)*8 + 1
// ł邱Ƃ𗘗pāAa^153߂ɂ́A
//	a^153 = ((a^8 * a)^2 * a)^8 * a
// Ƃ̂fłB扉Z3a^8܂AȉZAAZA
// 3AZ̏ɌvZa^153܂BA1532i\
// 100110011001Ƃp^[܂ނƂɒڂƁA
//	b = a^8 * a,  a^153 = b^16 * b 
// ƌvZłBꂾƁAu3AZA4AZvŌvZIA
// Z̐1񌸂B̂Ƃ 1001 ̂悤ȃp^[windowƌĂсA
// ̂悤ȌŏZ̉񐔂炷@(sliding )window@ƌB
//  window@ɂ͗\߃p^[pӂĂŒwindow@ƁAIɃp^[
// 𔭌ĂIwindow@Aaɑ΂ĉxׂ߂
// ꍇ͌Œwindow@̂ق|IɗǂB܂Aȉ~Ȑ̓_̔{ZŒ
// window@ŋ߂ꍇ́AMontgomery@ɂp^[𐳋KĂ
// \łB
//  Z\ȏꍇ͂ a^15 = a^16/â悤ȍHv\łB
// ̏ꍇ-1܂߂čœKbit\߂B
// 
// gp̐
//  B̓rbgZNXƂAB͈ȉI/FƂ:
//   1. B̍őbit(enumȂǂŒ`)
//	  B::SIZE_IN_BITS
//   2. rbg𓾂֐
//	  int numBits() const
//   3. erbg̏Ԃ𓾂֐
//	  int isBitOn(int) const
//
// ̂ƂAsigned57_<B>, unsigned5_<B>ړĨNXƂȂBA
// ̂܂܂̃NXpł͂ȂB


namespace mttbw {
// ===========================================================================
//  b_: bit representation
template<class B>
class b_ {
public:
  b_(B const& b) : bits_(b) {}
  int numBits() const { return bits_.numBits(); }
  int isBitOn(int b) const { return bits_.isBitOn(b); }
  B const& bits_;
};

// ===========================================================================
//  signedbase_: base class of signed window
template<class B>
class signedbase_ {
public:
	// ----------------------------------------------------------------------
	//  flags
	enum {
		op_double = 0,
		op_add,
		op_sub,
		ENUM_FORBIDS_EXTRA_COMMAS
	};
   
	// ----------------------------------------------------------------------
	//  ctor, dtor
	signedbase_(b_<B> const& t) {
		int maxbits = t.numBits();
		int carry = t.isBitOn(0);
		for(bits_ = 1; bits_ < maxbits; ++bits_) {
			int bit = t.isBitOn(bits_);
			carry += bit;
			int res = (carry&1) - bit;
			buf_[bits_-1] = res > 0? '+': res < 0? '-': '0';
			carry /= 2;
			carry += bit;
		}
		if(carry > 1) buf_[bits_++-1] = '0';
		buf_[bits_-1] = '+';
	}
	~signedbase_() {}
	
	// ----------------------------------------------------------------------
	//  operations
	void begin() { ptr_ = bits_; }
protected:
	char buf_[B::SIZE_IN_BITS+8];
	int bits_, ptr_;
};


// ===========================================================================
//  signed57_: signed 5bit and unsigned 7bit window
template<class B>
class signed57_ : public signedbase_<B> {
public:
	// ----------------------------------------------------------------------
	//  ctor, dtor
	signed57_(b_<B> const& t) : signedbase_<B>(t) {}
	~signed57_() {}
	
	// ----------------------------------------------------------------------
	//  operations
	bool next_op(int& op, int& num) {
		int& ptr_ = signedbase_<B>::ptr_;
		char*const buf_ = signedbase_<B>::buf_;
		
		if(!ptr_) return false;
		bool zero = (buf_[ptr_-1] == '0');
		if(zero) {
			op = signedbase_<B>::op_double;
			num = 0;
			while(ptr_ > 0 && buf_[ptr_-1] == '0') {
				++num;
				--ptr_;
			}
		}
		int nbits = ptr_ > 7? 7: ptr_;
		while(nbits > 0 && buf_[ptr_-nbits] == '0') --nbits;
		if(nbits > 5) {
			for(int i = 2; i < nbits; ++i) {
				if(buf_[ptr_-1] + buf_[ptr_-i-1] == '+' + '-') {
					nbits = 5;
					while(nbits > 0 && buf_[ptr_-nbits] == '0') --nbits;
					break;
				}
			}
		}
		if(zero) num += nbits;
		else {
			num = 0;
			for(int i = 0; i < nbits; ++i) {
				num *= 2;
				if(buf_[ptr_-1] == '+') ++num;
				else if(buf_[ptr_-1] == '-') --num;
				--ptr_;
			}
			if(num > 0) op = signedbase_<B>::op_add;
			else {
				op = signedbase_<B>::op_sub;
				num = -num;
			}
		}
		return true;
	}
};


// ===========================================================================
//  unsigned57_: unsigned 5bit window
template<class B>
class unsigned5_ {
public:
	// ----------------------------------------------------------------------
	//  flags
	enum {
		op_double = 0,
		op_add,
		ENUM_FORBIDS_EXTRA_COMMAS
	};
	
	// ----------------------------------------------------------------------
	//  ctor, dtor
	unsigned5_(b_<B> const& t) {
		bits_ = t.numBits();
		for(int i = 0; i < bits_; ++i) buf_[i] = static_cast<char>(t.isBitOn(i));
	}
	~unsigned5_() {}
	
	// ----------------------------------------------------------------------
	//  operations
	void begin() { ptr_ = bits_; op_ = op_add; }
	bool next_op(int& op, int& num) {
		if(!ptr_) return false;
		op = op_; op_ = op_add + op_double - op_;
		num = 0;
		while(ptr_ > 0 && !buf_[ptr_-1]) {
			++num;
			--ptr_;
		}
		int nbits = ptr_ > 5? 5: ptr_;
		while(nbits > 0 && !buf_[ptr_-nbits]) --nbits;
		if(op == op_double) num += nbits;
		else {
			num = 0;
			for(int i = 0; i < nbits; ++i) {
				num *= 2;
				if(buf_[ptr_-1]) ++num;
				--ptr_;
			}
		}
		return true;
	}
	
protected:
	int bits_, ptr_, op_;
	char buf_[B::SIZE_IN_BITS];
};

// ===========================================================================
//  end of namespace
}


#endif /* MTT_BITWINDOW_TMPL_H */
