#ifndef   MTT_ELLIPTIC_GENPOINT_TMPL_H
#define   MTT_ELLIPTIC_GENPOINT_TMPL_H

// ===========================================================================
//  elliptic_genpoint_tmpl.h -- ȉ~Ȑ̓_̎
// ---------------------------------------------------------------------------
// 
//  _̎͗Lׂ̂̂p邱ƂɂȂ̂ŕ
//  (c.f. elliptic_tmpl.h)


#include "types_tmpl.h"
#include "field_fq_power_tmpl.h"
#include "elliptic_power_tmpl.h"

namespace mttec {
#define Fq Fp
// ===========================================================================
//  genPoint : generate a point with x-coordinate equal to P.x or -P.x

template<class Fp, class Fm>
void power_<Fp, Fm>::genPoint(mttfq::power_<Fp, Fm>& F, ep_<Fq>& P)
{
	// w0 <- 4x^3 - 12x
	Fp *const wfq_ = ec_<Fp>::wfq_;
	wfq_[0] = P.x*P.x;
	wfq_[0] -=3; wfq_[0] += wfq_[0]; wfq_[0] += wfq_[0];
	wfq_[0] *= P.x;
	// set y
	F.sqrt(wfq_[0], P.y);
	// set x
	wfq_[0] -= P.y*P.y; wfq_[0].normalize();
	if(!wfq_[0].isZero()) P.x.negate();
	P.z = 1;
	P.affine = true;
}


// ===========================================================================
//  genPoint : generate a m-torsion point according to P.x
template<class Fp, class Fm>
void power_<Fp, Fm>::genMTorsionPoint(mttfq::power_<Fp, Fm>& F, ep_<Fq>& P)
{
	genPoint(F, P);
	pow(P, Fp::value_type::GetFactorCoM(), P);
}


// ===========================================================================
//  end of namespace
#undef Fq
}


#endif /* MTT_ELLIPTIC_GENPOINT_TMPL_H */
