#ifndef   MTT_ELLIPTIC_TMPL_H
#define   MTT_ELLIPTIC_TMPL_H

// ===========================================================================
//  elliptic_tmpl.h -- ȉ~Ȑ̉Z̎
// ---------------------------------------------------------------------------
// wI
//  ȉ~Ȑ y^2 = x^3 + x Ɠlȑȉ~Ȑ y^2 = 4x^3 - 12x ̏̉Z
// sȂBȉ~Ȑ̓_JacobiW[x:y:z]ŕ\킷Bʏ̍W(affine
// W)ł́A(x/z^2, y/z^3)ƕ\킳B_[1:2:0]łB
// 
// gp̐
//  ȉ~ȐNX ec_<T> ȉ~Ȑ̓_NX ep_<T> łBȉ~Ȑ
// ̃CX^X쐬ÃCX^X̊֐œ_m̉Z
// sȂBT͗L̂̃NXłB܂ÃNX͂̂܂
// pł͂ȂB
//  {Z̎͊܂܂ȂB{ZpƂ elliptic_power_tmpl.h
// #include邱ƁB


// ===========================================================================
//  use class mttfm::e_<T, E>, class mttfq::power_<T>
namespace mttfm {
template<class T, class E> class e_;
}
namespace mttfq {
template<class Mp, class Mm> class power_;
}

namespace mttec {
// ===========================================================================
//  ep_: point on an elliptic curve with Jacobi coordinate
template<class T>
struct ep_ {
	T x, y, z;
	bool affine;
};


// ===========================================================================
//  miller_: point P and value of f_P([Q]-[R])
template<class T>
struct miller_ : ep_<T> {
	T num, den;
	miller_ const& operator=(ep_<T>const& ep) {
		static_cast<ep_<T>&>(*this) = ep;
		return *this;
	}
};


// ===========================================================================
//  ec_: elliptic curve
template<class T>
class ec_ {
public:
	// ----------------------------------------------------------------------
	//  ctor, dtor   
	ec_() : i_(0, 1) {}
	~ec_() {}
	
	// ----------------------------------------------------------------------
	//  calculations
	void affinize(ep_<T>& d);
	void distort(ep_<T>const& s, ep_<T>& d);
	void dbl(ep_<T>const& s, ep_<T>& d);
	void add(ep_<T>const& s1, ep_<T>const& s2, ep_<T>& d);
	void sub(ep_<T>const& s1, ep_<T>const& s2, ep_<T>& d);
	bool equal(ep_<T>const& s1, ep_<T>const& s2);

	// ----------------------------------------------------------------------
	//  calculations(full tate pairing/ weil pairing)
	void setDivisor(ep_<T>const& Q, ep_<T>const& R);
	void dbl(miller_<T>const& s, miller_<T>& d);
	void add(miller_<T>const& s1, miller_<T>const& s2, miller_<T>& d);
	void sub(miller_<T>const& s1, miller_<T>const& s2, miller_<T>& d);

	// ----------------------------------------------------------------------
	//  calculations(fast tate pairing)
	void setPoint(ep_<T>const& Q);
	void dblFast(miller_<T>const& s, miller_<T>& d);
	void addFast(miller_<T>const& s1, miller_<T>const& s2, miller_<T>& d);
	void subFast(miller_<T>const& s1, miller_<T>const& s2, miller_<T>& d);
	
protected:
	T i_, wfq_[10];
	ep_<T> wep_[20];
};


// ---------------------------------------------------------------------------
//  affinize 
template<class T>
inline void ec_<T>::affinize(ep_<T>& d)
{
	if(d.affine) return;
	d.affine = true;
	d.z.normalize();
	if(d.z.isZero()) {
		d.x = 1;
		d.y = 2;
		return;
	}
	wfq_[0] = inverse(d.z);
//	wfq_[2] = wfq_[0] * (wfq_[1] = wfq_[0]*wfq_[0]);
	wfq_[1] = wfq_[0] * wfq_[0];
	wfq_[2] = wfq_[0] * wfq_[1];
	d.x *= wfq_[1];
	d.y *= wfq_[2];
	d.z  = 1;
}


// ---------------------------------------------------------------------------
//  distort
// (x, y) -> (-x, iy)
template<class T>
inline void ec_<T>::distort(ep_<T>const& s, ep_<T>& d)
{
	if(&s == &d) {
		d.x.negate();
		d.y *= i_;
	} else {
		d.x = -s.x;
		d.y = i_ * s.y;
		d.z = s.z;
		d.affine = s.affine;
	}
}


// ---------------------------------------------------------------------------
//  double a point: P_d = 2P_s
template<class T>
inline void ec_<T>::dbl(ep_<T>const& s, ep_<T>& d)
{
	// P_s == [0]
	s.z.normalize();
	if(s.z.isZero()) {
		if(&s != &d) d = s;
		return;
	}
	
	// 2P_s == [0]
	s.y.normalize();
	if(s.y.isZero()) {
		d.affine = true;
		d.x = 1;
		d.y = 2;
		d.z = 0;
		return;
	}
	d.affine = false;	

	// w0 <- lambda_n := 3(x^2 - z^4)
	if(s.affine) {
	   wfq_[1] = s.x*s.x;
	   wfq_[0] = -3 + wfq_[1] + (wfq_[1] + wfq_[1]);
	} else {
		wfq_[1] = s.z*s.z;
		wfq_[0] = (s.x + wfq_[1])*(s.x - wfq_[1]);
		wfq_[1] = wfq_[0] + wfq_[0];
		wfq_[0] += wfq_[1];
	}
	
	// w1 <- y^2,  w2 <- xy^2,  w3 <- lambda_n^2
//	wfq_[2] = s.x*(wfq_[1] = s.y*s.y);
	wfq_[1] = s.y * s.y;
	wfq_[2] = s.x * wfq_[1];
	wfq_[3] = wfq_[0]*wfq_[0];
	
	// Z <- yz,  X <- lambda_n^2 - 2xy^2, 
	d.z = s.affine? s.y: s.y*s.z;
//	d.x = wfq_[3] - (wfq_[2] + wfq_[2]);
	d.x = wfq_[3] - wfq_[2];
	d.x -= wfq_[2];
	
	// Y <- 2(3xy^2 - lambda_n^2)lambda_n - y^4
	d.y = (wfq_[2] - d.x)*wfq_[0];
	wfq_[1] *= wfq_[1];
	d.y += d.y - wfq_[1];
}


// ---------------------------------------------------------------------------
//  add points: P_d = P_s1 + P_s2
template<class T>
inline void ec_<T>::add(ep_<T>const& s1, ep_<T>const& s2, ep_<T>& d)
{
	// P_s1 is identical to P_s2
	if(&s1 == &s2) {
		dbl(s1, d);
		return;
	}
	
	// P_s1 == [0]
	s1.z.normalize();
	if(s1.z.isZero()) {
		if(&s2 != &d) d = s2;
		return;
	}
	
	// P_s2 == [0]
	s2.z.normalize();
	if(s2.z.isZero()) {
		if(&s1 != &d) d = s1;
		return;
	}
	
	// w2 <- lambda_d := x1 z2^2 - z1^2 x2
	// w3 <- lambda_n := y1 z2^3 - z1^3 y2
	// w0 <- mu_d	 := x1 z2^2 + z1^2 x2
	// w1 <- mu_n	 := y1 z2^3 + z1^3 y2
	if(s1.affine) {
		if(s2.affine) {
			wfq_[2] = s1.x - s2.x;
			wfq_[3] = s1.y - s2.y;
			wfq_[0] = s1.x + s2.x;
			wfq_[1] = s1.y + s2.y;
		} else {
//			wfq_[1]  = s2.z*(wfq_[0] = s2.z*s2.z);
			wfq_[0] = s2.z * s2.z;
			wfq_[1] = wfq_[0] * s2.z;
			wfq_[0] *= s1.x;
			wfq_[1] *= s1.y;
			wfq_[2]  = wfq_[0] - s2.x;
			wfq_[3]  = wfq_[1] - s2.y;
			wfq_[0] += s2.x;
			wfq_[1] += s2.y;
		}
	} else {
		// w0 <- z1^2 x2,  w1 <- z1^3 y2
//		wfq_[1] = s1.z*(wfq_[2] = s1.z*s1.z);
		wfq_[2] = s1.z * s1.z;
		wfq_[1] = wfq_[2] * s1.z;
		wfq_[0] = s2.x*wfq_[2];
		wfq_[1] *= s2.y;
		if(s2.affine) {
			wfq_[2]  = s1.x - wfq_[0];
			wfq_[0] += s1.x;
			wfq_[3]  = s1.y - wfq_[1];
			wfq_[1] += s1.y;
		} else {
//			wfq_[3]  = s2.z*(wfq_[2] = s2.z*s2.z);
			wfq_[2] = s2.z * s2.z;
			wfq_[3] = wfq_[2] * s2.z;
			wfq_[4]  = s1.x*wfq_[2];
			wfq_[2]  = wfq_[4] - wfq_[0];
			wfq_[0] += wfq_[4];
			wfq_[4]  = s1.y*wfq_[3];
			wfq_[3]  = wfq_[4] - wfq_[1];
			wfq_[1] += wfq_[4];
		}
	}
	
	// P_s1 == P_s2,  P_s1 == -P_s2
	wfq_[2].normalize();
	if(wfq_[2].isZero()) {
		wfq_[3].normalize();
		if(wfq_[3].isZero()) dbl(s1, d);
		else {
			d.affine = true;
			d.x = 1;
			d.y = 2;
			d.z = 0;
		}
		return;
	}
	d.affine = false;
	
	// w4 <- 2lambda_d,  Z <- 2z1 z2 lambda_d
	wfq_[4] = wfq_[2] + wfq_[2];
	if(s1.affine) d.z = s2.affine? wfq_[4]: s2.z*wfq_[4];
	else if(s2.affine) d.z = s1.z*wfq_[4];
	else d.z = s1.z*s2.z*wfq_[4];
	
	// w4 <- 4lambda_d^3,  w0 <- 4lambda_d^2 mu_d
	wfq_[4] *= wfq_[4];
	wfq_[0] *= wfq_[4];
	wfq_[4] *= wfq_[2];
	
	// X <- -4lambda_d^2 mu_d + lambda_n^2
	d.x = wfq_[3]*wfq_[3] - wfq_[0];
	
	// Y <- (w0 - 2X)w3 - w4*w1
	wfq_[0] -= d.x + d.x;
	d.y = wfq_[0]*wfq_[3] - wfq_[4]*wfq_[1];
}


// ---------------------------------------------------------------------------
//  subtract points: P_d = P_s1 - P_s2
template<class T>
inline void ec_<T>::sub(ep_<T>const& s1, ep_<T>const& s2, ep_<T>& d)
{
	// P_s1 is identical to P_s2
	if(&s1 == &s2) {
		d.affine = true;
		d.x = 1;
		d.y = 2;
		d.z = 0;
		return;
	}
	
	// P_s2 == [0]
	s2.z.normalize();
	if(s2.z.isZero()) {
		if(&s1 != &d) d = s1;
		return;
	}
	
	// P_s1 == [0]
	s1.z.normalize();
	if(s1.z.isZero()) {
		if(&s2 != &d) d = s2;
		d.y.negate();
		return;
	}
	
	// w2 <- lambda_d := x1 z2^2 - z1^2 x2
	// w3 <- lambda_n := y1 z2^3 - z1^3 (-y2)
	// w0 <- mu_d	 := x1 z2^2 + z1^2 x2
	// w1 <- mu_n	 := y1 z2^3 + z1^3 (-y2)
	if(s1.affine) {
		if(s2.affine) {
			wfq_[2] = s1.x - s2.x;
			wfq_[3] = s1.y + s2.y;
			wfq_[0] = s1.x + s2.x;
			wfq_[1] = s1.y - s2.y;
		} else {
//			wfq_[1]  = s2.z*(wfq_[0] = s2.z*s2.z);
			wfq_[0] = s2.z * s2.z;
			wfq_[1] = wfq_[0] * s2.z;
			wfq_[0] *= s1.x;
			wfq_[1] *= s1.y;
			wfq_[2]  = wfq_[0] - s2.x;
			wfq_[3]  = wfq_[1] + s2.y;
			wfq_[0] += s2.x;
			wfq_[1] -= s2.y;
		}
	} else {
		// w0 <- z1^2 x2,  w3 <- z1^3 y2
//		wfq_[3] = s1.z*(wfq_[2] = s1.z*s1.z);
		wfq_[2] = s1.z * s1.z;
		wfq_[3] = wfq_[2] * s1.z;
		wfq_[0] = s2.x*wfq_[2];
		wfq_[3] *= s2.y;
		if(s2.affine) {
			wfq_[2]  = s1.x - wfq_[0];
			wfq_[0] += s1.x;
			wfq_[1]  = s1.y - wfq_[3];
			wfq_[3] += s1.y;
		} else {
//			wfq_[1]  = s2.z*(wfq_[2] = s2.z*s2.z);
			wfq_[2] = s2.z * s2.z;
			wfq_[1] = wfq_[2] * s2.z;
			wfq_[4]  = s1.x*wfq_[2];
			wfq_[2]  = wfq_[4] - wfq_[0];
			wfq_[0] += wfq_[4];
			wfq_[4]  = s1.y*wfq_[1];
			wfq_[1]  = wfq_[4] - wfq_[3];
			wfq_[3] += wfq_[4];
		}
	}
	
	// P_s1 == -P_s2,  P_s1 == P_s2
	wfq_[2].normalize();
	if(wfq_[2].isZero()) {
		wfq_[3].normalize();
		if(wfq_[3].isZero()) dbl(s1, d);
		else {
			d.affine = true;
			d.x = 1;
			d.y = 2;
			d.z = 0;
		}
		return;
	}
	d.affine = false;
	
	// w4 <- 2lambda_d,  Z <- 2z1 z2 lambda_d
	wfq_[4] = wfq_[2] + wfq_[2];
	if(s1.affine) d.z = s2.affine? wfq_[4]: s2.z*wfq_[4];
	else if(s2.affine) d.z = s1.z*wfq_[4];
	else d.z = s1.z*s2.z*wfq_[4];
	
	// w4 <- 4lambda_d^3,  w0 <- 4lambda_d^2 mu_d
	wfq_[4] *= wfq_[4];
	wfq_[0] *= wfq_[4];
	wfq_[4] *= wfq_[2];
	
	// X <- -4lambda_d^2 mu_d + lambda_n^2
	d.x = wfq_[3]*wfq_[3] - wfq_[0];
	
	// Y <- (w0 - 2X)w3 - w4*w1
	wfq_[0] -= d.x + d.x;
	d.y = wfq_[0]*wfq_[3] - wfq_[4]*wfq_[1];
}


// ===========================================================================
//  end of namespace
}

#endif /* MTT_ELLIPTIC_TMPL_H */
