#ifndef   MTT_FIELD_FQ_POWER_TMPL_H
#define   MTT_FIELD_FQ_POWER_TMPL_H

// ===========================================================================
//  field_fq_power_tmpl.h -- LF_qׂ̂̎
// ---------------------------------------------------------------------------
// 
//  ׂ͕̎GɂȂ̂ŕ(c.f. field_fq_tmpl.h)
//  ȂǂŌvZ邱Ƃo


#include "types_tmpl.h"

namespace mttfq {
#define Fq Fp
// ===========================================================================
//  class power_: calucate power
template<class Fp, class Fm>
class power_ {
public:
	template<class Bits>
	void pow(Fq const& s, Bits const& e, Fq& d);
	void pow(Fq const& s, Fp const& e, Fq& d) {
		e.getR().getBits(expP_);
		pow(s, expP_, d);
	}
	void pow(Fq const& s, Fm const& e, Fq& d) {
		e.getR().getBits(expM_);
		pow(s, expM_, d);
	}
	
	// ----------------------------------------------------------------------
	//  sqrt: d = s^(1/2) actually d = s^((p+1)/4)
	void sqrt(Fq const& s, Fq& d) {
		pow(s, Fq::value_type::GetSqrtExp(), d);
	}
protected:
	Fq wfq_[20];
	typename Fp::value_type::Bits expP_;
	typename Fm::value_type::Bits expM_;
};


// ---------------------------------------------------------------------------
//  power: d = s^e(e != 0肷)
template<class Fp, class Fm>
template<class Bits>
void power_<Fp, Fm>::pow(Fq const& s, Bits const& b, Fq& d)
{
	typename MttWindow<Bits>::Exponent e(b);
	int mbits = e.numBits();
	if(1 == mbits) {
		if(e.isBitOn(0)) {
			if(&d != &s) d = s;
			return;
		}
		--mbits;
	}
	
	wfq_[0] = s;
	d = 1;
	if(0 == mbits) return;
	if(mbits > 12) {
		wfq_[16] = wfq_[0]*wfq_[0];
		for(int i = 0; i <15 ; ++i) wfq_[i+1] = wfq_[16]*wfq_[i];
		typename MttWindow<Bits>::Unsigned5 binary(e);
		binary.begin();
		int op = 0, num = 0;
		binary.next_op(op, num);
		while(op == binary.op_double) binary.next_op(op, num);
		d = wfq_[num/2];
		while(binary.next_op(op, num)) {
			if(op == binary.op_add) {
				d *= wfq_[num/2];
			} else {
				while(num--) d *= d;
			} 
		}
	} else {
		while(--mbits) {
			if(e.isBitOn(mbits)) d *= wfq_[0];
			d *= d;
		}
		if(e.isBitOn(mbits)) d *= wfq_[0];
	}
}

// ===========================================================================
//  end of namespace
#undef Fq
}

#endif /* MTT_FIELD_FQ_POWER_TMPL_H */
