#ifndef MIE_INNER_UTIL_H_
#define MIE_INNER_UTIL_H_

static inline dummyFm* _dummyFm(Fm *x) { return reinterpret_cast<dummyFm*>(x); }
static inline dummyFq* _dummyFq(Fq *x) { return reinterpret_cast<dummyFq*>(x); }
static inline dummyEm* _dummyEm(Em *x) { return reinterpret_cast<dummyEm*>(x); }
static inline const dummyFm* _dummyFm(const Fm *x) { return reinterpret_cast<const dummyFm*>(x); }
static inline const dummyFq* _dummyFq(const Fq *x) { return reinterpret_cast<const dummyFq*>(x); }
static inline const dummyEm* _dummyEm(const Em *x) { return reinterpret_cast<const dummyEm*>(x); }

static inline Fm* _Fm(dummyFm *x) { return reinterpret_cast<Fm*>(x); }
static inline Fq* _Fq(dummyFq *x) { return reinterpret_cast<Fq*>(x); }
static inline Em* _Em(dummyEm *x) { return reinterpret_cast<Em*>(x); }
static inline const Fm* _Fm(const dummyFm *x) { return reinterpret_cast<const Fm*>(x); }
static inline const Fq* _Fq(const dummyFq *x) { return reinterpret_cast<const Fq*>(x); }
static inline const Em* _Em(const dummyEm *x) { return reinterpret_cast<const Em*>(x); }

static inline dummyFm *newFm() { return _dummyFm(new Fm()); }
static inline dummyFq *newFq() { return _dummyFq(new Fq()); }
static inline dummyEm *newEm() { return _dummyEm(new Em()); }

void copyValue(dummyFm *lhs, const dummyFm *rhs)
{
	*_Fm(lhs) = *_Fm(rhs);
}
void copyValue(dummyFq *lhs, const dummyFq *rhs)
{
	*_Fq(lhs) = *_Fq(rhs);
}
void copyValue(dummyEm *lhs, const dummyEm *rhs)
{
	*_Em(lhs) = *_Em(rhs);
}
/*!
	dummyFm̍폜
*/
static inline void deleteFm(dummyFm **x)
{
	delete _Fm(*x);
	*x = 0;
}
/*!
	dummyEm̍폜
*/
static inline void deleteEm(dummyEm **x)
{
	delete _Em(*x);
	*x = 0;
}
/*!
	dummyFq̍폜
*/
static inline void deleteFq(dummyFq **x)
{
	delete _Fq(*x);
	*x = 0;
}


#endif /* MIE_INNER_UTIL_H_ */
