#ifndef   MTT_PAIRING_TMPL_H
#define   MTT_PAIRING_TMPL_H

// ===========================================================================
//  pairing_tmpl.h -- e pairing ̎
// ---------------------------------------------------------------------------
// 
//   milleř𗘗pAe pairing vZB
//  tateFast()͍o[W Tate pairingłAtate() fullo[W
//  Tate pairingłB


#include "types_tmpl.h"
#include "miller_tmpl.h"
#include "field_fq_power_tmpl.h"


namespace mttpair {
#define Fq Fp
// ===========================================================================
//  tate_fast : fast tate pairing
//   e = e(P, Q)
template<class Fp, class Fm>
void tateFast(mttec::power_<Fp, Fm>& E, mttfq::power_<Fp, Fm>& F,
	mttec::ep_<Fp>const& P, mttec::ep_<Fq>const& Q, Fq& e)
{
	// calculate miller formula
	mttec::miller_<Fp> fP;
	fP = P;
	fP.num = 1;
	E.setPoint(Q);
	E.powFast(fP, Fp::value_type::GetFactorM(), fP);
	
	// (p-1)*co_m th power
	e = inverse(fP.num);
	fP.num.frobenius();
	fP.num *= e;
	F.pow(fP.num, Fp::value_type::GetFactorCoM(), e);
}


// ===========================================================================
//  end of namespace
#undef Fq
}


#endif /* MTT_PAIRING_TMPL_H */

