#include "mtt_ext_if.h"
#include <vector>
#include <memory>

/*!
	@brief OC^tF[XeXgAv
	@file $RCSfile: testmain.cpp,v $
	@version $Revision: 1.3 $
	@date $Date: 2006/05/19 01:54:49 $
*/

using namespace std;
using namespace MTT;

#if defined(_MSC_VER)
	#if (_MSC_VER <= 1200)
		#define for if(0);else for
	#endif
#endif

/*!
	[U\
*/
void put(const UserInfo& info)
{
	if (info.isEmpty()) return;
	printf("name:%s\n", info.getName());
	printf("pass:%s\n", info.getPassword());
	printf("adj :%d\n", info.getAdj());
	printf("num :%s\n", info.getNumber());
}

/*!
	
*/
#define CAT(x, y) x ## y
void decode(UserKey *userKey, const char* header, char *name)
{
	bool isOK;
	char sessionKey[MAX_SESSION_KEY_SIZE];

	isOK = userKey->getSessionKey(sessionKey, header);
	if (isOK) {
		printf("%s's sessionKey=%s\n", name, sessionKey);
	} else {
		printf("%s's sessionKey is not effective\n", name);
	}
}

int main()
{
	bool isOK;
	UserInfo shigeo, dsk, kei;
	UserKey *shigeoKey, *dskKey, *keiKey;
	vector<UserKey*> revocationList;
	char sessionKey[MAX_SESSION_KEY_SIZE];

	MTT::init();
	SystemKeyGenerator *keyGenerator = new SystemKeyGenerator();

	keyGenerator->set("abc", 5);

	// 
	isOK = keyGenerator->save("test.mts");
	if (!isOK) {
		puts("save ERROR");
	}
#if 0
	isOK = keyGenerator->load("test.mts");
	if (!isOK) goto ERROR;
#endif

	// [Uݒ
	isOK = shigeo.set("Mitsunari Shigeo", "999", 0);
	if (!isOK) goto ERROR;
	puts("shigeo info"); put(shigeo);

	isOK = dsk.set("Watanabe Hudeyuki", "12345678", 0);
	if (!isOK) goto ERROR;
	puts("dsk info"); put(dsk);

	isOK = kei.set("Ishida Kei", "0909999333", 0);
	if (!isOK) goto ERROR;
	puts("kei info"); put(kei);

	// [U쐬
	shigeoKey = new UserKey();
	isOK = keyGenerator->createInstanceOfUserKey(shigeoKey, shigeo);
	if (!isOK) goto ERROR;
	isOK = shigeoKey->save("shigeo." MTT_USER_SUFFIX);
	if (!isOK) goto ERROR;

	dskKey = new UserKey();
	isOK = keyGenerator->createInstanceOfUserKey(dskKey, dsk);
	if (!isOK) goto ERROR;
	isOK = dskKey->save("dsk." MTT_USER_SUFFIX);
	if (!isOK) goto ERROR;

	keiKey = new UserKey();
	isOK = keyGenerator->createInstanceOfUserKey(keiKey, kei);
	if (!isOK) goto ERROR;
	isOK = keiKey->save("kei." MTT_USER_SUFFIX);
	if (!isOK) goto ERROR;

	// zM

	for (int i = 0; i < 3; i++) {
		auto_ptr<char> header(new char [keyGenerator->getMaxHeaderSize()]);
		const char seed[][20] = { "asdfvasd", "#)JRS#", "faevraz" };

		printf("Key distribution (%dtimes)\n", i + 1);
		if (i == 2) {
			printf("Revoke kei's private key.\n");
			revocationList.push_back(keiKey);
		}
		// [VXe]wb_ƃZNV쐬
		isOK = keyGenerator->createHeader(
			sessionKey, header.get(), seed[i],
			&revocationList[0], (int)revocationList.size());
		if (!isOK) goto ERROR;
		printf("system's sessionKey=%s\n", sessionKey);

		// [[U]wb_ZbV
		decode(shigeoKey, header.get(), "shigeo");

		// [[U]wb_ZbV
		decode(dskKey, header.get(), "   dsk");

		// [[U]wb_ZbV
		decode(keiKey, header.get(), "   kei");
	}

ERROR:
	puts(isOK ? "OK" : "ERROR");
	delete keyGenerator;

	return 0;
}
