#ifndef CIPHER_RIJNDAEL_H_
#define CIPHER_RIJNDAEL_H_

/*!
	RijndaelRecÍ/NXwb_
	@file cipher_rijndael.h
	@author $Author: shigeo $
	@version $Revision: 1.17 $
	@date $Date: 2007/08/30 02:09:07 $
*/

#if 0//#ifdef _MSC_VER
	#ifdef RIJNDAEL_DLL_EXPORT
		#define RIJNDAEL_DLL_DECL __declspec(dllexport)
	#else
		#define RIJNDAEL_DLL_DECL __declspec(dllimport)
	#endif
#else
	#define RIJNDAEL_DLL_DECL /*!< Windows DLLpexport錾 */
#endif

namespace MTT {

class RIJNDAEL_DLL_DECL CipherRijndael {
public:
	enum {
		BUFFER_SIZE = 4096, //!< xɏbyte
		KEY_LENGTH = 256,
		ENUM_FORBIDS_EXTRA_COMMAS
	};
	/*!
		RXgN^
	*/
	CipherRijndael()
		: keyInst_(0), cipherInst_(0), update_(0), padding_(0)
	{
	}
	/*!
		fXgN^
	*/
	~CipherRijndael();

	//! Í/[hI
	enum MODE {
		ENCODING, //!< Ís
		DECODING //!< s
	};
	/*!
		
		@param key [in] 閧(16i16/24/32)
		@param mode [in] Í/[h
		@param keyLength [in] (128/192/256)
		@param iv [in] IV(16i32)
	*/
	bool setup(const char *key, MODE mode, int keyLength = KEY_LENGTH, const char *iv = 0);

	/*!
		BUFFER_SIZẼf[^
		@param inData [in] ̓f[^
		@param inDataSize [in] ̓f[^(byte)
		@param outData [out] o̓f[^
		@return obyte
	*/
	int update(const char inData[BUFFER_SIZE], int inDataSize, char outData[BUFFER_SIZE]);

	/*!
		c̏
		@param inData [in] ̓f[^
		@param inDataSize [in] ̓f[^(byte)
		@param outData [out] o̓f[^
		@return obyte
	*/
	int padding(const char *inData, int inDataSize, char *outData);
private:
	void *keyInst_;
	void *cipherInst_;
	void *update_;
	void *padding_;
};

/*!
	RijndaelÍ̎s
	@param isEncode [in] ENCODINGȂÍ DECODINGȂ畜
	@param key [in] 閧(16i16/24/32)
	@param keyLength [in] (128/192/256)
	@param r [in] ǂݍݗpNX(istream)
	@param w [in] ݗpNX(ostream)
	@param iv [in] IV(16i32)
	@param update [in] Abvf[gpcallback
	@param update_arg [in] update()̑ɓn|C^
*/

template <class Tr, class Tw>
bool RIJNDAEL_do(
	CipherRijndael::MODE mode,
	const char* key,
	int keyLength,
	Tr& r,
	Tw& w,
	const char *iv = 0,
	void (*update)(void*, int) = 0,
	void *update_arg = 0
)
{
	CipherRijndael cipher;
	if (!cipher.setup(key, mode, keyLength, iv)) return false;

	bool isQuit = false;
	/*
		̍Ō̃ubN͑傫Ɋւ炸paddingĂяoȂ
		mȃt@CTCYvZłȂD
		ď+1]vɓǂݍ݂݂
		@note Ƃ悢@悤ȋC(\߃t@CTCYm邱ƂȂ)
	*/
	const int bufferSize = CipherRijndael::BUFFER_SIZE;
	char inBuf[bufferSize + 1];
	r.read(&inBuf[bufferSize], 1);
	if (r.eof()) return false;
	do {
		char outBuf[bufferSize + 16]; /* padding̕ő +16 */

		inBuf[0] = inBuf[bufferSize]; /* Ô擪ɃRs[ */
		r.read(&inBuf[1], bufferSize);
		int readSize = static_cast<int>(r.gcount());
		int writeSize;
		if (readSize < bufferSize) {
			/*
				ŏIȂpadding
			*/
			writeSize = cipher.padding(inBuf, readSize + 1, outBuf);
			if (writeSize < 0) {
//				return false;
				/*
					󌳃f[^bufferSize̔{̂ƂŌ+16paddingC
					ɊւĕG[ɂȂĂ܂
				*/
				writeSize = readSize + 1 - 16;
			}
			isQuit = true;
		} else {
			writeSize = cipher.update(inBuf, bufferSize, outBuf);
			if (writeSize != bufferSize) return false;
		}
		w.write(outBuf, writeSize);
		if (update) update(update_arg, writeSize);
	} while (!isQuit);
	return true;
}

} // end of namespace

#endif /* CIPHER_RIJNDAEL_H_ */
