#ifndef MIE_TIMECAPSULE_H_
#define MIE_TIMECAPSULE_H_

#include <ctime> // for time_t
#include <string>
/*!
	^CJvZÍW[C^tF[X
	@file mie_timecapsule.h
	@author $Author: shigeo $
	@version $Revision: 1.21 $
	@date $Date: 2007/08/28 09:43:21 $
*/

#if defined(_MSC_VER) && defined(_WINDLL)
	#ifdef MIE_TC_EXPORT
		#define MIE_TC_DECL __declspec(dllexport)
	#else
		#define MIE_TC_DECL __declspec(dllimport)
	#endif
	#define MIE_TC_CDECL __cdecl
#else
	#define MIE_TC_DECL /*!< Windows DLLpexport錾 */
	#define MIE_TC_CDECL /*!< Windows DLLpCC^tF[X錾 */
#endif

namespace MIE_TC {

/*!
	VXe
	@note xAPIĂяoȂƂĂKĂяoKv
	(GWɂstaticȕϐ̃fXgN^łĂ܂)
*/
void MIE_TC_DECL MIE_TC_CDECL init();

enum {
	debug = 0,
	MAX_KEY_SIZE = 1024 /*! ̍őo̓TCY */
};

/*!
	C^tF[X̂߂̕sS^(`͖)
*/
struct dummyFm; // Z/mZ
struct dummyFq; // (Z/mZ)^2
struct dummyEm; // E[m]

/*!
	JNX
	(P, xP)̑g
*/
class MIE_TC_DECL PublicKey {
private:
	dummyEm *P_;
	dummyEm *xP_;
	mutable std::string data_;

	void createThis();
	void deleteThis();
	PublicKey(const PublicKey&);
	PublicKey& operator=(const PublicKey&);
public:
	/*!
		RXgN^
	*/
	PublicKey()
		: P_(0)
		, xP_(0)
	{
		createThis();
	}

	/*!
		̎x(PrivateKeyĂ)Ƃ(P, xP)ݒ肷
		@param seed [in] 
		@param x [in] 閧
	*/
	bool init(const char *seed, const dummyFm *x);

	/*!
		fXgN^
	*/
	~PublicKey() { deleteThis(); }

	/*!
		t@Cۑ
		@param name [in] Jt@C
	*/
	bool save(const char *name) const;
	/*!
		t@CǍ
		@param name [in] Jt@C
	*/
	bool load(const char *name);

	/*! ANZbT */
	const dummyEm* getP() const { return P_; }
	/*! ANZbT */
	const dummyEm* getxP() const { return xP_; }

	/*!
		f[^̎擾
		@retval !0 Jւ̃|C^
		@retval 0 G[
		@note ŌNULŏI
	*/
	const char *get() const;

	/*!
		f[^̓Ǎ
		@param data [in] J
		@note data̍ŌNULŏIĂ邱
	*/
	bool set(const char *data);
};

/*!
	ǗNX
	YYYYMMDDhhmmss(14)ŕ\
	YYYY : 4
	MM   : (01`12)
	DD   : (01`31)
	hh   : (00`23)
	mm   : (00`59)
	ss   : b(00`59)
	@note {TZ=JST-9lĂȂ
	@note time_t͊ɂăTCYقȂ邱Ƃ̂ŎgȂ
	@note [b͂Ȃ

	bool set(std::time_t time)
	{
		const struct tm *tm = std::localtime(&time);
		if (tm == 0) return false;
		return std::strftime(data_, STR_LEN + 1, "%Y%m%d%H%M%S", tm) != 0;
	}
*/
class MIE_TC_DECL TimeInfo {
	enum {
		STR_LEN = 15
	};
	char data_[STR_LEN]; /*  */
public:
	/*!
		ݎɐݒ肷
	*/
	bool setNow();

	/*!
		𕶎Œڐݒ肷
		@param str [in] 14YYYYMMDDhhmmss(擪"time="Ŏn܂19ł悢)
		sȎ̓G[ɂȂ邩Kȓtɕϊ
	*/
	bool set(const char *str);

	/*!
		ݎ擾
	*/
	const char *get() const { return data_; }

	/*!
		
		@param rhs [in] rΏێ
	*/
	bool isEqualTo(const TimeInfo& rhs) const;
	/*!
		(܂܂Ȃ)
		@param rhs [in] rΏێ
		@param plusSec [in] ␳l(sec)
		@note thisrhs + plusSec(܂this > rhs + plusSec)Ȃtrue
		@note V傫
	*/
	bool isNewerThan(const TimeInfo& rhs, int plusSec = 0) const;
	/*!
		thisrhsߋ(܂this < rhs)Ȃtrue
		@param rhs [in] rΏێ
		@note V傫
	*/
	bool operator<(const TimeInfo& rhs) const
	{
		return rhs.isNewerThan(*this);
	}
};

/*!
	ꂽǗNX
*/
class MIE_TC_DECL SignedTimeInfo {
	friend class PrivateKey;
private:
	std::string data_;
public:
	/*!
		RXgN^
		@param str [in] Mf[^
	*/
	SignedTimeInfo(const char *str = 0);

	/*!
		oCif[^̐ݒ
		@param str [in] Mf[^
	*/
	bool set(const char *str);
	/*!
		oCif[^̎擾
	*/
	const char *get() const { return &data_[0]; }
	/*!
		̎擾
	*/
	bool getTimeInfo(TimeInfo *timeInfo) const;
};

/*!
	閧NX
*/
class MIE_TC_DECL PrivateKey {
private:
	dummyFm *x_;

	void createThis();
	void deleteThis();
	PrivateKey(const PrivateKey&);
	PrivateKey& operator=(const PrivateKey&);
public:
	/*!
		v̎łȂƂmF邩Ȃ̃[h
	*/
	enum Mode {
		DontVerifyTime, /*!< `FbNȂ */
		VerifyTime /*!< `FbN */
	};
	/*!
		RXgN^
	*/
	PrivateKey()
		: x_(0)
	{
		createThis();
	}

	/*!
		fXgN^
	*/
	~PrivateKey() { deleteThis(); }

	/*!
		x肵publicKey
		@param seed [in] ̎
		@param publicKey [out] J
	*/
	bool init(const char *seed, PublicKey *publicKey);

	/*!
		timeInfoɑ΂鏐𐶐
		@param signedTimeInfo [out] 
		@param timeInfo [in] 
		@param publicKey [in] J
		@param mode [in] s̎timeInfoÂ`FbN
	*/
	bool sign(SignedTimeInfo *signedTimeInfo, const TimeInfo& timeInfo, const PublicKey& publicKey, Mode mode = VerifyTime) const;
};

class EncodedSessionKey;
/*!
	ZbVNX
*/
class MIE_TC_DECL SessionKey {
	friend class EncodedSessionKey;
private:
	std::string data_;
public:
	/*!
		ZbVƈÍꂽZbV𐶐
		@param encodedSessionKey [out] ÍꂽZbV
		@param publicKey [in] J
		@param timeInfo [in] \
		@param seed [in] ̎
	*/
	bool init(EncodedSessionKey *encodedSessionKey, const PublicKey& publicKey, const TimeInfo& timeInfo, const char* seed);

	/*!
		\il擾(160O)
	*/
	const char *get() const;
};

/*!
	ÍꂽZbVNX
*/
class MIE_TC_DECL EncodedSessionKey {
	friend class SessionKey;
private:
	std::string data_;
public:
	/*!
		RXgN^
		@param str [in] ÍꂽRec̃wb_
	*/
	EncodedSessionKey(const char *str = 0);

	/*!
		oCif[^̐ݒ
		@param str [in] ÍꂽRec̃wb_
	*/
	bool set(const char *str);
	/*!
		oCif[^̎擾
	*/
	const char *get() const { return data_.c_str(); }
	/*!
		wb_Ɋ܂܂鎞̎擾
		@param timeInfo [out] 
	*/
	bool getTimeInfo(TimeInfo *timeInfo) const;
	/*!
		
		@param sessionKey [out] ZbV
		@param signedTimeInfo [in] 
		@param publicKey [in] J(0łȂΏ̌؂s)
	*/
	bool decode(SessionKey *sessionKey, const SignedTimeInfo& signedTimeInfo, const PublicKey *publicKey = 0) const;
};

} // end of namespace

#endif /* MIE_TIMECAPSULE_H_ */
