# common definition for Makefile

HAS_SSE2=true

UNAME=$(shell uname)
ifeq ($(findstring Linux, $(UNAME)), Linux)
	THIS_HOST=LINUX
	AFLAGS=-f elf -D__unix__ -i./$(ARCH)/
	AR=ar r
	AR_PREV_OBJS=
	STATIC_LINK = -static
else
  ifeq ($(findstring Darwin, $(UNAME)), Darwin)
	THIS_HOST=DARWIN
	AFLAGS=-f macho -DDARWIN -i./$(ARCH)/
	AR=libtool -static -o
	AR_PREV_OBJS=-s
	STATIC_LINK =
	ifneq ($(findstring i386, $(shell uname -a)), i386)
		HAS_SSE2=false
	endif
  else
	@echo "unknown OS"
  endif
endif

# for GNU c++
CXX = g++ -x c++
LD = g++
CP = cp -f
AS = nasm
MKDIR=mkdir -p
RM=rm -f
CFLAGS = -Wall -O3 -c -fomit-frame-pointer -D_FILE_OFFSET_BITS=64
LDFLAGS = -lm

ifneq ($(HAS_SSE2), true)
	CFLAGS += -DMTT_DONT_USE_IA32ASM
endif

