/*!
	@brief RijndaelRecÍ/NX
	@file $RCSfile: cipher_rijndael.cpp,v $
	@version $Revision: 1.10 $
	@date $Date: 2007/08/30 02:09:07 $
	@note TvȂ̂initial vectorȂ, ECB[h
*/
#define RIJNDAEL_DLL_EXPORT
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cipher_rijndael.h"
#include "rijndael-api-fst.h"

#ifndef NDEBUG
static int debug = 1;
#else
static int debug = 0;
#endif

using namespace MTT;

bool CipherRijndael::setup(const char *key, MODE mode, int keyLength, const char *iv)
{
	int dir_mode;
	switch (mode) {
	case ENCODING:
		dir_mode = DIR_ENCRYPT;
		break;
	case DECODING:
		dir_mode = DIR_DECRYPT;
		break;
	default:
		return false;
	}

	// `FbN
	if (keyLength != 128 && keyLength != 192 && keyLength != 256) {
		return false;
	}

	int ret;
	keyInstance *keyInst = (keyInstance*)calloc(1, sizeof(keyInstance));
	cipherInstance *cipherInst = (cipherInstance*)calloc(1, sizeof(cipherInstance));

	update_ = (void *)((mode == ENCODING) ? blockEncrypt : blockDecrypt);
	padding_ = (void *)((mode == ENCODING) ? padEncrypt : padDecrypt);

	char keyBuf[256];

	// 
	size_t len;
	len = strlen(key);
	if (len > sizeof(keyBuf)) len = sizeof(keyBuf);
	memcpy(keyBuf, key, len);
	memset(&keyBuf[len], '0', sizeof(keyBuf) - len);

	ret = makeKey(keyInst, dir_mode, keyLength, keyBuf);
	if (ret != 1) {
		if (debug) fprintf(stderr, "makeKey error\n");
		return false;
	}

	// 
	ret = cipherInit(cipherInst, MODE_CBC, iv ? iv : "1234567894320f4eab32f37529324872");
	if (ret != 1) {
		if (debug) fprintf(stderr, "cipherInit error %d\n", ret);
		return false;
	}
	keyInst_ = (void *)keyInst;
	cipherInst_ = (void *)cipherInst;
	return true;
}

CipherRijndael::~CipherRijndael()
{
	free((keyInstance*)keyInst_);
	free((cipherInstance*)cipherInst_);
}
/*!
	BUFFER_SIZẼf[^
	@param inData [in] ̓f[^
	@param inDataSize [in] ̓f[^(byte)
	@param outData [out] o̓f[^
*/
int CipherRijndael::update(const char inData[BUFFER_SIZE], int inDataSize, char outData[BUFFER_SIZE])
{
	keyInstance *keyInst = (keyInstance*)keyInst_;
	cipherInstance *cipherInst = (cipherInstance*)cipherInst_;

	const int (*update)(cipherInstance *, const keyInstance *, const char *, int, char *)
		= (const int (*)(cipherInstance *, const keyInstance *, const char *, int, char *))update_;

	return update(cipherInst, keyInst, inData, inDataSize * 8, outData) / 8;
}

/*!
	c̏
	@param inData [in] ̓f[^
	@param inDataSize [in] ̓f[^(byte)
	@param outData [out] o̓f[^
	@return obyte
*/
int CipherRijndael::padding(const char *inData, int inDataSize, char *outData)
{
	keyInstance *keyInst = (keyInstance*)keyInst_;
	cipherInstance *cipherInst = (cipherInstance*)cipherInst_;

	const int (*padding)(cipherInstance *, const keyInstance *, const char *, int, char *)
		= (const int (*)(cipherInstance *, const keyInstance *, const char *, int, char *))padding_;

	return padding(cipherInst, keyInst, inData, inDataSize, outData);
}
