/*!
	@brief RijndaeleXg
	@file $RCSfile: testmain.cpp,v $
	@version $Revision: 1.8 $
	@date $Date: 2007/08/30 02:09:07 $
*/
#include <stdio.h>
#include <stdlib.h>
#include "cipher_rijndael.h"
#include <sstream>

using namespace MTT;

void test(const std::string msg, std::string key, int keyLen, std::string iv)
{
	std::istringstream is(msg);
	std::ostringstream enc;
	RIJNDAEL_do(CipherRijndael::ENCODING, key.c_str(), keyLen, is, enc, iv.c_str());
	std::istringstream es(enc.str());
	std::ostringstream os;
	RIJNDAEL_do(CipherRijndael::DECODING, key.c_str(), keyLen, es, os, iv.c_str());
	printf("msg %s, keyLen=%d\n", msg.c_str(), keyLen);
	if (msg == os.str()) {
		printf("ok\n");
	} else {
		printf("err %s\n", os.str().c_str());
	}
}

#ifndef NUM_OF_ARRAY
	#define NUM_OF_ARRAY(x) (sizeof(x) / sizeof(*x))
#endif

int main(int argc, char *argv[])
{
	std::string msgTbl[] = {
		"abc",
		"This is a pen.",
		"doremifadondon yamanonaka"
	};
	for (size_t i = 0; i < NUM_OF_ARRAY(msgTbl); i++) {
		std::string key = "1234567123412341234123412413765287";
		int keyLenTbl[] = { 128, 192, 256 };
		for (size_t j = 0; j < NUM_OF_ARRAY(keyLenTbl); j++) {
			int keyLen = keyLenTbl[j];
			std::string iv = "12345678901234567890123456789012";
			test(msgTbl[i], key, keyLen, iv);
		}
	}
	return 0;
}
